//
//  Macros.h
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/13.
//

#ifndef Macros_h
#define Macros_h

#define kApplication        [UIApplication sharedApplication]
#define kAppWindow          [UIApplication sharedApplication].delegate.window
#define kRootViewController [UIApplication sharedApplication].delegate.window.rootViewController
#define kUserDefaults       [NSUserDefaults standardUserDefaults]
#define kNotificationCenter [NSNotificationCenter defaultCenter]
#define kAppDelegate        [AppDelegate sharedAppDelegate]
#define KMainUrl @"http://49.51.95.97"
#define KUploadMainUrl @""
#define KHtmlUrl @""
#define KAppStoreID @""
#define KKeFuPhone @""
#define AlipayScheme  @"alipayyshapp"

#define kStatusBarHeight [[UIApplication sharedApplication] statusBarFrame].size.height
#define kIsiPhoneX ([[UIApplication sharedApplication] statusBarFrame].size.height > 20 ? YES : NO)
#define kNavBarHeight 44.0
#define kTabBarHeight ([[UIApplication sharedApplication] statusBarFrame].size.height>20?83:49)
#define kTopHeight (kStatusBarHeight + kNavBarHeight)
// home indicator
#define HOME_INDICATOR_HEIGHT (kIsiPhoneX ? 34.f : 0.f)

#define ORDER_PAY_NOTIFICATION  @"payForResult"
#define kIfAgreeProtocol @"userIfAgreeProtocol"
//////////// 版本 /////////////
#define kSYSTEM_VERSION [[[UIDevice currentDevice] systemVersion] floatValue]
#define kAPP_BUILD_VERSION [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleVersion"]
#define kAPP_VERSION [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"]

// 读取本地图片 性能更高
#define kLOAD_LOCAL_IMAGE(file, ext) [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:file ofType:ext]]

#define kAvatarPlaceHolderImg [UIImage imageNamed:@"头像占位"]
#define kPlaceHolderImg [UIImage imageNamed:@"占位图"]

// rgb颜色转换（16进制->10进制）
#define kUIColorFromRGB(rgbValue) [UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 green:((float)((rgbValue & 0xFF00) >> 8))/255.0 blue:((float)(rgbValue & 0xFF))/255.0 alpha:1.0]
// 设置颜色RGB
#define kCOLOR(R, G, B, A) [UIColor colorWithRed:R/255.0 green:G/255.0 blue:B/255.0 alpha:A]

#define kGrayTextColor kCOLOR(158, 164, 176, 1)
//#define kRedTextColor  kCOLOR(224, 57, 44, 1)
#define kRedTextColor  [UIColor colorWithHexString:@"#E61743"]
/** 随机色 */
#define kRANDOM_COLOR [UIColor colorWithHue:(arc4random() % 255 / 255.0f) saturation:(arc4random() % 255 / 255.0f) brightness:(arc4random() % 255 / 255.0f) alpha:1]


#define kLightGrayTextColor [UIColor colorWithHexString:@"#AAAAAA"]
#define kMainThemeColor [UIColor colorWithHexString:@"#E60000"]
#define kMainTextColor  [UIColor colorWithHexString:@"#333333"]
#define kNormalLineColor kCOLOR(249, 248, 248, 1)
#define kNavColor [UIColor colorWithHexString:@"#031F12"]
#define kColorWithHex(hexstr) [UIColor colorWithHexString:hexstr]

//常规字体
#define REGULARFONT(FONTSIZE)    [UIFont fontWithName:@"PingFangSC-Regular" size:FONTSIZE]
//中间字体
#define MEDIUMFONT(FONTSIZE)    [UIFont fontWithName:@"PingFangSC-Medium" size:FONTSIZE]
//加粗字体
#define SEMIBOLDFONT(FONTSIZE)    [UIFont fontWithName:@"PingFangSC-Semibold" size:FONTSIZE]


// 字体适配 (4,5,6为同一个字号, 6p为 1.2倍)
#define IsIphone6P          [UIScreen mainScreen].bounds.size.width==414
#define SizeScale           (IsIphone6P ? 1.2 : 1)
#define kFontSize(value)    value*SizeScale
#define kScaleFont(value)        [UIFont systemFontOfSize:value*SizeScale]
#define kBoldScaleFont(value)  [UIFont boldSystemFontOfSize:value*SizeScale]
#define KWidth(value)        value*SizeScale

#define kDefaultDataBasePath [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES)[0] stringByAppendingString:@"/WHCSqlite/"]

//判断字符串是否为空
#define KisNull(string) [BaseFunction isNull:string]
//字符串为空则返回@""
#define KStringIsNull(string) [BaseFunction stringIsNull:string]

#define kStringFormat(format,...) [NSString stringWithFormat:format,##__VA_ARGS__]

#define kPageSize 8

//-------------------打印日志-------------------------
//DEBUG  模式下打印日志,当前行
#ifdef DEBUG
#define KLog(format, ...) printf("class: <%s:(%d) > method: %s \n%s\n",[[[NSString stringWithUTF8String:__FILE__] lastPathComponent] UTF8String], __LINE__, __PRETTY_FUNCTION__, [[NSString stringWithFormat:(format), ##__VA_ARGS__] UTF8String] )
#else
#define KLog(format, ...)
#endif


#endif /* Macros_h */
