//
//  BC_ExecuteViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/13.
//

#import "BC_ExecuteViewController.h"
#import "BC_ExecuteSubListViewController.h"
#import "BC_CreateProjectViewController.h"

#import <JXCategoryView.h>
@interface BC_ExecuteViewController ()<JXCategoryViewDelegate, JXCategoryListContainerViewDelegate>
@property (nonatomic, strong) JXCategoryTitleView *categoryView;
@property (nonatomic, strong) JXCategoryListContainerView *listContainerView;

@end

@implementation BC_ExecuteViewController
- (void)dealloc {
    KLog(@"BC_ExecuteViewController dealloc");
    [kNotificationCenter removeObserver:self];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Project record";
    self.isShowLeftBackBtn = NO;
    
//    UIBarButtonItem *item = [[UIBarButtonItem alloc] initWithImage:[[UIImage imageNamed:@"我的房产-增加"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal]  style:UIBarButtonItemStylePlain target:self action:@selector(addAction)];
//    self.navigationItem.rightBarButtonItem = item;
    
    [kNotificationCenter addObserver:self selector:@selector(updatePageState) name:@"refreshProDetailAfterEva" object:nil];
    [kNotificationCenter addObserver:self selector:@selector(updatePageState) name:@"finishProjectEva" object:nil];
    [self setupUI];
}

- (void)updatePageState {
    [self.categoryView reloadData];
}

- (void)setupUI {
    self.categoryView = [[JXCategoryTitleView alloc] initWithFrame:CGRectMake(15, 5, kScreenWidth - 30, 40)];
    self.categoryView.delegate = self;
    self.categoryView.backgroundColor = kColorWithHex(@"#F5F5F5");
    self.categoryView.cellSpacing = 0;
    self.categoryView.titleColor = kMainTextColor;
    self.categoryView.titleSelectedColor = UIColor.whiteColor;
    self.categoryView.titleFont = REGULARFONT(15);
    self.categoryView.titleSelectedFont = REGULARFONT(15);
    self.categoryView.defaultSelectedIndex = 0;
    self.categoryView.titleColorGradientEnabled = YES;
    self.categoryView.averageCellSpacingEnabled = YES;
    self.categoryView.titles = @[@"Published", @"Process", @"Completed"];
    self.categoryView.cellWidth = (kScreenWidth - 30)/3;
    self.categoryView.layer.masksToBounds = YES;
    self.categoryView.layer.cornerRadius = 20;
    
    JXCategoryIndicatorBackgroundView *backgroundView = [[JXCategoryIndicatorBackgroundView alloc] init];
    backgroundView.indicatorWidth = (kScreenWidth - 30)/3-10;
    backgroundView.indicatorHeight = 36;
    backgroundView.indicatorCornerRadius = 18;
    backgroundView.indicatorColor = kMainThemeColor;
    [backgroundView setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 0) radius:8];
//    backgroundView.indicatorWidthIncrement = 60;
    self.categoryView.indicators = @[backgroundView];
    [self.view addSubview:self.categoryView];
    
    self.listContainerView = [[JXCategoryListContainerView alloc] initWithType:JXCategoryListContainerType_ScrollView delegate:self];
    self.listContainerView.frame = CGRectMake(0, 50, kScreenWidth, kScreenHeight - kTopHeight - 50 - kTabBarHeight);
    [self.view addSubview:self.listContainerView];
    self.categoryView.listContainer = self.listContainerView;
    
    UIButton *pubBtn = [JLFactoryUtil buttonWithImage:@"发布帖子"];
    [pubBtn addTarget:self action:@selector(addAction) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:pubBtn];
    [pubBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.view.mas_right).offset(-5);
        make.bottom.equalTo(self.view.mas_bottom).offset(-kTabBarHeight - 150);
        make.size.mas_equalTo(CGSizeMake(90, 90));
    }];
}

#pragma mark - JXCategoryViewDelegate
- (id<JXCategoryListContentViewDelegate>)listContainerView:(JXCategoryListContainerView *)listContainerView initListForIndex:(NSInteger)index {
    BC_ExecuteSubListViewController *list = [BC_ExecuteSubListViewController new];
    list.index = index;
    return list;
}

- (NSInteger)numberOfListsInlistContainerView:(JXCategoryListContainerView *)listContainerView {
    return 3;
}

#pragma mark  添加项目
- (void)addAction {
    BC_CreateProjectViewController *create = [BC_CreateProjectViewController new];
    [self.navigationController pushViewController:create animated:YES];
}

@end
