//
//  BC_CreateProjectViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/22.
//

#import "BC_CreateProjectViewController.h"
#import "BC_CreateProjectSuccViewController.h"
#import "BRAddressPickerView.h"
@interface BC_CreateProjectViewController ()
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;
@property (nonatomic, strong) UILabel *cateL;
@property (nonatomic, strong) UITextField *pname;
@property (nonatomic, strong) YYTextView *descTV;
@property (nonatomic, strong) UITextField *locationL;
@property (nonatomic, strong) UITextField *addressTF;

@property (nonatomic, strong) NSMutableArray *areaArr;
@property (nonatomic, strong) NSMutableArray *cateArr;

@property (nonatomic, copy) NSString *selectCateID;
@property (nonatomic, copy) NSString *selectCate;
@property (nonatomic, copy) NSString *selectCityID;
@property (nonatomic, strong) BRAddressPickerView *areaPicker;
@end

@implementation BC_CreateProjectViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.    
    self.isHidenNaviBar = YES;
    self.selectCityID = @"";
    self.selectCate = @"";
    self.selectCateID = @"";
    self.areaArr = [NSMutableArray array];
    self.cateArr = [NSMutableArray array];
    [self setupUI];
    [self getCityList];
    [self getCateList];
}

- (void)setupUI {
    UIView *topNav = [JLFactoryUtil view];
    topNav.frame = CGRectMake(0, 0, kScreenWidth, kTopHeight);
    topNav.backgroundColor = UIColor.whiteColor;
    [self.view addSubview:topNav];
    
    UILabel *navL = [JLFactoryUtil labelWithText:@"New Project" font:MEDIUMFONT(26) textColor:kMainTextColor];
    [topNav addSubview:navL];
    [navL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(topNav.mas_left).offset(15);
        make.bottom.equalTo(topNav.mas_bottom).offset(-5);
    }];
    
    UIButton *closeBtn = [JLFactoryUtil buttonWithImage:@"关闭icon"];
    [closeBtn addTarget:self action:@selector(backBtnClicked) forControlEvents:UIControlEventTouchUpInside];
    [topNav addSubview:closeBtn];
    [closeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(navL);
        make.right.equalTo(topNav.mas_right).offset(-15);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, kTopHeight, kScreenWidth, kScreenHeight - kTopHeight - HOME_INDICATOR_HEIGHT - 60)];
    self.scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:self.scrollView];
    
    self.contentView = [UIView new];
    self.contentView.backgroundColor = [UIColor whiteColor];
    [self.scrollView addSubview:self.contentView];
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.scrollView);
        make.width.equalTo(self.scrollView);
    }];
    
    self.cateL = [JLFactoryUtil labelWithText:KStringIsNull(self.selectCate) font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:self.cateL];
    [self.cateL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
    }];
    
    UIImageView *arrow1 = [JLFactoryUtil imageViewWithImg:@"更多"];
    [self.contentView addSubview:arrow1];
    [arrow1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(self.cateL);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    UIView *line1 = [JLFactoryUtil view];
    line1.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line1];
    [line1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.cateL.mas_bottom).offset(15);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UIView *cateClear = [JLFactoryUtil view];
    cateClear.backgroundColor = UIColor.clearColor;
    [self.contentView addSubview:cateClear];
    [cateClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.centerY.equalTo(self.cateL);
        make.height.mas_equalTo(35);
    }];
    UITapGestureRecognizer *tapCate = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(showCateView)];
    [cateClear addGestureRecognizer:tapCate];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Project name" font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line1.mas_bottom).offset(15);
    }];
    
    self.pname = [JLFactoryUtil textFieldWithFont:REGULARFONT(14) place:@"Fill in the title"];
    self.pname.textColor = kMainTextColor;
    [self.contentView addSubview:self.pname];
    [self.pname mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(10);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.height.mas_equalTo(30);
    }];
    
    UIView *line2 = [JLFactoryUtil view];
    line2.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line2];
    [line2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.pname.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Describe" font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line2.mas_bottom).offset(15);
    }];
    
    UIView *tvview = [JLFactoryUtil view];
    tvview.backgroundColor = kColorWithHex(@"#F5F5F5");
    [tvview setCorner:4 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:tvview];
    [tvview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label2.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 120));
    }];
    
    self.descTV = [YYTextView new];
    self.descTV.placeholderFont = REGULARFONT(14);
    self.descTV.placeholderText = @"Add text";
    self.descTV.placeholderTextColor = kLightGrayTextColor;
    self.descTV.textColor = kMainTextColor;
    self.descTV.font = REGULARFONT(14);
    [tvview addSubview:self.descTV];
    [self.descTV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(tvview).insets(UIEdgeInsetsMake(10, 10, 10, 10));
    }];
    
    UIView *line3 = [JLFactoryUtil view];
    line3.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line3];
    [line3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(tvview.mas_bottom).offset(20);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UIView *line4 = [JLFactoryUtil view];
    line4.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line4];
    [line4 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line3.mas_bottom).offset(55);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UIImageView *locImg = [JLFactoryUtil imageViewWithImg:@"位置"];
    [self.contentView addSubview:locImg];
    [locImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line3.mas_bottom).offset(16);
        make.size.mas_equalTo(CGSizeMake(22, 22));
    }];
    
    self.locationL = [JLFactoryUtil textFieldWithFont:REGULARFONT(15) place:@"location"];
    self.locationL.enabled = NO;
    self.locationL.textColor = kColorWithHex(@"#05A833");
    [self.contentView addSubview:self.locationL];
    [self.locationL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(locImg);
        make.left.equalTo(locImg.mas_right).offset(15);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.height.mas_equalTo(35);
    }];
    
    UIView *locClear = [JLFactoryUtil view];
    locClear.backgroundColor = UIColor.clearColor;
    [self.contentView addSubview:locClear];
    [locClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.centerY.equalTo(locImg);
        make.height.mas_equalTo(40);
    }];
    UITapGestureRecognizer *taplocClear = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseLocation)];
    [locClear addGestureRecognizer:taplocClear];
    
    UIView *line5 = [JLFactoryUtil view];
    line5.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line5];
    [line5 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line4.mas_bottom).offset(55);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    self.addressTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(14) place:@"Please enter your full address"];
    self.addressTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.addressTF];
    [self.addressTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(line5.mas_top).offset(-10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 35));
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(line5.mas_bottom).offset(20);
    }];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT-6);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
}

- (void)chooseLocation {
    if (self.areaArr.count == 0) return;
    [self.view endEditing:YES];
    [self.areaPicker show];
}

#pragma mark  选择分类
- (void)showCateView {
    
    if (self.cateArr.count == 0) {
        [self getCateList];
        return;
    }
    
    UIView *contentView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, 230)];
    contentView.backgroundColor = UIColor.whiteColor;
    
    UIScrollView *scrollView = [[UIScrollView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, 230)];
    scrollView.showsVerticalScrollIndicator = NO;
    [contentView addSubview:scrollView];
    
    UIView *bgview = [JLFactoryUtil view];
    bgview.backgroundColor = [UIColor whiteColor];
    [scrollView addSubview:bgview];
    [bgview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(scrollView);
        make.width.equalTo(scrollView);
    }];

    NSMutableArray *temp = [NSMutableArray array];
    for (int i = 0; i < self.cateArr.count; i++) {
        NSDictionary *dic = self.cateArr[i];
        UILabel *label1 = [JLFactoryUtil labelWithText:KStringIsNull(dic[@"name"]) font:REGULARFONT(16) textColor:kMainTextColor];
        label1.numberOfLines = 0;
        [bgview addSubview:label1];
        [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(bgview.mas_left).offset(15);
            make.top.equalTo(bgview.mas_top).offset(20 + 60 * i);
            make.right.lessThanOrEqualTo(bgview.mas_right).offset(-60);
        }];
        
        UIView *hline1 = [UIView new];
        hline1.backgroundColor = kColorWithHex(@"#F5F5F5");
        [bgview addSubview:hline1];
        [hline1 mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(bgview.mas_left).offset(15);
            make.top.equalTo(label1.mas_bottom).offset(20);
            make.height.mas_equalTo(1);
            make.width.mas_equalTo(kScreenWidth - 30);
        }];
        
        [temp addObject:hline1];
                
        UIView *cateClear1 = [JLFactoryUtil view];
        cateClear1.tag = 200+i;
        cateClear1.backgroundColor = UIColor.clearColor;
        [bgview addSubview:cateClear1];
        [cateClear1 mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(bgview);
            make.width.mas_equalTo(kScreenWidth);
            make.top.equalTo(label1.mas_top).offset(-10);
            make.bottom.equalTo(hline1.mas_top);
        }];
        UITapGestureRecognizer *tapCate1 = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseCate:)];
        [cateClear1 addGestureRecognizer:tapCate1];
        
        if ([KStringIsNull(self.selectCate) isEqualToString:KStringIsNull(dic[@"name"])]) {
            label1.textColor = kMainThemeColor;
            UIImageView *duihao = [JLFactoryUtil imageViewWithImg:@"对号icon"];
            [bgview addSubview:duihao];
            [duihao mas_makeConstraints:^(MASConstraintMaker *make) {
                make.centerY.equalTo(label1);
                make.right.equalTo(bgview.mas_right).offset(-15);
                make.size.mas_equalTo(CGSizeMake(22, 22));
            }];
        }
        
    }
    
    UIView *line = temp.lastObject;
    [bgview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(line.mas_bottom).offset(10);
    }];
    
    KLCPopupLayout layout = KLCPopupLayoutMake(KLCPopupHorizontalLayoutCenter, KLCPopupVerticalLayoutBottom);
    KLCPopup *popup = [KLCPopup popupWithContentView:contentView showType:KLCPopupShowTypeSlideInFromBottom dismissType:KLCPopupDismissTypeSlideOutToBottom maskType:KLCPopupMaskTypeDimmed dismissOnBackgroundTouch:YES dismissOnContentTouch:NO];
    [popup showWithLayout:layout];
    
}

- (void)chooseCate:(UIGestureRecognizer *)sender {
    [[sender view] dismissPresentingPopup];
    NSInteger tag = [sender view].tag-200;
    NSDictionary *dic = self.cateArr[tag];
    self.selectCate = KStringIsNull(dic[@"name"]);
    self.selectCateID = KStringIsNull(dic[@"id"]);
    self.cateL.text = self.selectCate;
}

- (void)getCateList {
    [self.cateArr removeAllObjects];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getservicetypelist/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSArray *arr = (NSArray *)dataDic[@"data"];
            [self.cateArr addObjectsFromArray:arr];
            if (self.cateArr.count > 0) {
                NSDictionary *dic = self.cateArr[0];
                self.selectCate = KStringIsNull(dic[@"name"]);
                self.selectCateID = KStringIsNull(dic[@"id"]);
                self.cateL.text = self.selectCate;
            }
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
    }];
}

- (void)getCityList {
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getprovinceareaslist/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSArray *arr = (NSArray *)dataDic[@"data"];
            NSMutableArray *dataSource = [NSMutableArray array];

            [arr enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
                NSDictionary *pdic = arr[idx];
                NSMutableArray *cityModelArr = [NSMutableArray array];
                NSArray *cityArr = (NSArray *)pdic[@"childlist"];
                [cityArr enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx1, BOOL * _Nonnull stop) {
                    NSDictionary *adic = cityArr[idx1];
                    BRCityModel *cmodel = [BRCityModel new];
                    cmodel.name = adic[@"name"];
                    cmodel.code = adic[@"id"];
                    cmodel.index = idx1;
                    [cityModelArr addObject:cmodel];
                }];
                BRProvinceModel *model = [BRProvinceModel new];
                model.name = pdic[@"name"];
                model.citylist = cityModelArr;
                model.code = pdic[@"id"];
                model.index = idx;
                [dataSource addObject:model];
            }];

            [self.areaArr removeAllObjects];
            [self.areaArr addObjectsFromArray:dataSource];
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

#pragma mark  提交
- (void)submitBtnClick {
    
    if ([KStringIsNull(self.selectCateID) isEqualToString:@""] || [KStringIsNull(self.pname.text) isEqualToString:@""] || [KStringIsNull(self.descTV.text) isEqualToString:@""] || [KStringIsNull(self.locationL.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please complete info"];
        return;
    }
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programadd/", KMainUrl];
    NSDictionary *para = @{@"name":KStringIsNull(self.pname.text), @"place":KStringIsNull(self.addressTF.text), @"city":KStringIsNull(self.selectCityID), @"service_type":KStringIsNull(self.selectCateID), @"desc":KStringIsNull(self.descTV.text)};
    KLog(@"发布项目====%@", para);
    [PPNetworkHelper POST:url parameters:para success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [self.navigationController pushViewController:[BC_CreateProjectSuccViewController new] animated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (BRAddressPickerView *)areaPicker {
    if (!_areaPicker) {
        _areaPicker = [[BRAddressPickerView alloc] initWithPickerMode:BRAddressPickerModeCity];
        _areaPicker.dataSourceArr = self.areaArr;
        @weakify(self);
        _areaPicker.resultBlock = ^(BRProvinceModel * _Nullable province, BRCityModel * _Nullable city, BRAreaModel * _Nullable area) {
            @strongify(self);
            self.locationL.text = kStringFormat(@"%@ %@", KStringIsNull(province.name), KStringIsNull(city.name));
            self.selectCityID = KStringIsNull(city.code);
        };
    }
    return _areaPicker;
}
@end
