//
//  BC_ProjectDetailViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/21.
//

#import "BC_ProjectDetailViewController.h"
#import "BC_ProjectInformationViewController.h"
#import "BC_ProjectRateViewController.h"
#import "BC_GroupChatViewController.h"

#import "BC_ProjectDetailPicCollectionViewCell.h"
#import "ZlinkPhotoBrowserView.h"

#import "BC_ExecuteModuleModel.h"
#import "TUIChatConversationModel.h"

@interface BC_ProjectDetailViewController ()<UICollectionViewDelegate, UICollectionViewDataSource>
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;

@property (nonatomic, strong) UILabel *timeL;
@property (nonatomic, strong) UILabel *cateL;
@property (nonatomic, strong) UILabel *nameL;
@property (nonatomic, strong) UILabel *descL;
@property (nonatomic, strong) UIView *areaView;
@property (nonatomic, strong) UILabel *areaL;
@property (nonatomic, strong) UICollectionView *memberCV;
@property (nonatomic, strong) UIView *pinfo;

@property (nonatomic, strong) UILabel *orderCreateTimeL;
@property (nonatomic, strong) UILabel *orderNoL;

@property (nonatomic, strong) UIImageView *grabAvatar;
@property (nonatomic, strong) UILabel *grabNameL;
@property (nonatomic, strong) UILabel *grabIdenL;
@property (nonatomic, strong) UILabel *grabPriceL;
@property (nonatomic, strong) UILabel *grabTimeL;
@property (nonatomic, strong) UILabel *completeTimeL;
@property (nonatomic, strong) UIButton *rateBtn;
@property (nonatomic, strong) UILabel *completeNormalL;
@property (nonatomic, strong) UILabel *grabTimeNormalL;
@property (nonatomic, strong) UIView *orderInfoView;
@property (nonatomic, strong) UILabel *grabL;

@property (nonatomic, strong) BC_ExecuteModuleModel *infoModel;
@property (nonatomic, strong) NSMutableArray *proPicArr;
@end

@implementation BC_ProjectDetailViewController
- (void)dealloc {
    [kNotificationCenter removeObserver:self];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Project details";
    self.proPicArr = [NSMutableArray array];
    [kNotificationCenter addObserver:self selector:@selector(changeRate) name:@"refreshProDetailAfterEva" object:nil];
    [self setupUI];
    [self getPageData];
}

#pragma mark  评价后修改按钮文字
- (void)changeRate {
    self.infoModel.is_score = @"1";
    [self.rateBtn setTitle:@"View rate" forState:0];
}

- (void)setupUI {
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight - HOME_INDICATOR_HEIGHT - 80)];
    self.scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:self.scrollView];
    
    self.contentView = [UIView new];
    self.contentView.backgroundColor = [UIColor whiteColor];
    [self.scrollView addSubview:self.contentView];
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.scrollView);
        make.width.equalTo(self.scrollView);
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
    }];
    
    self.cateL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(14) textColor:UIColor.whiteColor];
    self.cateL.layer.masksToBounds = YES;
    self.cateL.layer.cornerRadius = 14;
    self.cateL.textAlignment = NSTextAlignmentCenter;
    self.cateL.backgroundColor = kColorWithHex(@"#05A833");
    [self.contentView addSubview:self.cateL];
    [self.cateL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(self.timeL);
        make.size.mas_equalTo(CGSizeMake(30, 28));
    }];
    
    self.nameL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(17) textColor:kMainTextColor];
    self.nameL.numberOfLines = 0;
    [self.contentView addSubview:self.nameL];
    [self.nameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.timeL.mas_bottom).offset(20);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.descL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kLightGrayTextColor];
    self.descL.numberOfLines = 0;
    [self.contentView addSubview:self.descL];
    [self.descL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.nameL.mas_bottom).offset(10);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.areaView = [JLFactoryUtil view];
    self.areaView.backgroundColor = kColorWithHex(@"#ECF8EF");
    [self.areaView setCorner:12 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.areaView];
    [self.areaView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.descL.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(30, 24));
    }];
    
    UIImageView *areaImg = [JLFactoryUtil imageViewWithImg:@"位置"];
    [self.areaView addSubview:areaImg];
    [areaImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(self.areaView.mas_left).offset(10);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    self.areaL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kColorWithHex(@"#05A833")];
    [self.areaView addSubview:self.areaL];
    [self.areaL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(areaImg.mas_right).offset(4);
        make.width.mas_lessThanOrEqualTo(kScreenWidth - 70);
    }];
    
    UILabel *picL = [JLFactoryUtil labelWithText:@"Picture" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:picL];
    [picL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.areaView.mas_bottom).offset(20);
    }];
    
    UICollectionViewFlowLayout *taglayout = [UICollectionViewFlowLayout new];
    taglayout.scrollDirection = UICollectionViewScrollDirectionVertical;
    taglayout.minimumInteritemSpacing = 10;
    taglayout.minimumLineSpacing = 10;
    taglayout.itemSize = CGSizeMake((kScreenWidth-50)/4, (kScreenWidth-50)/4);
    taglayout.sectionInset = UIEdgeInsetsMake(10, 10, 10, 10);
    self.memberCV = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:taglayout];
    self.memberCV.delegate = self;
    self.memberCV.dataSource = self;
    self.memberCV.backgroundColor = UIColor.whiteColor;
    self.memberCV.showsVerticalScrollIndicator = NO;
    self.memberCV.scrollEnabled = NO;
    [self.memberCV registerClass:[BC_ProjectDetailPicCollectionViewCell class] forCellWithReuseIdentifier:@"membercell"];
    [self.contentView addSubview:self.memberCV];
    [self.memberCV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView);
        make.left.equalTo(self.contentView);
        make.top.equalTo(picL.mas_bottom).offset(10);
        make.height.mas_equalTo(1);
    }];
    
    UIView *pinfo = [JLFactoryUtil view];
    [self.contentView addSubview:pinfo];
    [pinfo mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(self.memberCV.mas_bottom).offset(10);
        make.height.mas_equalTo(60);
    }];
    CALayer *layer1 = [CALayer layer];
    layer1.frame = CGRectMake(15, 0, kScreenWidth - 30, 1);
    layer1.backgroundColor = kColorWithHex(@"#F2F2F2").CGColor;
    [pinfo.layer addSublayer:layer1];
    CALayer *layer2 = [CALayer layer];
    layer2.frame = CGRectMake(15, 59, kScreenWidth - 30, 1);
    layer2.backgroundColor = kColorWithHex(@"#F2F2F2").CGColor;
    [pinfo.layer addSublayer:layer2];
    UITapGestureRecognizer *tapProInfo = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(pushProjectInfo)];
    [pinfo addGestureRecognizer:tapProInfo];
    _pinfo = pinfo;
    
    UILabel *pinfoL = [JLFactoryUtil labelWithText:@"Project Information" font:REGULARFONT(15) textColor:kMainTextColor];
    pinfoL.userInteractionEnabled = YES;
    [pinfo addSubview:pinfoL];
    [pinfoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(pinfo);
        make.left.equalTo(pinfo.mas_left).offset(15);
    }];
    
    UIImageView *pinfoArrow = [JLFactoryUtil imageViewWithImg:@"更多"];
    pinfoArrow.userInteractionEnabled = YES;
    [pinfo addSubview:pinfoArrow];
    [pinfoArrow mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(pinfo);
        make.right.equalTo(pinfo.mas_right).offset(-15);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
}

- (void)setupWaitUI {
    [self.orderInfoView removeAllSubviews];
    self.orderInfoView = [JLFactoryUtil view];
    [self.contentView addSubview:self.orderInfoView];
    [self.orderInfoView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(self.pinfo.mas_bottom).offset(20);
        make.height.mas_equalTo(150);
    }];
    
    UILabel *oinfoL = [JLFactoryUtil labelWithText:@"Order information" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.orderInfoView addSubview:oinfoL];
    [oinfoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(self.orderInfoView.mas_top).offset(1);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Order number" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(oinfoL.mas_bottom).offset(8);
    }];
    
    self.orderNoL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderNoL];
    [self.orderNoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label1);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Creation time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(15);
    }];
    
    self.orderCreateTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderCreateTimeL];
    [self.orderCreateTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label2);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(self.orderInfoView.mas_bottom).offset(20);
    }];
    
    UIButton *waitSuccBtn = [JLFactoryUtil buttonWithTitle:@"Waiting for the successful order" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [waitSuccBtn setCorner:24 withType:JLCornerTypeAllCorner];
    waitSuccBtn.backgroundColor = kMainThemeColor;
    [waitSuccBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [waitSuccBtn addTarget:self action:@selector(waitSuccBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:waitSuccBtn];
    [waitSuccBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.contentView);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT - 16);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
        
    
    self.orderNoL.text = KStringIsNull(self.infoModel.order_id);
    self.orderCreateTimeL.text = KStringIsNull(self.infoModel.create_datetime);
}

- (void)setupInProgressUI {
        
    UILabel *grabL = [JLFactoryUtil labelWithText:@"Grab a single" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:grabL];
    [grabL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.pinfo.mas_bottom).offset(20);
    }];
    _grabL = grabL;
    
    self.grabAvatar = [JLFactoryUtil imageView];
    [self.grabAvatar setCorner:24 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.grabAvatar];
    [self.grabAvatar mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(grabL.mas_bottom).offset(12);
        make.size.mas_equalTo(CGSizeMake(48, 48));
    }];
    
    self.grabNameL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.grabNameL];
    [self.grabNameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.grabAvatar.mas_right).offset(12);
        make.right.lessThanOrEqualTo(self.contentView.mas_centerX).offset(20);
        make.bottom.equalTo(self.grabAvatar.mas_centerY).offset(-2);
    }];
    
    self.grabIdenL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.contentView addSubview:self.grabIdenL];
    [self.grabIdenL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.grabAvatar.mas_right).offset(12);
        make.right.lessThanOrEqualTo(self.contentView.mas_centerX).offset(20);
        make.top.equalTo(self.grabAvatar.mas_centerY).offset(2);
    }];
    
    self.grabPriceL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(18) textColor:kMainTextColor];
    [self.contentView addSubview:self.grabPriceL];
    [self.grabPriceL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(self.grabAvatar);
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.grabAvatar.mas_bottom).offset(15);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    [self.orderInfoView removeAllSubviews];
    self.orderInfoView = [JLFactoryUtil view];
    [self.contentView addSubview:self.orderInfoView];
    [self.orderInfoView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(line.mas_bottom).offset(20);
        make.height.mas_equalTo(180);
    }];
    
    UILabel *oinfoL = [JLFactoryUtil labelWithText:@"Order information" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.orderInfoView addSubview:oinfoL];
    [oinfoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(self.orderInfoView.mas_top).offset(1);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Order number" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(oinfoL.mas_bottom).offset(8);
    }];
    
    self.orderNoL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderNoL];
    [self.orderNoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label1);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Creation time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(15);
    }];
    
    self.orderCreateTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderCreateTimeL];
    [self.orderCreateTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label2);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label3 = [JLFactoryUtil labelWithText:@"Grab time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label3];
    [label3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label2.mas_bottom).offset(15);
    }];
    _grabTimeNormalL = label3;
    
    self.grabTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.grabTimeL];
    [self.grabTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label3);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(self.orderInfoView.mas_bottom).offset(20);
    }];
    
    //如果是督导 只显示群聊按钮
    if ([KStringIsNull([UserManager shareManager].getUserInfo.identity) isEqualToString:@"4"]) {
        //督导
        UIButton *groupBtn = [JLFactoryUtil buttonWithTitle:@"Group chat" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
        [groupBtn setCorner:24 withType:JLCornerTypeAllCorner];
        groupBtn.backgroundColor = kMainThemeColor;
        [groupBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
        [groupBtn addTarget:self action:@selector(groupBtnClick) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:groupBtn];
        [groupBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.view.mas_left).offset(30);
            make.bottom.equalTo(self.view.mas_bottom).offset(-16);
            make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
        }];
    } else {
        UIImageView *bgimg = [JLFactoryUtil imageViewWithImg:@"形状结合"];
        bgimg.userInteractionEnabled = YES;
        [self.view addSubview:bgimg];
        [bgimg mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.right.equalTo(self.contentView);
            make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT);
            make.height.mas_equalTo(80);
        }];
        
        UIView *groupView = [JLFactoryUtil view];
        groupView.backgroundColor = UIColor.clearColor;
        [bgimg addSubview:groupView];
        [groupView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(bgimg);
            make.bottom.equalTo(bgimg.mas_bottom).offset(0);
            make.size.mas_equalTo(CGSizeMake(160*kScreenWidth/375, 75));
        }];
        UITapGestureRecognizer *tapgroup = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(groupBtnClick)];
        [groupView addGestureRecognizer:tapgroup];
        
        UIImageView *groupImg = [JLFactoryUtil imageViewWithImg:@"群聊选中"];
        groupImg.userInteractionEnabled = YES;
        [groupView addSubview:groupImg];
        [groupImg mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(groupView);
            make.bottom.equalTo(groupView.mas_centerY).offset(-1);
            make.size.mas_equalTo(CGSizeMake(22, 22));
        }];
        
        UILabel *groupL = [JLFactoryUtil labelWithText:@"Group" font:MEDIUMFONT(14) textColor:kMainTextColor];
        groupL.userInteractionEnabled = YES;
        [groupView addSubview:groupL];
        [groupL mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(groupView);
            make.top.equalTo(groupView.mas_centerY).offset(1);
        }];
        
        UIButton *confirmCompleteBtn = [JLFactoryUtil buttonWithTitle:@"Confirm complete" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
        [confirmCompleteBtn setCorner:20 withType:JLCornerTypeAllCorner];
        confirmCompleteBtn.backgroundColor = kMainThemeColor;
        [confirmCompleteBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
        [confirmCompleteBtn addTarget:self action:@selector(confirmCompleteBtnClick) forControlEvents:UIControlEventTouchUpInside];
        [bgimg addSubview:confirmCompleteBtn];
        [confirmCompleteBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.bottom.equalTo(bgimg.mas_bottom).offset(-4);
            make.right.equalTo(bgimg.mas_right).offset(-15);
            make.size.mas_equalTo(CGSizeMake(kScreenWidth - 185, 40));
        }];
        _rateBtn = confirmCompleteBtn;
    }
        
    self.orderNoL.text = KStringIsNull(self.infoModel.order_id);
    self.orderCreateTimeL.text = KStringIsNull(self.infoModel.create_datetime);
    self.grabTimeL.text = KStringIsNull(self.infoModel.grab_time);
    
    BC_ExecuteModuleModel *umodel = [BC_ExecuteModuleModel mj_objectWithKeyValues:_infoModel.grab_userinfo];
    [self.grabAvatar sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(umodel.avatar)] placeholderImage:kAvatarPlaceHolderImg];
    self.grabNameL.text = KStringIsNull(umodel.name);
    if ([KStringIsNull(umodel.identity) isEqualToString:@"2"]) {
        self.grabIdenL.text = @"Professional users";
    } else if ([KStringIsNull(umodel.identity) isEqualToString:@"3"]) {
        self.grabIdenL.text = @"Project executor";
    } else if ([KStringIsNull(umodel.identity) isEqualToString:@"4"]) {
        self.grabIdenL.text = @"supervisor";
    }
    self.grabPriceL.text = kStringFormat(@"$%@", KStringIsNull(umodel.price));
}

- (void)setupCompleteUI {
    
    [_grabL removeFromSuperview];
    [self.grabAvatar removeFromSuperview];
    [self.grabNameL removeFromSuperview];
    [self.grabIdenL removeFromSuperview];
    [self.grabPriceL removeFromSuperview];
    
    UILabel *grabL = [JLFactoryUtil labelWithText:@"Grab a single" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:grabL];
    [grabL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.pinfo.mas_bottom).offset(20);
    }];
    _grabL = grabL;
    
    self.grabAvatar = [JLFactoryUtil imageView];
    [self.grabAvatar setCorner:24 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.grabAvatar];
    [self.grabAvatar mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(grabL.mas_bottom).offset(12);
        make.size.mas_equalTo(CGSizeMake(48, 48));
    }];
    
    self.grabNameL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.grabNameL];
    [self.grabNameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.grabAvatar.mas_right).offset(12);
        make.right.lessThanOrEqualTo(self.contentView.mas_centerX).offset(20);
        make.bottom.equalTo(self.grabAvatar.mas_centerY).offset(-2);
    }];
    
    self.grabIdenL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.contentView addSubview:self.grabIdenL];
    [self.grabIdenL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.grabAvatar.mas_right).offset(12);
        make.right.lessThanOrEqualTo(self.contentView.mas_centerX).offset(20);
        make.top.equalTo(self.grabAvatar.mas_centerY).offset(2);
    }];
    
    self.grabPriceL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(18) textColor:kMainTextColor];
    [self.contentView addSubview:self.grabPriceL];
    [self.grabPriceL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(self.grabAvatar);
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.grabAvatar.mas_bottom).offset(15);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    [self.orderInfoView removeAllSubviews];
    self.orderInfoView = [JLFactoryUtil view];
    [self.contentView addSubview:self.orderInfoView];
    [self.orderInfoView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(line.mas_bottom).offset(20);
        make.height.mas_equalTo(210);
    }];
    
    UILabel *oinfoL = [JLFactoryUtil labelWithText:@"Order information" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.orderInfoView addSubview:oinfoL];
    [oinfoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(line.mas_bottom).offset(20);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Order number" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(oinfoL.mas_bottom).offset(8);
    }];
    
    self.orderNoL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderNoL];
    [self.orderNoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label1);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Creation time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(15);
    }];
    
    self.orderCreateTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderCreateTimeL];
    [self.orderCreateTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label2);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label3 = [JLFactoryUtil labelWithText:@"Grab time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label3];
    [label3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label2.mas_bottom).offset(15);
    }];
    _grabTimeNormalL = label3;
    
    self.grabTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.grabTimeL];
    [self.grabTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label3);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label4 = [JLFactoryUtil labelWithText:@"Complete time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label4];
    [label4 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label3.mas_bottom).offset(15);
    }];
    _completeNormalL = label4;
    
    self.completeTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.completeTimeL];
    [self.completeTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label4);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(self.orderInfoView.mas_bottom).offset(20);
    }];
    
    //如果是督导 只显示群聊按钮
    if ([KStringIsNull([UserManager shareManager].getUserInfo.identity) isEqualToString:@"4"]) {
        UIButton *groupBtn = [JLFactoryUtil buttonWithTitle:@"Group chat" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
        [groupBtn setCorner:24 withType:JLCornerTypeAllCorner];
        groupBtn.backgroundColor = kMainThemeColor;
        [groupBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
        [groupBtn addTarget:self action:@selector(groupBtnClick) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:groupBtn];
        [groupBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.view.mas_left).offset(30);
            make.bottom.equalTo(self.view.mas_bottom).offset(-16);
            make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
        }];
    } else {
        UIImageView *bgimg = [JLFactoryUtil imageViewWithImg:@"形状结合"];
        bgimg.userInteractionEnabled = YES;
        [self.view addSubview:bgimg];
        [bgimg mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.right.equalTo(self.contentView);
            make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT);
            make.height.mas_equalTo(80);
        }];
        
        UIView *groupView = [JLFactoryUtil view];
        groupView.backgroundColor = UIColor.clearColor;
        [bgimg addSubview:groupView];
        [groupView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(bgimg);
            make.bottom.equalTo(bgimg.mas_bottom).offset(0);
            make.size.mas_equalTo(CGSizeMake(160*kScreenWidth/375, 75));
        }];
        UITapGestureRecognizer *tapgroup = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(groupBtnClick)];
        [groupView addGestureRecognizer:tapgroup];
        
        UIImageView *groupImg = [JLFactoryUtil imageViewWithImg:@"群聊选中"];
        groupImg.userInteractionEnabled = YES;
        [groupView addSubview:groupImg];
        [groupImg mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(groupView);
            make.bottom.equalTo(groupView.mas_centerY).offset(-1);
            make.size.mas_equalTo(CGSizeMake(22, 22));
        }];
        
        UILabel *groupL = [JLFactoryUtil labelWithText:@"Group" font:MEDIUMFONT(14) textColor:kMainTextColor];
        groupL.userInteractionEnabled = YES;
        [groupView addSubview:groupL];
        [groupL mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(groupView);
            make.top.equalTo(groupView.mas_centerY).offset(1);
        }];
        
    //    is_score = 1 已评价
        if ([KStringIsNull(_infoModel.is_score) isEqualToString:@"1"]) {
            UIButton *rateBtn = [JLFactoryUtil buttonWithTitle:@"View rate" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
            [rateBtn setCorner:20 withType:JLCornerTypeAllCorner];
            rateBtn.backgroundColor = kMainThemeColor;
            [rateBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
            [rateBtn addTarget:self action:@selector(gorateClick) forControlEvents:UIControlEventTouchUpInside];
            [bgimg addSubview:rateBtn];
            [rateBtn mas_makeConstraints:^(MASConstraintMaker *make) {
                make.bottom.equalTo(bgimg.mas_bottom).offset(-4);
                make.right.equalTo(bgimg.mas_right).offset(-15);
                make.size.mas_equalTo(CGSizeMake(kScreenWidth - 185, 40));
            }];
            _rateBtn = rateBtn;
        } else {
            UIButton *rateBtn = [JLFactoryUtil buttonWithTitle:@"Go to rate" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
            [rateBtn setCorner:20 withType:JLCornerTypeAllCorner];
            rateBtn.backgroundColor = kMainThemeColor;
            [rateBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
            [rateBtn addTarget:self action:@selector(gorateClick) forControlEvents:UIControlEventTouchUpInside];
            [bgimg addSubview:rateBtn];
            [rateBtn mas_makeConstraints:^(MASConstraintMaker *make) {
                make.bottom.equalTo(bgimg.mas_bottom).offset(-4);
                make.right.equalTo(bgimg.mas_right).offset(-15);
                make.size.mas_equalTo(CGSizeMake(kScreenWidth - 185, 40));
            }];
            _rateBtn = rateBtn;
        }
        
    }
    
    self.orderNoL.text = KStringIsNull(self.infoModel.order_id);
    self.orderCreateTimeL.text = KStringIsNull(self.infoModel.create_datetime);
    self.grabTimeL.text = KStringIsNull(self.infoModel.grab_time);
    
    BC_ExecuteModuleModel *umodel = [BC_ExecuteModuleModel mj_objectWithKeyValues:_infoModel.grab_userinfo];
    [self.grabAvatar sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(umodel.avatar)] placeholderImage:kAvatarPlaceHolderImg];
    self.grabNameL.text = KStringIsNull(umodel.name);
    if ([KStringIsNull(umodel.identity) isEqualToString:@"2"]) {
        self.grabIdenL.text = @"Professional users";
    } else if ([KStringIsNull(umodel.identity) isEqualToString:@"3"]) {
        self.grabIdenL.text = @"Project executor";
    } else if ([KStringIsNull(umodel.identity) isEqualToString:@"4"]) {
        self.grabIdenL.text = @"supervisor";
    }
    self.grabPriceL.text = kStringFormat(@"$%@", KStringIsNull(umodel.price));
    self.completeTimeL.text = KStringIsNull(self.infoModel.complte_time);
}

#pragma mark  UICollectionView Delegate
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    
    BC_ProjectDetailPicCollectionViewCell *cell = (BC_ProjectDetailPicCollectionViewCell *)[self.memberCV cellForItemAtIndexPath:indexPath];
    NSMutableArray *itemarr = [NSMutableArray array];
    for (NSString *url in self.proPicArr) {
        ZlinkPhotoGroupItem *item = [ZlinkPhotoGroupItem new];
        item.thumbView = cell;
        item.largeImageURL = [NSURL URLWithString:KStringIsNull(url)];
        [itemarr addObject:item];
    }
    ZlinkPhotoBrowserView *browser = [[ZlinkPhotoBrowserView alloc] initWithGroupItems:itemarr];
    [browser presentFromImageView:cell toContainer:self.navigationController.view animated:YES index:indexPath.item completion:^{
    }];
}

- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    BC_ProjectDetailPicCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"membercell" forIndexPath:indexPath];
    [cell setPicurl:_proPicArr[indexPath.item]];
    return cell;
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    return self.proPicArr.count;
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView {
    return 1;
}

#pragma mark  项目资料
- (void)pushProjectInfo {
    BC_ProjectInformationViewController *info = [BC_ProjectInformationViewController new];
    info.pid = KStringIsNull(self.infoModel.itemid);
    [self.navigationController pushViewController:info animated:YES];
}

#pragma mark  等待分配成功
- (void)waitSuccBtnClick {
    
}

#pragma mark  进群聊
- (void)groupBtnClick {
    
    if ([KStringIsNull(_infoModel.im_groupid) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Group does not exist"];
        return;
    }
    TUIChatConversationModel *model = [[TUIChatConversationModel alloc] init];
    model.groupID = KStringIsNull(_infoModel.im_groupid);
    model.title = KStringIsNull(_infoModel.name);
    BC_GroupChatViewController *chat = [[BC_GroupChatViewController alloc] init];
    chat.conversationData = model;
    [self.navigationController pushViewController:chat animated:YES];
}

#pragma mark  确认完成
- (void)confirmCompleteBtnClick {
    UIView *contentView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 290, 150)];
    contentView.backgroundColor = UIColor.whiteColor;
    [contentView setCorner:12 withType:JLCornerTypeAllCorner];
    
    UILabel *titleL = [JLFactoryUtil labelWithText:@"Scoring the construction staff" font:REGULARFONT(16) textColor:kMainTextColor];
    titleL.textAlignment = NSTextAlignmentCenter;
    titleL.numberOfLines = 0;
    [contentView addSubview:titleL];
    [titleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(contentView);
        make.top.equalTo(contentView.mas_top).offset(30);
        make.width.mas_lessThanOrEqualTo(260);
    }];
    
    UIView *hline = [UIView new];
    hline.backgroundColor = kColorWithHex(@"#EEEEEE");
    [contentView addSubview:hline];
    [hline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(contentView);
        make.bottom.equalTo(contentView.mas_bottom).offset(-40);
        make.height.mas_equalTo(1);
    }];
    
    UIView *vline = [UIView new];
    vline.backgroundColor = kColorWithHex(@"#EEEEEE");
    [contentView addSubview:vline];
    [vline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(contentView);
        make.top.equalTo(hline.mas_bottom);
        make.bottom.equalTo(contentView.mas_bottom);
        make.width.mas_equalTo(1);
    }];
    
    UIButton *cancelBtn = [JLFactoryUtil buttonWithTitle:@"Cancel" font:REGULARFONT(14) textColor:kMainThemeColor];
    [cancelBtn addTarget:self action:@selector(cancelAction:) forControlEvents:UIControlEventTouchUpInside];
    [contentView addSubview:cancelBtn];
    [cancelBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(contentView.mas_left).offset(15);
        make.bottom.equalTo(contentView.mas_bottom);
        make.top.equalTo(hline.mas_bottom);
        make.right.equalTo(vline.mas_left);
    }];
    
    UIButton *confirmBtn = [JLFactoryUtil buttonWithTitle:@"OK" font:REGULARFONT(14) textColor:kMainThemeColor];
    [confirmBtn addTarget:self action:@selector(confirmCompleteAction:) forControlEvents:UIControlEventTouchUpInside];
    [contentView addSubview:confirmBtn];
    [confirmBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(contentView.mas_right).offset(-15);
        make.bottom.equalTo(contentView.mas_bottom);
        make.top.equalTo(hline.mas_bottom);
        make.left.equalTo(vline.mas_right);
    }];
    
    KLCPopupLayout layout = KLCPopupLayoutMake(KLCPopupHorizontalLayoutCenter, KLCPopupVerticalLayoutCenter);
    KLCPopup *popup = [KLCPopup popupWithContentView:contentView showType:KLCPopupShowTypeShrinkIn dismissType:KLCPopupDismissTypeShrinkOut maskType:KLCPopupMaskTypeDimmed dismissOnBackgroundTouch:NO dismissOnContentTouch:NO];
    [popup showWithLayout:layout];
    
}

#pragma mark 完成项目
- (void)confirmCompleteAction:(UIButton *)sender {
    [sender dismissPresentingPopup];
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/completeprogram/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"id":KStringIsNull(self.pid)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [kNotificationCenter postNotificationName:@"finishProjectEva" object:nil];
            [self getFinishTime];
            [self gorateClick];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)getFinishTime {
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programdetail/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{@"id":KStringIsNull(self.pid)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            self.infoModel = [BC_ExecuteModuleModel mj_objectWithKeyValues:dataDic[@"data"]];
            [self setupCompleteUI];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
    }];
}

- (void)cancelAction:(UIButton *)sender {
    [sender dismissPresentingPopup];
}

#pragma mark  去评价
- (void)gorateClick {
    BC_ProjectRateViewController *rate = [BC_ProjectRateViewController new];
    rate.pid = KStringIsNull(self.infoModel.itemid);
    [self.navigationController pushViewController:rate animated:YES];
}

- (void)getPageData {
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programdetail/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{@"id":KStringIsNull(self.pid)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            self.infoModel = [BC_ExecuteModuleModel mj_objectWithKeyValues:dataDic[@"data"]];
            
            self.areaL.text = kStringFormat(@"%@,%@", KStringIsNull(self.infoModel.city), KStringIsNull(self.infoModel.province));
            CGSize size = [self.areaL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
            if (size.width >= (kScreenWidth - 70)) {
                size.width = kScreenWidth - 70;
            }
            [self.areaView mas_updateConstraints:^(MASConstraintMaker *make) {
                make.size.mas_equalTo(CGSizeMake(40+size.width, 24));
            }];
            
        
            self.cateL.text = KStringIsNull(self.infoModel.service_type);
            CGSize csize = [self.cateL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
            [self.cateL mas_updateConstraints:^(MASConstraintMaker *make) {
                make.size.mas_equalTo(CGSizeMake(24+csize.width, 28));
            }];
            
            self.timeL.text = KStringIsNull(self.infoModel.create_datetime);
            self.nameL.text = KStringIsNull(self.infoModel.name);
            self.descL.text = KStringIsNull(self.infoModel.desc);
            
            if (self.infoModel.images.count > 0) {
                self.proPicArr = [NSMutableArray arrayWithArray:self.infoModel.images];
            }
            
            [self.memberCV reloadData];
            [self.memberCV layoutIfNeeded];
            [self.memberCV mas_updateConstraints:^(MASConstraintMaker *make) {
                make.height.mas_equalTo(self.memberCV.collectionViewLayout.collectionViewContentSize.height);
            }];
            
            if ([KStringIsNull(self.infoModel.status) isEqualToString:@"20"] || [KStringIsNull(self.infoModel.status) isEqualToString:@"10"]) {
                [self setupWaitUI];
            } else if ([KStringIsNull(self.infoModel.status) isEqualToString:@"30"] || [KStringIsNull(self.infoModel.status) isEqualToString:@"40"]) {
                [self setupInProgressUI];
            } else if ([KStringIsNull(self.infoModel.status) isEqualToString:@"50"]) {
                [self setupCompleteUI];
            } else {
                [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
                    make.bottom.equalTo(self.pinfo.mas_bottom).offset(20);
                }];
            }
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

@end
