//
//  BC_ProjectMaterialViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/22.
//

#import "BC_ProjectMaterialViewController.h"
#import <WebKit/WebKit.h>
@interface BC_ProjectMaterialViewController ()<WKNavigationDelegate>
@property (nonatomic, strong) WKWebView *webview;

@end

@implementation BC_ProjectMaterialViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Material";

    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    
    NSString *jScript = @"var meta = document.createElement('meta'); meta.setAttribute('name', 'viewport'); meta.setAttribute('content', 'width=device-width'); document.getElementsByTagName('head')[0].appendChild(meta);";

    WKUserScript *wkUScript = [[WKUserScript alloc] initWithSource:jScript injectionTime:WKUserScriptInjectionTimeAtDocumentEnd forMainFrameOnly:YES];
    WKUserContentController *wkUController = [[WKUserContentController alloc] init];
    [wkUController addUserScript:wkUScript];

    WKWebViewConfiguration *wkWebConfig = [[WKWebViewConfiguration alloc] init];
    wkWebConfig.userContentController = wkUController;

    self.webview = [[WKWebView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight) configuration:wkWebConfig];
    self.webview.navigationDelegate = self;
    [self.view addSubview:self.webview];
        
    if ([KStringIsNull(self.contentStr) isEqualToString:@""]) {
        [self.webview loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:KStringIsNull(self.linkurl)]]];
    } else {
        NSString *first = @"<!DOCTYPE html><html><head><meta charset='utf-8' /><meta name='viewport' content='width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0'><meta name='apple-mobile-web-app-capable' content='yes'><title></title><style>  body{background-color:#fff;} img{width:100% !important;height:auto} *{word-break: break-all;color:#000} p{margin:0px !important;padding:0px !important} img{margin:0px !important;padding:0px !important;vertical-align:top;vertical-align:bottom;} </style></head><body>";
        NSString *second = @"</body><html>";
        NSString *temp = [first stringByAppendingString:KStringIsNull(self.contentStr)];
        NSString *final = [temp stringByAppendingString:second];
        [self.webview loadHTMLString:final baseURL:nil];
    }
    
}

- (void)webView:(WKWebView *)webView didFinishNavigation:(WKNavigation *)navigation {
    [MBProgressHUD hideHUDForView:self.view animated:YES];
}

- (void)webView:(WKWebView *)webView didFailNavigation:(WKNavigation *)navigation withError:(NSError *)error {
    [MBProgressHUD hideHUDForView:self.view animated:YES];
}

- (void)webView:(WKWebView *)webView didFailProvisionalNavigation:(WKNavigation *)navigation withError:(NSError *)error {
    [MBProgressHUD hideHUDForView:self.view animated:YES];
}
@end
