//
//  BC_RateSuccessViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/22.
//

#import "BC_RateSuccessViewController.h"
#import "BC_ProjectDetailViewController.h"
#import "BC_ExecutorProjectDetailViewController.h"

@interface BC_RateSuccessViewController ()

@end

@implementation BC_RateSuccessViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Successful";
    [self setupUI];
}

- (void)setupUI {
    UIImageView *imgv = [JLFactoryUtil imageViewWithImg:@"成功"];
    [self.view addSubview:imgv];
    [imgv mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.view);
        make.top.equalTo(self.view.mas_top).offset(50);
        make.size.mas_equalTo(CGSizeMake(108, 108));
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Submitted successfully" font:REGULARFONT(15) textColor:kMainTextColor];
    label1.textAlignment = NSTextAlignmentCenter;
    label1.numberOfLines = 0;
    [self.view addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.view);
        make.top.equalTo(imgv.mas_bottom).offset(15);
        make.width.mas_equalTo(kScreenWidth - 20);
    }];
    
    UIButton *loginBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [loginBtn setCorner:24 withType:JLCornerTypeAllCorner];
    loginBtn.backgroundColor = kMainThemeColor;
    [loginBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [loginBtn addTarget:self action:@selector(backBtnClicked) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:loginBtn];
    [loginBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.top.equalTo(label1.mas_bottom).offset(120);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
}

- (void)backBtnClicked {
    for (UIViewController *vc in self.navigationController.viewControllers) {
        if ([vc isKindOfClass:[BC_ProjectDetailViewController class]]) {
            [self.navigationController popToViewController:vc animated:YES];
            break;
        }
        if ([vc isKindOfClass:[BC_ExecutorProjectDetailViewController class]]) {
            [self.navigationController popToViewController:vc animated:YES];
            break;
        }
    }
}
@end
