//
//  BC_ProjectRateTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/22.
//

#import "BC_ProjectRateTableViewCell.h"
#import "CWStarRateView.h"
#import "BC_ExecuteModuleModel.h"
@interface BC_ProjectRateTableViewCell ()<CWStarRateViewDelegate>

@end

@implementation BC_ProjectRateTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.avatar = [JLFactoryUtil imageView];
    [self.avatar setCorner:24 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.avatar];
    [self.avatar mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.size.mas_equalTo(CGSizeMake(48, 48));
    }];
    
    self.nicknameL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.nicknameL];
    [self.nicknameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.avatar.mas_right).offset(10);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-10);
        make.bottom.equalTo(self.avatar.mas_centerY).offset(-4);
    }];
    
    self.rateView = [[CWStarRateView alloc] initWithFrame:CGRectMake(66, 52, 150, 20) numberOfStars:5];
    self.rateView.delegate = self;
    [self.contentView addSubview:self.rateView];
        
}

- (void)starRateView:(CWStarRateView *)starRateView scroePercentDidChange:(CGFloat)newScorePercent {
    _model.starvalue = newScorePercent;
    if (self.delegate && [self.delegate respondsToSelector:@selector(starValue:)]) {
        [self.delegate starValue:_model];
    }
}

- (void)setCanedit:(BOOL)canedit {
    self.rateView.userInteractionEnabled = canedit;
}

- (void)setModel:(BC_ExecuteModuleModel *)model {
    _model = model;
    [self.avatar sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(model.avatar)] placeholderImage:kAvatarPlaceHolderImg];
    self.nicknameL.text = KStringIsNull(model.nickname);
    self.rateView.scorePercent = model.starvalue;
}
@end
