//
//  BC_ExecutorSeeAllLogViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/24.
//

#import "BC_ExecutorSeeAllLogViewController.h"

#import "BC_ProjectScheduleTableViewCell.h"

#import "BRDatePickerView.h"
#import "BC_ExecuteModuleModel.h"

@interface BC_ExecutorSeeAllLogViewController ()<UITableViewDelegate, UITableViewDataSource, DZNEmptyDataSetSource, DZNEmptyDataSetDelegate>
@property (nonatomic, strong) UITableView *tableView;
@property (nonatomic, strong) NSMutableArray *dataArr;
@property (nonatomic, assign) NSInteger pageNum;
@property (nonatomic, strong) UITextField *startTF;
@property (nonatomic, strong) UITextField *endTF;
@property (nonatomic, strong) UILabel *timeL;

@property (nonatomic, strong) BRDatePickerView *sPicker;
@property (nonatomic, strong) BRDatePickerView *ePicker;

@property (nonatomic, strong) NSDate *selectStartDate;
@property (nonatomic, strong) NSDate *selectEndDate;


@end

@implementation BC_ExecutorSeeAllLogViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"My log";
    self.dataArr = [NSMutableArray array];
    self.pageNum = 1;
    [self setupUI];
    [self loadData];
}

- (void)setupUI {
    
    UIView *startView = [JLFactoryUtil view];
    startView.layer.borderWidth = 1;
    startView.layer.borderColor = kColorWithHex(@"#CCCCCC").CGColor;
    [startView setCorner:8 withType:JLCornerTypeAllCorner];
    [self.view addSubview:startView];
    [startView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(15);
        make.top.equalTo(self.view.mas_top).offset(24);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 85)/2, 36));
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#E6E6E6");
    [self.view addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(startView);
        make.left.equalTo(startView.mas_right).offset(17);
        make.size.mas_equalTo(CGSizeMake(20, 1));
    }];
    
    self.startTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(14) place:@"start date"];
    self.startTF.textColor = kMainTextColor;
    self.startTF.enabled = NO;
    [startView addSubview:self.startTF];
    [self.startTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(startView);
        make.left.equalTo(startView.mas_left).offset(44);
        make.right.equalTo(startView.mas_right).offset(-20);
        make.height.mas_equalTo(30);
    }];
    
    UIImageView *simg = [JLFactoryUtil imageViewWithImg:@"日期"];
    [startView addSubview:simg];
    [simg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(startView);
        make.left.equalTo(startView.mas_left).offset(12);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    UIView *startClear = [JLFactoryUtil view];
    startClear.backgroundColor = UIColor.clearColor;
    [startView addSubview:startClear];
    [startClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(startView);
    }];
    UITapGestureRecognizer *tapStart = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseStartDate)];
    [startClear addGestureRecognizer:tapStart];
    
    UIView *endView = [JLFactoryUtil view];
    endView.layer.borderWidth = 1;
    endView.layer.borderColor = kColorWithHex(@"#CCCCCC").CGColor;
    [endView setCorner:8 withType:JLCornerTypeAllCorner];
    [self.view addSubview:endView];
    [endView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(startView.mas_right).offset(55);
        make.top.equalTo(self.view.mas_top).offset(24);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 85)/2, 36));
    }];
    
    self.endTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(14) place:@"End date"];
    self.endTF.textColor = kMainTextColor;
    self.endTF.enabled = NO;
    [endView addSubview:self.endTF];
    [self.endTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(endView);
        make.left.equalTo(endView.mas_left).offset(44);
        make.right.equalTo(endView.mas_right).offset(-20);
        make.height.mas_equalTo(30);
    }];
    
    UIImageView *eimg = [JLFactoryUtil imageViewWithImg:@"日期"];
    [endView addSubview:eimg];
    [eimg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(endView);
        make.left.equalTo(endView.mas_left).offset(12);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    UIView *endClear = [JLFactoryUtil view];
    endClear.backgroundColor = UIColor.clearColor;
    [endView addSubview:endClear];
    [endClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(endView);
    }];
    UITapGestureRecognizer *tapEnd = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseEndDate)];
    [endView addGestureRecognizer:tapEnd];
    
    UIView *label1 = [JLFactoryUtil labelWithText:@"Log" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.view addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(15);
        make.top.equalTo(startView.mas_bottom).offset(20);
    }];
    
    UIImageView *logImg = [JLFactoryUtil imageViewWithImg:@"日志icon"];
    [self.view addSubview:logImg];
    [logImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(label1);
        make.top.equalTo(label1.mas_bottom).offset(15);
        make.size.mas_equalTo(CGSizeMake(18, 18));
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kMainTextColor];
    [self.view addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(logImg);
        make.left.equalTo(logImg.mas_right).offset(10);
    }];
    
    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 150, kScreenWidth, kScreenHeight - kTopHeight - 150 - HOME_INDICATOR_HEIGHT - 60)];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.tableFooterView = [UIView new];
    self.tableView.showsVerticalScrollIndicator = NO;
    self.tableView.emptyDataSetSource = self;
    self.tableView.emptyDataSetDelegate = self;
    self.tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    self.tableView.backgroundColor = UIColor.whiteColor;
    [self.view addSubview:self.tableView];
    self.tableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;
    if (@available(iOS 15.0, *)) {
        self.tableView.sectionHeaderTopPadding = 0;
    }
    [self.tableView registerClass:[BC_ProjectScheduleTableViewCell class] forCellReuseIdentifier:@"cellid"];
    self.tableView.mj_header = [MJRefreshNormalHeader headerWithRefreshingTarget:self refreshingAction:@selector(loadData)];
    self.tableView.mj_footer = [MJRefreshBackNormalFooter footerWithRefreshingTarget:self refreshingAction:@selector(loadMoreData)];
    
    UIButton *writeBtn = [JLFactoryUtil buttonWithTitle:@"Write log" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [writeBtn setCorner:22 withType:JLCornerTypeAllCorner];
    writeBtn.backgroundColor = kMainThemeColor;
    [writeBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [writeBtn addTarget:self action:@selector(writeBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:writeBtn];
    [writeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.view);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT-8);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 44));
    }];
}

- (void)loadData {
    self.pageNum = 1;
    [self.tableView.mj_footer resetNoMoreData];
    [self getPageData];
}

- (void)loadMoreData {
    self.pageNum++;
    [self getPageData];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellid = @"cellid";
    BC_ProjectScheduleTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellid];
    if (!cell) {
        cell = [[BC_ProjectScheduleTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellid];
    }
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    [self configCell:cell andIndexP:indexPath];
    return cell;
}

- (void)configCell:(BC_ProjectScheduleTableViewCell *)cell andIndexP:(NSIndexPath *)indexp {
    [cell setModel:_dataArr[indexp.row]];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return [tableView fd_heightForCellWithIdentifier:@"cellid" cacheByIndexPath:indexPath configuration:^(id cell) {
        [self configCell:cell andIndexP:indexPath];
    }];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.dataArr.count;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
}

- (UIImage *)imageForEmptyDataSet:(UIScrollView *)scrollView {
    return [UIImage imageNamed:@"空数据"];
}

- (BOOL)emptyDataSetShouldAllowScroll:(UIScrollView *)scrollView {
    return YES;
}

#pragma mark  开始日期
- (void)chooseStartDate {
    [self.sPicker show];
}

#pragma mark  结束日期
- (void)chooseEndDate {
    [self.ePicker show];
}

#pragma mark  写日志
- (void)writeBtnClick {
    [self.navigationController popViewControllerAnimated:YES];
}

#pragma mark  Action
- (void)getPageData {
    
    NSString *stime = @"";
    NSString *etime = @"";
    if (self.selectStartDate) {
        stime = [self.selectStartDate stringWithFormat:@"yyyy-MM-dd"];
    }
    if (self.selectEndDate) {
        etime = [self.selectEndDate stringWithFormat:@"yyyy-MM-dd"];
    }

    NSString *url = [NSString stringWithFormat:@"%@/api/app/programlogaddlist/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{@"page":@(self.pageNum), @"limit":@"15", @"id":KStringIsNull(self.pid), @"start_time":KStringIsNull(stime), @"end_time":KStringIsNull(etime)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            if (self.pageNum == 1) {
                self.dataArr = [BC_ExecuteModuleModel mj_objectArrayWithKeyValuesArray:dataDic[@"data"]];
                [self.tableView.mj_header endRefreshing];
            } else {
                NSMutableArray *tempArr = [BC_ExecuteModuleModel mj_objectArrayWithKeyValuesArray:dataDic[@"data"]];
                if (tempArr.count > 0) {
                    [self.dataArr addObjectsFromArray:tempArr];
                    [self.tableView.mj_footer endRefreshing];
                } else {
                    [self.tableView.mj_footer endRefreshingWithNoMoreData];
                }
            }
        } else {
            [self.tableView.mj_header endRefreshing];
            [self.tableView.mj_footer endRefreshing];
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
        [self.tableView reloadData];
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [self.tableView.mj_header endRefreshing];
        [self.tableView.mj_footer endRefreshing];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (BRDatePickerView *)sPicker {
    if (!_sPicker) {
        _sPicker = [[BRDatePickerView alloc] initWithPickerMode:BRDatePickerModeYMD];
        @weakify(self);
        _sPicker.resultBlock = ^(NSDate * _Nullable selectDate, NSString * _Nullable selectValue) {
            @strongify(self);
            if (self.selectEndDate) {
                NSComparisonResult result = [selectDate compare:self.selectEndDate];
                if (result == NSOrderedDescending) {
                    //selectDate > self.selectEndDate
                    //开始时间大于结束时间
                    [BaseFunction showAlert:@"Please select the correct time period"];
                    return;
                }
            }
            self.selectStartDate = selectDate;
            self.startTF.text = KStringIsNull(selectValue);
            self.timeL.text = kStringFormat(@"%@ ~ %@", KStringIsNull(self.startTF.text), KStringIsNull(self.endTF.text));
            [self loadData];
        };
    }
    return _sPicker;
}

- (BRDatePickerView *)ePicker {
    if (!_ePicker) {
        _ePicker = [[BRDatePickerView alloc] initWithPickerMode:BRDatePickerModeYMD];
        @weakify(self);
        _ePicker.resultBlock = ^(NSDate * _Nullable selectDate, NSString * _Nullable selectValue) {
            @strongify(self);
            if (self.selectStartDate) {
                NSComparisonResult result = [self.selectStartDate compare:selectDate];
                if (result == NSOrderedDescending) {
                    //self.selectStartDate > selectDate
                    //开始时间大于结束时间
                    [BaseFunction showAlert:@"Please select the correct time period"];
                    return;
                }
            }
            self.selectEndDate = selectDate;
            self.endTF.text = KStringIsNull(selectValue);
            self.timeL.text = kStringFormat(@"%@ ~ %@", KStringIsNull(self.startTF.text), KStringIsNull(self.endTF.text));
            [self loadData];
        };
    }
    return _ePicker;
}



@end
