//
//  BC_WriteLogViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/24.
//

#import "BC_WriteLogViewController.h"
#import "BC_ExecutorSeeAllLogViewController.h"

#import "BRDatePickerView.h"

@interface BC_WriteLogViewController ()
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;
@property (nonatomic, strong) UILabel *timeL;
@property (nonatomic, strong) YYTextView *contentTV;
@property (nonatomic, strong) YYTextView *descTV;
@property (nonatomic, strong) BRDatePickerView *datePicker;
@end

@implementation BC_WriteLogViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Add log";
    [self setupUI];
}

- (void)setupUI {
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight - HOME_INDICATOR_HEIGHT - 66)];
    self.scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:self.scrollView];
    
    self.contentView = [UIView new];
    self.contentView.backgroundColor = [UIColor whiteColor];
    [self.scrollView addSubview:self.contentView];
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.scrollView);
        make.width.equalTo(self.scrollView);
    }];
    
    UIImageView *logimg = [JLFactoryUtil imageViewWithImg:@"日志icon"];
    [self.contentView addSubview:logimg];
    [logimg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(30);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(logimg);
        make.left.equalTo(logimg.mas_right).offset(15);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-50);
    }];
    NSString *today = [[NSDate date] stringWithFormat:@"yyyy-MM-dd"];
    self.timeL.text = KStringIsNull(today);
    
    UIImageView *arrow = [JLFactoryUtil imageViewWithImg:@"更多"];
    [self.contentView addSubview:arrow];
    [arrow mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(logimg);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    UIView *line1 = [JLFactoryUtil view];
    line1.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line1];
    [line1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(logimg.mas_bottom).offset(15);
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UIView *timeClear = [JLFactoryUtil view];
    timeClear.backgroundColor = UIColor.clearColor;
    [self.contentView addSubview:timeClear];
    [timeClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.timeL);
        make.left.right.equalTo(self.contentView);
        make.height.mas_equalTo(35);
    }];
    UITapGestureRecognizer *tapTime = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseTime)];
    [timeClear addGestureRecognizer:tapTime];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Work content" font:MEDIUMFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line1.mas_bottom).offset(30);
    }];
    
    UIView *cview = [JLFactoryUtil view];
    [cview setCorner:4 withType:JLCornerTypeAllCorner];
    cview.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:cview];
    [cview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(label1);
        make.top.equalTo(label1.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 120));
    }];
    
    self.contentTV = [YYTextView new];
    self.contentTV.placeholderFont = REGULARFONT(14);
    self.contentTV.placeholderText = @"Please enter";
    self.contentTV.placeholderTextColor = kLightGrayTextColor;
    self.contentTV.textColor = kMainTextColor;
    self.contentTV.font = REGULARFONT(14);
    [cview addSubview:self.contentTV];
    [self.contentTV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(cview).insets(UIEdgeInsetsMake(10, 10, 10, 10));
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Description" font:MEDIUMFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(cview.mas_bottom).offset(30);
    }];
    
    UIView *dview = [JLFactoryUtil view];
    [dview setCorner:4 withType:JLCornerTypeAllCorner];
    dview.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:dview];
    [dview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(label1);
        make.top.equalTo(label2.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 120));
    }];
    
    self.descTV = [YYTextView new];
    self.descTV.placeholderFont = REGULARFONT(14);
    self.descTV.placeholderText = @"Please enter";
    self.descTV.placeholderTextColor = kLightGrayTextColor;
    self.descTV.textColor = kMainTextColor;
    self.descTV.font = REGULARFONT(14);
    [dview addSubview:self.descTV];
    [self.descTV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(dview).insets(UIEdgeInsetsMake(10, 10, 10, 10));
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(dview.mas_bottom).offset(20);
    }];
    
    
    UIView *bottomView = [JLFactoryUtil view];
    bottomView.backgroundColor = UIColor.whiteColor;
    [self.view addSubview:bottomView];
    [bottomView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.view);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT);
        make.height.mas_equalTo(64);
    }];
    
    UIImageView *seeImg = [JLFactoryUtil imageViewWithImg:@"全部日志"];
    [bottomView addSubview:seeImg];
    [seeImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(bottomView.mas_left).offset(50);
        make.top.equalTo(bottomView.mas_top).offset(10);
        make.size.mas_equalTo(CGSizeMake(22, 22));
    }];
    
    UILabel *seeL = [JLFactoryUtil labelWithText:@"See log" font:REGULARFONT(14) textColor:kMainTextColor];
    [bottomView addSubview:seeL];
    [seeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(seeImg);
        make.top.equalTo(seeImg.mas_bottom).offset(2);
    }];
    
    UIView *seeClear = [JLFactoryUtil view];
    seeClear.backgroundColor = UIColor.clearColor;
    [bottomView addSubview:seeClear];
    [seeClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.top.bottom.equalTo(bottomView);
        make.right.equalTo(seeL.mas_right);
    }];
    UITapGestureRecognizer *tapSee = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(showAllLog)];
    [seeClear addGestureRecognizer:tapSee];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:22 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [bottomView addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(bottomView.mas_right).offset(-15);
        make.centerY.equalTo(bottomView);
        make.size.mas_equalTo(CGSizeMake(220, 44));
    }];
}

- (void)chooseTime {
    [self.view endEditing:YES];
    [self.datePicker show];
}

#pragma mark  查看日志
- (void)showAllLog {
    BC_ExecutorSeeAllLogViewController *seelog = [BC_ExecutorSeeAllLogViewController new];
    seelog.pid = KStringIsNull(self.pid);
    [self.navigationController pushViewController:seelog animated:YES];
}

#pragma mark  提交
- (void)submitBtnClick {
    
    if ([KStringIsNull(self.contentTV.text) isEqualToString:@""] || [KStringIsNull(self.descTV.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please complete info"];
        return;
    }
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programlogaddlist/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"id":KStringIsNull(self.pid), @"content":KStringIsNull(self.contentTV.text), @"desc":KStringIsNull(self.descTV.text), @"logtime":KStringIsNull(self.timeL.text)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [BaseFunction showAlert:@"Success"];
            [self.navigationController popViewControllerAnimated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (BRDatePickerView *)datePicker {
    if (!_datePicker) {
        _datePicker = [[BRDatePickerView alloc] initWithPickerMode:BRDatePickerModeYMD];
        _datePicker.minDate = [NSDate date];
        @weakify(self);
        _datePicker.resultBlock = ^(NSDate * _Nullable selectDate, NSString * _Nullable selectValue) {
            @strongify(self);
            self.timeL.text = KStringIsNull(selectValue);
        };
    }
    return _datePicker;
}
@end
