//
//  BC_ExectorAddRateViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/24.
//

#import "BC_ExectorAddRateViewController.h"
#import "BC_RateSuccessViewController.h"

#import "BC_ExectorAddRateTableViewCell.h"
#import "BC_ExecuteModuleModel.h"

@interface BC_ExectorAddRateViewController ()<UITableViewDelegate, UITableViewDataSource, BC_ExectorAddRateTableViewCellDelegate>
@property (nonatomic, strong) UITableView *tableView;
@property (nonatomic, strong) UIButton *submitBtn;
@property (nonatomic, assign) CGFloat star1;
@property (nonatomic, assign) CGFloat star2;
@property (nonatomic, assign) CGFloat star3;
@property (nonatomic, strong) NSMutableArray *scoreArr;
@property (nonatomic, assign) BOOL canEdit;
@end

@implementation BC_ExectorAddRateViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Score";
    self.star1 = 5;
    self.star2 = 5;
    self.star3 = 5;
    self.scoreArr = [NSMutableArray array];
    self.canEdit = YES;
    [self setupUI];
    [self getScore];
}

- (void)setupUI {
    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight - HOME_INDICATOR_HEIGHT - 60)];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.tableFooterView = [UIView new];
    self.tableView.showsVerticalScrollIndicator = NO;
    self.tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    [self.view addSubview:self.tableView];
    self.tableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT-6);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    _submitBtn = submitBtn;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellid = @"cellid";
    BC_ExectorAddRateTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellid];
    if (!cell) {
        cell = [[BC_ExectorAddRateTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellid];
    }
    cell.delegate = self;
    cell.index = indexPath.row;
    if (!self.canEdit) {
        if (self.scoreArr.count > 0) {
            [cell setScore:self.scoreArr[indexPath.row]];
        }
    }
    cell.canedit = self.canEdit;
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 100;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 3;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
}

- (void)starValue:(NSInteger)index andScore:(CGFloat)score{
    KLog(@"%f", score);
    if (index == 0) {
        _star1 = score*10/2;
    } else if (index == 1) {
        _star2 = score*10/2;
    } else if (index == 2) {
        _star3 = score*10/2;
    }
}

- (void)submitBtnClick {
    
    NSDictionary *dic = @{@"payment":kStringFormat(@"%.0f", self.star1),@"friendly":kStringFormat(@"%.0f", self.star3),@"interflow":kStringFormat(@"%.0f", self.star2)};
    NSString *scoreStr = [KStringIsNull([dic mj_JSONString]) stringByReplacingOccurrencesOfString:@"\\" withString:@""];

    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programexecuteuserscore/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"id":KStringIsNull(self.pid), @"score":scoreStr} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [kNotificationCenter postNotificationName:@"refreshExecuListAfterEva" object:nil];
            [self.navigationController pushViewController:[BC_RateSuccessViewController new] animated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
    
}

- (void)getScore {
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programownuserscore/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{@"id":KStringIsNull(self.pid)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic1 = (NSDictionary *)resdic[@"data"];
            NSDictionary *dataDic2 = (NSDictionary *)dataDic1[@"data"];
            NSDictionary *scoreDic = (NSDictionary *)dataDic2[@"score"];
            if ([KStringIsNull(scoreDic[@"payment"]) isEqualToString:@""]) {
                //未评分
                self.canEdit = YES;
                self.submitBtn.hidden = NO;
            } else {
                //已评分
                self.canEdit = NO;
                self.submitBtn.hidden = YES;
                [self.scoreArr addObject:KStringIsNull(scoreDic[@"payment"])];
                [self.scoreArr addObject:KStringIsNull(scoreDic[@"interflow"])];
                [self.scoreArr addObject:KStringIsNull(scoreDic[@"friendly"])];
            }
            [self.tableView reloadData];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}
@end
