//
//  BC_ExectorAddRateTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/24.
//

#import "BC_ExectorAddRateTableViewCell.h"
#import "CWStarRateView.h"
@interface BC_ExectorAddRateTableViewCell ()<CWStarRateViewDelegate>

@end

@implementation BC_ExectorAddRateTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    
    self.rateTypeL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.rateTypeL];
    [self.rateTypeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-10);
        make.bottom.equalTo(self.contentView.mas_centerY).offset(-4);
    }];
    
    self.rateView = [[CWStarRateView alloc] initWithFrame:CGRectMake(14, 52, 150, 20) numberOfStars:5];
    self.rateView.delegate = self;
    [self.contentView addSubview:self.rateView];
        
}

- (void)starRateView:(CWStarRateView *)starRateView scroePercentDidChange:(CGFloat)newScorePercent {
    if (self.delegate && [self.delegate respondsToSelector:@selector(starValue:andScore:)]) {
        [self.delegate starValue:self.index andScore:newScorePercent];
    }
}

- (void)setIndex:(NSInteger)index {
    _index = index;
    if (index == 0) {
        self.rateTypeL.text = @"Payment";
    } else if (index == 1) {
        self.rateTypeL.text = @"Coordinate and communicate";
    } else {
        self.rateTypeL.text = @"Is it friendly";
    }
}

- (void)setCanedit:(BOOL)canedit {
    self.rateView.userInteractionEnabled = canedit;
}

- (void)setScore:(NSString *)score {
    CGFloat fscore = [score floatValue]*2/10;
    self.rateView.scorePercent = fscore;
}
@end
