//
//  BC_ExecutorProjectDetailViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/23.
//

#import "BC_ExecutorProjectDetailViewController.h"
#import "BC_ProjectMaterialViewController.h"
#import "BC_ExecutorRejectProjectViewController.h"
#import "BC_WriteLogViewController.h"
#import "BC_ExectorAddRateViewController.h"
#import "BC_ExecutorQuotPriceSuccViewController.h"
#import "BC_GroupChatViewController.h"

#import "BC_ProjectDetailPicCollectionViewCell.h"
#import "BC_ProjectInfoFileCollectionViewCell.h"
#import "ZlinkPhotoBrowserView.h"

#import "TUIChatConversationModel.h"
#import "BC_ExecuteModuleModel.h"
@interface BC_ExecutorProjectDetailViewController ()<UICollectionViewDelegate, UICollectionViewDataSource, UITextFieldDelegate>
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;

@property (nonatomic, strong) UILabel *timeL;
@property (nonatomic, strong) UILabel *cateL;
@property (nonatomic, strong) UILabel *nameL;
@property (nonatomic, strong) UILabel *descL;
@property (nonatomic, strong) UIView *areaView;
@property (nonatomic, strong) UILabel *areaL;
@property (nonatomic, strong) UICollectionView *picCollectionView;
@property (nonatomic, strong) UICollectionView *contractCollectionView;
@property (nonatomic, strong) UICollectionView *agreementCollectionView;
@property (nonatomic, strong) UIView *matline1;
@property (nonatomic, strong) UILabel *orderFinishTimeL;
@property (nonatomic, strong) UILabel *orderCreateTimeL;
@property (nonatomic, strong) UILabel *orderNoL;
@property (nonatomic, strong) UILabel *grabTimeL;
@property (nonatomic, strong) UITextField *quotPriceTF;
@property (nonatomic, strong) UIView *orderInfoView;
@property (nonatomic, strong) UIView *bottomBtnView;
@property (nonatomic, strong) UIButton *finishBtn;

@property (nonatomic, strong) BC_ExecuteModuleModel *infoModel;
@property (nonatomic, strong) NSMutableArray *proPicArr;
@property (nonatomic, strong) NSMutableArray *contractArr;
@property (nonatomic, strong) NSMutableArray *agreeArr;
@end

@implementation BC_ExecutorProjectDetailViewController
- (void)dealloc {
    [kNotificationCenter removeObserver:self];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Project details";
    self.proPicArr = [NSMutableArray array];
    self.contractArr = [NSMutableArray array];
    self.agreeArr = [NSMutableArray array];
    [kNotificationCenter addObserver:self selector:@selector(refreshPage) name:@"refreshExecuListAfterEva" object:nil];
    [self setupUI];
    [self getPageData];
}

#pragma mark  评分后刷新页面
- (void)refreshPage {
    self.infoModel.is_score = @"1";
    [self.finishBtn setTitle:@"View rate" forState:0];
}

- (void)setupUI {
    
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight - HOME_INDICATOR_HEIGHT - 85)];
    self.scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:self.scrollView];
    
    self.contentView = [UIView new];
    self.contentView.backgroundColor = [UIColor whiteColor];
    [self.scrollView addSubview:self.contentView];
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.scrollView);
        make.width.equalTo(self.scrollView);
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
    }];
    
    self.cateL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(14) textColor:UIColor.whiteColor];
    self.cateL.layer.masksToBounds = YES;
    self.cateL.layer.cornerRadius = 14;
    self.cateL.textAlignment = NSTextAlignmentCenter;
    self.cateL.backgroundColor = kColorWithHex(@"#05A833");
    [self.contentView addSubview:self.cateL];
    [self.cateL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(self.timeL);
        make.size.mas_equalTo(CGSizeMake(30, 28));
    }];
    
    self.nameL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(17) textColor:kMainTextColor];
    self.nameL.numberOfLines = 0;
    [self.contentView addSubview:self.nameL];
    [self.nameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.timeL.mas_bottom).offset(20);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.descL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kLightGrayTextColor];
    self.descL.numberOfLines = 0;
    [self.contentView addSubview:self.descL];
    [self.descL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.nameL.mas_bottom).offset(10);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.areaView = [JLFactoryUtil view];
    self.areaView.backgroundColor = kColorWithHex(@"#ECF8EF");
    [self.areaView setCorner:12 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.areaView];
    [self.areaView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.descL.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(30, 24));
    }];
    
    UIImageView *areaImg = [JLFactoryUtil imageViewWithImg:@"位置"];
    [self.areaView addSubview:areaImg];
    [areaImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(self.areaView.mas_left).offset(10);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    self.areaL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kColorWithHex(@"#05A833")];
    [self.areaView addSubview:self.areaL];
    [self.areaL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(areaImg.mas_right).offset(4);
        make.width.mas_lessThanOrEqualTo(kScreenWidth - 70);
    }];
    
    UILabel *picL = [JLFactoryUtil labelWithText:@"Picture" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:picL];
    [picL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.areaView.mas_bottom).offset(20);
    }];
    
    UICollectionViewFlowLayout *taglayout = [UICollectionViewFlowLayout new];
    taglayout.scrollDirection = UICollectionViewScrollDirectionVertical;
    taglayout.minimumInteritemSpacing = 10;
    taglayout.minimumLineSpacing = 10;
    taglayout.itemSize = CGSizeMake((kScreenWidth-50)/4, (kScreenWidth-50)/4);
    taglayout.sectionInset = UIEdgeInsetsMake(10, 10, 10, 10);
    self.picCollectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:taglayout];
    self.picCollectionView.delegate = self;
    self.picCollectionView.dataSource = self;
    self.picCollectionView.backgroundColor = UIColor.whiteColor;
    self.picCollectionView.showsVerticalScrollIndicator = NO;
    self.picCollectionView.scrollEnabled = NO;
    [self.picCollectionView registerClass:[BC_ProjectDetailPicCollectionViewCell class] forCellWithReuseIdentifier:@"membercell"];
    [self.contentView addSubview:self.picCollectionView];
    [self.picCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView);
        make.left.equalTo(self.contentView);
        make.top.equalTo(picL.mas_bottom).offset(10);
        make.height.mas_equalTo(1);
    }];
    
    UILabel *fileL = [JLFactoryUtil labelWithText:@"File" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:fileL];
    [fileL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.picCollectionView.mas_bottom).offset(20);
    }];
        
    UIView *conView = [JLFactoryUtil view];
    conView.backgroundColor = kColorWithHex(@"#F8F8F8");
    [self.contentView addSubview:conView];
    [conView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(fileL.mas_bottom).offset(8);
        make.height.mas_equalTo(32);
    }];
    
    UILabel *conL = [JLFactoryUtil labelWithText:@"Contract" font:REGULARFONT(14) textColor:kMainTextColor];
    [conView addSubview:conL];
    [conL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(conView.mas_left).offset(15);
        make.centerY.equalTo(conView);
    }];
    
    UICollectionViewFlowLayout *conlayout = [UICollectionViewFlowLayout new];
    conlayout.scrollDirection = UICollectionViewScrollDirectionVertical;
    conlayout.minimumInteritemSpacing = 10;
    conlayout.minimumLineSpacing = 10;
    conlayout.itemSize = CGSizeMake((kScreenWidth-50)/4, 103);
    conlayout.sectionInset = UIEdgeInsetsMake(10, 10, 10, 10);
    self.contractCollectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:conlayout];
    self.contractCollectionView.delegate = self;
    self.contractCollectionView.dataSource = self;
    self.contractCollectionView.backgroundColor = UIColor.whiteColor;
    self.contractCollectionView.showsVerticalScrollIndicator = NO;
    self.contractCollectionView.scrollEnabled = NO;
    [self.contractCollectionView registerClass:[BC_ProjectInfoFileCollectionViewCell class] forCellWithReuseIdentifier:@"contractcell"];
    [self.contentView addSubview:self.contractCollectionView];
    [self.contractCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView);
        make.left.equalTo(self.contentView);
        make.top.equalTo(conView.mas_bottom).offset(10);
        make.height.mas_equalTo(1);
    }];
    
    UIView *agreeView = [JLFactoryUtil view];
    agreeView.backgroundColor = kColorWithHex(@"#F8F8F8");
    [self.contentView addSubview:agreeView];
    [agreeView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(self.contractCollectionView.mas_bottom).offset(10);
        make.height.mas_equalTo(32);
    }];
    
    UILabel *agreeL = [JLFactoryUtil labelWithText:@"Agreement" font:REGULARFONT(14) textColor:kMainTextColor];
    [agreeView addSubview:agreeL];
    [agreeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(agreeView.mas_left).offset(15);
        make.centerY.equalTo(agreeView);
    }];
    
    UICollectionViewFlowLayout *agrlayout = [UICollectionViewFlowLayout new];
    agrlayout.scrollDirection = UICollectionViewScrollDirectionVertical;
    agrlayout.minimumInteritemSpacing = 10;
    agrlayout.minimumLineSpacing = 10;
    agrlayout.itemSize = CGSizeMake((kScreenWidth-50)/4, 103);
    agrlayout.sectionInset = UIEdgeInsetsMake(10, 10, 10, 10);
    self.agreementCollectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:agrlayout];
    self.agreementCollectionView.delegate = self;
    self.agreementCollectionView.dataSource = self;
    self.agreementCollectionView.backgroundColor = UIColor.whiteColor;
    self.agreementCollectionView.showsVerticalScrollIndicator = NO;
    self.agreementCollectionView.scrollEnabled = NO;
    [self.agreementCollectionView registerClass:[BC_ProjectInfoFileCollectionViewCell class] forCellWithReuseIdentifier:@"agreecell"];
    [self.contentView addSubview:self.agreementCollectionView];
    [self.agreementCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView);
        make.left.equalTo(self.contentView);
        make.top.equalTo(agreeView.mas_bottom).offset(10);
        make.height.mas_equalTo(1);
    }];
    
    UIView *matline = [JLFactoryUtil view];
    matline.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:matline];
    [matline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.agreementCollectionView.mas_bottom).offset(20);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UILabel *matreL = [JLFactoryUtil labelWithText:@"Material" font:REGULARFONT(15) textColor:kMainTextColor];
    matreL.userInteractionEnabled = YES;
    [self.contentView addSubview:matreL];
    [matreL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(matline.mas_bottom).offset(20);
        make.left.equalTo(self.contentView.mas_left).offset(15);
    }];
    
    UIImageView *matreArrow = [JLFactoryUtil imageViewWithImg:@"更多"];
    matreArrow.userInteractionEnabled = YES;
    [self.contentView addSubview:matreArrow];
    [matreArrow mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(matreL);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    UIView *matline1 = [JLFactoryUtil view];
    matline1.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:matline1];
    [matline1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(matline.mas_bottom).offset(60);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    _matline1 = matline1;
    
    UIView *matview = [JLFactoryUtil view];
    matview.backgroundColor = UIColor.clearColor;
    [self.contentView addSubview:matview];
    [matview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.centerY.equalTo(matreL);
        make.height.mas_equalTo(40);
    }];
    UITapGestureRecognizer *tapMaterial = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(pushProjectMaterial)];
    [matview addGestureRecognizer:tapMaterial];
    
    
    self.areaL.text = @"qweqwqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweqweeqggggg";
    CGSize size = [self.areaL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
    if (size.width >= (kScreenWidth - 70)) {
        size.width = kScreenWidth - 70;
    }
    [self.areaView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.size.mas_equalTo(CGSizeMake(40+size.width, 24));
    }];
    
    self.cateL.text = @"maru";
    CGSize csize = [self.cateL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
    [self.cateL mas_updateConstraints:^(MASConstraintMaker *make) {
        make.size.mas_equalTo(CGSizeMake(24+csize.width, 28));
    }];
    
    self.timeL.text = @"10:00";
    self.nameL.text = @"Entry name";
    self.descL.text = @"2021 Beijing’s sncient buildings are prosperous, and the lilac flowers of Jietai Temple";
    
    [self.picCollectionView reloadData];
    [self.picCollectionView layoutIfNeeded];
    [self.picCollectionView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.height.mas_equalTo(self.picCollectionView.collectionViewLayout.collectionViewContentSize.height);
    }];
    
    [self.contractCollectionView reloadData];
    [self.contractCollectionView layoutIfNeeded];
    [self.contractCollectionView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.height.mas_equalTo(self.contractCollectionView.collectionViewLayout.collectionViewContentSize.height);
    }];
    
    [self.agreementCollectionView reloadData];
    [self.agreementCollectionView layoutIfNeeded];
    [self.agreementCollectionView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.height.mas_equalTo(self.agreementCollectionView.collectionViewLayout.collectionViewContentSize.height);
    }];

}

#pragma mark  报价
- (void)setupGrabUI {
    
    [self.orderInfoView removeAllSubviews];
    [self.bottomBtnView removeAllSubviews];
    
    self.orderInfoView = [JLFactoryUtil view];
    [self.contentView addSubview:self.orderInfoView];
    [self.orderInfoView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(self.matline1.mas_bottom).offset(20);
        make.height.mas_equalTo(120);
    }];
    
    UILabel *oinfoL = [JLFactoryUtil labelWithText:@"Order information" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.orderInfoView addSubview:oinfoL];
    [oinfoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(self.orderInfoView.mas_top).offset(20);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Order number" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(oinfoL.mas_bottom).offset(8);
    }];
    
    self.orderNoL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderNoL];
    [self.orderNoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label1);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Creation time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(15);
    }];
    
    self.orderCreateTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderCreateTimeL];
    [self.orderCreateTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label2);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(self.orderInfoView.mas_bottom).offset(5);
    }];
    
    self.bottomBtnView = [JLFactoryUtil view];
    [self.view addSubview:self.bottomBtnView];
    [self.bottomBtnView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.view);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT);
        make.height.mas_equalTo(80);
    }];
    //抢单
    UIButton *grabBtn = [JLFactoryUtil buttonWithTitle:@"Quoted price" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [grabBtn setCorner:24 withType:JLCornerTypeAllCorner];
    grabBtn.backgroundColor = kMainThemeColor;
    [grabBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [grabBtn addTarget:self action:@selector(grabBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.bottomBtnView addSubview:grabBtn];
    [grabBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.centerY.equalTo(self.bottomBtnView);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    self.orderNoL.text = KStringIsNull(_infoModel.order_id);
    self.orderCreateTimeL.text = KStringIsNull(_infoModel.create_datetime);
}

#pragma mark  派遣单
- (void)setupAssignUI {
    
    [self.orderInfoView removeAllSubviews];
    [self.bottomBtnView removeAllSubviews];
    
    self.orderInfoView = [JLFactoryUtil view];
    [self.contentView addSubview:self.orderInfoView];
    [self.orderInfoView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(self.matline1.mas_bottom).offset(20);
        make.height.mas_equalTo(1);
    }];
    
    self.bottomBtnView = [JLFactoryUtil view];
    [self.view addSubview:self.bottomBtnView];
    [self.bottomBtnView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.view);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT);
        make.height.mas_equalTo(80);
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(self.orderInfoView.mas_bottom).offset(20);
    }];
    
    UIButton *acceptBtn = [JLFactoryUtil buttonWithTitle:@"Accept" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [acceptBtn setCorner:24 withType:JLCornerTypeAllCorner];
    acceptBtn.backgroundColor = kMainThemeColor;
    [acceptBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [acceptBtn addTarget:self action:@selector(acceptBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.bottomBtnView addSubview:acceptBtn];
    [acceptBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.bottomBtnView.mas_right).offset(-30);
        make.centerY.equalTo(self.bottomBtnView);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 100)/2, 48));
    }];
    
    UIButton *refuseBtn = [JLFactoryUtil buttonWithTitle:@"Refuse" font:MEDIUMFONT(16) textColor:kMainThemeColor];
    [refuseBtn setCorner:24 withType:JLCornerTypeAllCorner];
    refuseBtn.layer.borderWidth = 1;
    refuseBtn.layer.borderColor = kMainThemeColor.CGColor;
    refuseBtn.backgroundColor = UIColor.whiteColor;
    [refuseBtn addTarget:self action:@selector(refuseBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.bottomBtnView addSubview:refuseBtn];
    [refuseBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(acceptBtn.mas_left).offset(-40);
        make.centerY.equalTo(self.bottomBtnView);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 100)/2, 48));
    }];
}

#pragma mark  已抢单
- (void)setupHasGetOrderUI {
    
    [self.orderInfoView removeAllSubviews];
    [self.bottomBtnView removeAllSubviews];
    
    self.orderInfoView = [JLFactoryUtil view];
    [self.contentView addSubview:self.orderInfoView];
    [self.orderInfoView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(self.matline1.mas_bottom).offset(20);
        make.height.mas_equalTo(120);
    }];
    
    self.bottomBtnView = [JLFactoryUtil view];
    [self.view addSubview:self.bottomBtnView];
    [self.bottomBtnView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.view);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT);
        make.height.mas_equalTo(80);
    }];
    
    UILabel *oinfoL = [JLFactoryUtil labelWithText:@"Order information" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.orderInfoView addSubview:oinfoL];
    [oinfoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(self.orderInfoView.mas_top).offset(20);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Order number" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(oinfoL.mas_bottom).offset(8);
    }];
    
    self.orderNoL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderNoL];
    [self.orderNoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label1);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Creation time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(15);
    }];
    
    self.orderCreateTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderCreateTimeL];
    [self.orderCreateTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label2);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(self.orderInfoView.mas_bottom).offset(20);
    }];
    
    //wait
    UIButton *grabBtn = [JLFactoryUtil buttonWithTitle:@"Waiting for the successful order" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [grabBtn setCorner:24 withType:JLCornerTypeAllCorner];
    grabBtn.backgroundColor = kLightGrayTextColor;
    grabBtn.enabled = NO;
    [self.bottomBtnView addSubview:grabBtn];
    [grabBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.contentView);
        make.centerY.equalTo(self.bottomBtnView);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    self.orderNoL.text = KStringIsNull(_infoModel.order_id);
    self.orderCreateTimeL.text = KStringIsNull(_infoModel.create_datetime);
}

#pragma mark  进行中
- (void)setupInProgressUI {
    
    [self.orderInfoView removeAllSubviews];
    [self.bottomBtnView removeAllSubviews];
    
    self.orderInfoView = [JLFactoryUtil view];
    [self.contentView addSubview:self.orderInfoView];
    [self.orderInfoView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(self.matline1.mas_bottom).offset(20);
        make.height.mas_equalTo(160);
    }];
    
    self.bottomBtnView = [JLFactoryUtil view];
    [self.view addSubview:self.bottomBtnView];
    [self.bottomBtnView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.view);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT);
        make.height.mas_equalTo(80);
    }];
    
    UILabel *oinfoL = [JLFactoryUtil labelWithText:@"Order information" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.orderInfoView addSubview:oinfoL];
    [oinfoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(self.orderInfoView.mas_top).offset(20);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Order number" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(oinfoL.mas_bottom).offset(8);
    }];
    
    self.orderNoL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderNoL];
    [self.orderNoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label1);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Creation time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(15);
    }];
    
    self.orderCreateTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderCreateTimeL];
    [self.orderCreateTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label2);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label3 = [JLFactoryUtil labelWithText:@"Grab time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label3];
    [label3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label2.mas_bottom).offset(15);
    }];
    
    self.grabTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.grabTimeL];
    [self.grabTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label3);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(self.orderInfoView.mas_bottom).offset(20);
    }];
    
    UIImageView *menuImg = [JLFactoryUtil imageViewWithImg:@"房产详情菜单"];
    menuImg.userInteractionEnabled = YES;
    [self.bottomBtnView addSubview:menuImg];
    [menuImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.bottomBtnView);
        make.bottom.equalTo(self.bottomBtnView.mas_bottom);
        make.height.mas_equalTo(79);
    }];
    
    UIButton *writeLogBtn = [JLFactoryUtil buttonWithTitle:@"Write log" font:MEDIUMFONT(14) textColor:kMainTextColor];
    [writeLogBtn addTarget:self action:@selector(writeLogBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [menuImg addSubview:writeLogBtn];
    [writeLogBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(menuImg);
        make.bottom.equalTo(menuImg.mas_bottom).offset(-10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth/3, 40));
    }];
    
    UIView *groupView = [JLFactoryUtil view];
    groupView.backgroundColor = UIColor.clearColor;
    [menuImg addSubview:groupView];
    [groupView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(menuImg);
        make.bottom.equalTo(menuImg.mas_bottom).offset(0);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth/3, 75));
    }];
    UITapGestureRecognizer *tapgroup = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(pushChat)];
    [groupView addGestureRecognizer:tapgroup];
    
    UIImageView *groupImg = [JLFactoryUtil imageViewWithImg:@"群聊选中"];
    groupImg.userInteractionEnabled = YES;
    [groupView addSubview:groupImg];
    [groupImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(groupView);
        make.bottom.equalTo(groupView.mas_centerY).offset(-1);
        make.size.mas_equalTo(CGSizeMake(22, 22));
    }];
    
    UILabel *groupL = [JLFactoryUtil labelWithText:@"Group" font:MEDIUMFONT(14) textColor:kMainTextColor];
    groupL.userInteractionEnabled = YES;
    [groupView addSubview:groupL];
    [groupL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(groupView);
        make.top.equalTo(groupView.mas_centerY).offset(1);
    }];
    
    UIButton *finishBtn = [JLFactoryUtil buttonWithTitle:@"Finish" font:MEDIUMFONT(14) textColor:kMainTextColor];
    [finishBtn addTarget:self action:@selector(finishBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [menuImg addSubview:finishBtn];
    [finishBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(groupView.mas_right).offset(0);
        make.bottom.equalTo(menuImg.mas_bottom).offset(-10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth/3, 40));
    }];
    _finishBtn = finishBtn;
    
    self.orderNoL.text = KStringIsNull(_infoModel.order_id);
    self.orderCreateTimeL.text = KStringIsNull(_infoModel.create_datetime);
    self.grabTimeL.text = KStringIsNull(_infoModel.grab_time);
}

#pragma mark  完成
- (void)setupFinishUI {
    [self.orderInfoView removeAllSubviews];
    [self.bottomBtnView removeAllSubviews];
    
    self.orderInfoView = [JLFactoryUtil view];
    [self.contentView addSubview:self.orderInfoView];
    [self.orderInfoView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(self.matline1.mas_bottom).offset(20);
        make.height.mas_equalTo(200);
    }];
    
    self.bottomBtnView = [JLFactoryUtil view];
    [self.view addSubview:self.bottomBtnView];
    [self.bottomBtnView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.view);
        make.bottom.equalTo(self.view.mas_bottom).offset(-HOME_INDICATOR_HEIGHT);
        make.height.mas_equalTo(80);
    }];
    
    UILabel *oinfoL = [JLFactoryUtil labelWithText:@"Order information" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.orderInfoView addSubview:oinfoL];
    [oinfoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(self.orderInfoView.mas_top).offset(20);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Order number" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(oinfoL.mas_bottom).offset(8);
    }];
    
    self.orderNoL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderNoL];
    [self.orderNoL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label1);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Creation time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(15);
    }];
    
    self.orderCreateTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderCreateTimeL];
    [self.orderCreateTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label2);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label3 = [JLFactoryUtil labelWithText:@"Grab time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label3];
    [label3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label2.mas_bottom).offset(15);
    }];
    
    self.grabTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.grabTimeL];
    [self.grabTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label3);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    UILabel *label4 = [JLFactoryUtil labelWithText:@"Complete time" font:REGULARFONT(13) textColor:kMainTextColor];
    [self.orderInfoView addSubview:label4];
    [label4 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.orderInfoView.mas_left).offset(15);
        make.top.equalTo(label3.mas_bottom).offset(15);
    }];
    
    self.orderFinishTimeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.orderInfoView addSubview:self.orderFinishTimeL];
    [self.orderFinishTimeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(label4);
        make.right.equalTo(self.orderInfoView.mas_right).offset(-15);
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(self.orderInfoView.mas_bottom).offset(20);
    }];
    
    UIImageView *menuImg = [JLFactoryUtil imageViewWithImg:@"房产详情菜单"];
    menuImg.userInteractionEnabled = YES;
    [self.bottomBtnView addSubview:menuImg];
    [menuImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.bottomBtnView);
        make.bottom.equalTo(self.bottomBtnView.mas_bottom);
        make.height.mas_equalTo(79);
    }];
    
    UIButton *writeLogBtn = [JLFactoryUtil buttonWithTitle:@"Write log" font:MEDIUMFONT(14) textColor:kMainTextColor];
    [writeLogBtn addTarget:self action:@selector(writeLogBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [menuImg addSubview:writeLogBtn];
    [writeLogBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(menuImg);
        make.bottom.equalTo(menuImg.mas_bottom).offset(-10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth/3, 40));
    }];
    
    UIView *groupView = [JLFactoryUtil view];
    groupView.backgroundColor = UIColor.clearColor;
    [menuImg addSubview:groupView];
    [groupView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(menuImg);
        make.bottom.equalTo(menuImg.mas_bottom).offset(0);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth/3, 75));
    }];
    UITapGestureRecognizer *tapgroup = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(pushChat)];
    [groupView addGestureRecognizer:tapgroup];
    
    UIImageView *groupImg = [JLFactoryUtil imageViewWithImg:@"群聊选中"];
    groupImg.userInteractionEnabled = YES;
    [groupView addSubview:groupImg];
    [groupImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(groupView);
        make.bottom.equalTo(groupView.mas_centerY).offset(-1);
        make.size.mas_equalTo(CGSizeMake(22, 22));
    }];
    
    UILabel *groupL = [JLFactoryUtil labelWithText:@"Group" font:MEDIUMFONT(14) textColor:kMainTextColor];
    groupL.userInteractionEnabled = YES;
    [groupView addSubview:groupL];
    [groupL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(groupView);
        make.top.equalTo(groupView.mas_centerY).offset(1);
    }];
    
    UIButton *finishBtn = [JLFactoryUtil buttonWithTitle:@"Go to rate" font:MEDIUMFONT(14) textColor:kMainTextColor];
    [finishBtn addTarget:self action:@selector(gotoRate) forControlEvents:UIControlEventTouchUpInside];
    [menuImg addSubview:finishBtn];
    [finishBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(groupView.mas_right).offset(0);
        make.bottom.equalTo(menuImg.mas_bottom).offset(-10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth/3, 40));
    }];
    _finishBtn = finishBtn;
    if ([KStringIsNull(_infoModel.is_score) isEqualToString:@"1"]) {
        [finishBtn setTitle:@"View rate" forState:0];
    } else {
        [finishBtn setTitle:@"Go to rate" forState:0];
    }

    self.orderNoL.text = KStringIsNull(_infoModel.order_id);
    self.orderCreateTimeL.text = KStringIsNull(_infoModel.create_datetime);
    self.grabTimeL.text = KStringIsNull(_infoModel.grab_time);
    self.orderFinishTimeL.text = KStringIsNull(_infoModel.complte_time);
}

#pragma mark  群聊
- (void)pushChat {
    TUIChatConversationModel *model = [[TUIChatConversationModel alloc] init];
    model.groupID = KStringIsNull(_infoModel.im_groupid);
    model.title = KStringIsNull(_infoModel.name);
    BC_GroupChatViewController *chat = [[BC_GroupChatViewController alloc] init];
    chat.conversationData = model;
    [self.navigationController pushViewController:chat animated:YES];
}

#pragma mark  UICollectionView Delegate
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    if (collectionView == self.picCollectionView) {
        BC_ProjectDetailPicCollectionViewCell *cell = (BC_ProjectDetailPicCollectionViewCell *)[self.picCollectionView cellForItemAtIndexPath:indexPath];
        NSMutableArray *itemarr = [NSMutableArray array];
        for (NSString *url in self.proPicArr) {
            ZlinkPhotoGroupItem *item = [ZlinkPhotoGroupItem new];
            item.thumbView = cell;
            item.largeImageURL = [NSURL URLWithString:KStringIsNull(url)];
            [itemarr addObject:item];
        }
        ZlinkPhotoBrowserView *browser = [[ZlinkPhotoBrowserView alloc] initWithGroupItems:itemarr];
        [browser presentFromImageView:cell toContainer:self.navigationController.view animated:YES index:indexPath.item completion:^{
        }];
    } else if (collectionView == self.contractCollectionView) {
        NSDictionary *dic = self.contractArr[indexPath.item];
        BC_ProjectMaterialViewController *mater = [BC_ProjectMaterialViewController new];
        mater.linkurl = KStringIsNull(dic[@"url"]);
        [self.navigationController pushViewController:mater animated:YES];
    } else {
        NSDictionary *dic = self.agreeArr[indexPath.item];
        BC_ProjectMaterialViewController *mater = [BC_ProjectMaterialViewController new];
        mater.linkurl = KStringIsNull(dic[@"url"]);
        [self.navigationController pushViewController:mater animated:YES];
    }
}

- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    if (collectionView == self.picCollectionView) {
        BC_ProjectDetailPicCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"membercell" forIndexPath:indexPath];
        [cell setPicurl:_proPicArr[indexPath.item]];
        return cell;
    } else if (collectionView == self.contractCollectionView) {
        BC_ProjectInfoFileCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"contractcell" forIndexPath:indexPath];
        return cell;
    } else {
        BC_ProjectInfoFileCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"agreecell" forIndexPath:indexPath];
        return cell;
    }
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    if (collectionView == self.picCollectionView) {
        return self.proPicArr.count;
    } else if (collectionView == self.contractCollectionView) {
        return self.contractArr.count;
    } else {
        return self.agreeArr.count;
    }
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView {
    return 1;
}

#pragma mark  项目材料
- (void)pushProjectMaterial {
    BC_ProjectMaterialViewController *mater = [BC_ProjectMaterialViewController new];
    mater.contentStr = KStringIsNull(_infoModel.stuffs);
    [self.navigationController pushViewController:mater animated:YES];
}

#pragma mark  报价抢单
- (void)grabBtnClick {
    
    UIView *contentView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, 260)];
    contentView.backgroundColor = UIColor.whiteColor;
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Quotation amount" font:REGULARFONT(14) textColor:kMainTextColor];
    label1.numberOfLines = 0;
    [contentView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(contentView.mas_left).offset(15);
        make.top.equalTo(contentView.mas_top).offset(15);
    }];
    
    UIButton *closeBtn = [JLFactoryUtil buttonWithImage:@"关闭icon"];
    [closeBtn addTarget:self action:@selector(closeBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [contentView addSubview:closeBtn];
    [closeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(contentView.mas_right).offset(-15);
        make.centerY.equalTo(label1);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"$" font:REGULARFONT(14) textColor:kMainTextColor];
    [contentView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(contentView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(35);
        make.width.mas_equalTo(20);
    }];
    
    self.quotPriceTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(17) place:@"Please enter"];
    self.quotPriceTF.keyboardType = UIKeyboardTypeDecimalPad;
    self.quotPriceTF.textColor = kMainTextColor;
    self.quotPriceTF.delegate = self;
    [contentView addSubview:self.quotPriceTF];
    [self.quotPriceTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(label2.mas_right).offset(10);
        make.centerY.equalTo(label2);
        make.right.equalTo(contentView.mas_right).offset(-15);
        make.height.mas_equalTo(30);
    }];
    
    UIView *hline1 = [UIView new];
    hline1.backgroundColor = kColorWithHex(@"#F5F5F5");
    [contentView addSubview:hline1];
    [hline1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(contentView.mas_left).offset(15);
        make.right.equalTo(contentView.mas_right).offset(-15);
        make.top.equalTo(self.quotPriceTF.mas_bottom).offset(15);
        make.height.mas_equalTo(1);
    }];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(quotPriceSubmit:) forControlEvents:UIControlEventTouchUpInside];
    [contentView addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(contentView);
        make.top.equalTo(hline1.mas_bottom).offset(40);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    KLCPopupLayout layout = KLCPopupLayoutMake(KLCPopupHorizontalLayoutCenter, KLCPopupVerticalLayoutBottom);
    KLCPopup *popup = [KLCPopup popupWithContentView:contentView showType:KLCPopupShowTypeSlideInFromBottom dismissType:KLCPopupDismissTypeSlideOutToBottom maskType:KLCPopupMaskTypeDimmed dismissOnBackgroundTouch:NO dismissOnContentTouch:NO];
    popup.shouldHandleKeyboard = YES;
    [popup showWithLayout:layout];
    
}

#pragma mark  接受
- (void)acceptBtnClick {
    UIView *contentView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 290, 150)];
    contentView.backgroundColor = UIColor.whiteColor;
    [contentView setCorner:12 withType:JLCornerTypeAllCorner];
    
    UILabel *titleL = [JLFactoryUtil labelWithText:@"Whether to confirm the order" font:REGULARFONT(16) textColor:kMainTextColor];
    titleL.textAlignment = NSTextAlignmentCenter;
    titleL.numberOfLines = 0;
    [contentView addSubview:titleL];
    [titleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(contentView);
        make.top.equalTo(contentView.mas_top).offset(30);
        make.width.mas_lessThanOrEqualTo(260);
    }];
    
    UIView *hline = [UIView new];
    hline.backgroundColor = kColorWithHex(@"#EEEEEE");
    [contentView addSubview:hline];
    [hline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(contentView);
        make.bottom.equalTo(contentView.mas_bottom).offset(-40);
        make.height.mas_equalTo(1);
    }];
    
    UIView *vline = [UIView new];
    vline.backgroundColor = kColorWithHex(@"#EEEEEE");
    [contentView addSubview:vline];
    [vline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(contentView);
        make.top.equalTo(hline.mas_bottom);
        make.bottom.equalTo(contentView.mas_bottom);
        make.width.mas_equalTo(1);
    }];
    
    UIButton *cancelBtn = [JLFactoryUtil buttonWithTitle:@"Cancel" font:REGULARFONT(14) textColor:kMainThemeColor];
    [cancelBtn addTarget:self action:@selector(cancelAction:) forControlEvents:UIControlEventTouchUpInside];
    [contentView addSubview:cancelBtn];
    [cancelBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(contentView.mas_left).offset(15);
        make.bottom.equalTo(contentView.mas_bottom);
        make.top.equalTo(hline.mas_bottom);
        make.right.equalTo(vline.mas_left);
    }];
    
    UIButton *confirmBtn = [JLFactoryUtil buttonWithTitle:@"OK" font:REGULARFONT(14) textColor:kMainThemeColor];
    [confirmBtn addTarget:self action:@selector(confirmAcceptAction:) forControlEvents:UIControlEventTouchUpInside];
    [contentView addSubview:confirmBtn];
    [confirmBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(contentView.mas_right).offset(-15);
        make.bottom.equalTo(contentView.mas_bottom);
        make.top.equalTo(hline.mas_bottom);
        make.left.equalTo(vline.mas_right);
    }];
    
    KLCPopupLayout layout = KLCPopupLayoutMake(KLCPopupHorizontalLayoutCenter, KLCPopupVerticalLayoutCenter);
    KLCPopup *popup = [KLCPopup popupWithContentView:contentView showType:KLCPopupShowTypeShrinkIn dismissType:KLCPopupDismissTypeShrinkOut maskType:KLCPopupMaskTypeDimmed dismissOnBackgroundTouch:NO dismissOnContentTouch:NO];
    [popup showWithLayout:layout];
    
}

#pragma mark  完成项目
- (void)finishBtnClick {
    UIView *contentView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 290, 150)];
    contentView.backgroundColor = UIColor.whiteColor;
    [contentView setCorner:12 withType:JLCornerTypeAllCorner];
    
    UILabel *titleL = [JLFactoryUtil labelWithText:@"Confirm to complete the project" font:REGULARFONT(16) textColor:kMainTextColor];
    titleL.textAlignment = NSTextAlignmentCenter;
    titleL.numberOfLines = 0;
    [contentView addSubview:titleL];
    [titleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(contentView);
        make.top.equalTo(contentView.mas_top).offset(30);
        make.width.mas_lessThanOrEqualTo(260);
    }];
    
    UIView *hline = [UIView new];
    hline.backgroundColor = kColorWithHex(@"#EEEEEE");
    [contentView addSubview:hline];
    [hline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(contentView);
        make.bottom.equalTo(contentView.mas_bottom).offset(-40);
        make.height.mas_equalTo(1);
    }];
    
    UIView *vline = [UIView new];
    vline.backgroundColor = kColorWithHex(@"#EEEEEE");
    [contentView addSubview:vline];
    [vline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(contentView);
        make.top.equalTo(hline.mas_bottom);
        make.bottom.equalTo(contentView.mas_bottom);
        make.width.mas_equalTo(1);
    }];
    
    UIButton *cancelBtn = [JLFactoryUtil buttonWithTitle:@"Cancel" font:REGULARFONT(14) textColor:kMainThemeColor];
    [cancelBtn addTarget:self action:@selector(cancelAction:) forControlEvents:UIControlEventTouchUpInside];
    [contentView addSubview:cancelBtn];
    [cancelBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(contentView.mas_left).offset(15);
        make.bottom.equalTo(contentView.mas_bottom);
        make.top.equalTo(hline.mas_bottom);
        make.right.equalTo(vline.mas_left);
    }];
    
    UIButton *confirmBtn = [JLFactoryUtil buttonWithTitle:@"OK" font:REGULARFONT(14) textColor:kMainThemeColor];
    [confirmBtn addTarget:self action:@selector(confirmCompleteAction:) forControlEvents:UIControlEventTouchUpInside];
    [contentView addSubview:confirmBtn];
    [confirmBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(contentView.mas_right).offset(-15);
        make.bottom.equalTo(contentView.mas_bottom);
        make.top.equalTo(hline.mas_bottom);
        make.left.equalTo(vline.mas_right);
    }];
    
    KLCPopupLayout layout = KLCPopupLayoutMake(KLCPopupHorizontalLayoutCenter, KLCPopupVerticalLayoutCenter);
    KLCPopup *popup = [KLCPopup popupWithContentView:contentView showType:KLCPopupShowTypeShrinkIn dismissType:KLCPopupDismissTypeShrinkOut maskType:KLCPopupMaskTypeDimmed dismissOnBackgroundTouch:NO dismissOnContentTouch:NO];
    [popup showWithLayout:layout];
}

#pragma mark  确认接单
- (void)confirmAcceptAction:(UIButton *)sender {
    [sender dismissPresentingPopup];
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programexecuteuseraudit/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"id":KStringIsNull(self.pid), @"action":@"pass"} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [BaseFunction showAlert:@"Success"];
            [self setupInProgressUI];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)cancelAction:(UIButton *)sender {
    [sender dismissPresentingPopup];
}

#pragma mark  拒绝
- (void)refuseBtnClick {
    BC_ExecutorRejectProjectViewController *reject = [BC_ExecutorRejectProjectViewController new];
    reject.pid = KStringIsNull(self.pid);
    [self.navigationController pushViewController:reject animated:YES];
}

- (void)closeBtnClick:(UIButton *)sender {
    [self.quotPriceTF resignFirstResponder];
    [sender dismissPresentingPopup];
}

#pragma mark  写日志
- (void)writeLogBtnClick {
    BC_WriteLogViewController *wlog = [BC_WriteLogViewController new];
    wlog.pid = KStringIsNull(self.pid);
    [self.navigationController pushViewController:wlog animated:YES];
}

#pragma mark  确认完成
- (void)confirmCompleteAction:(UIButton *)sender {
    [sender dismissPresentingPopup];
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/completeprogram/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"id":KStringIsNull(self.pid)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [kNotificationCenter postNotificationName:@"refreshExecuList" object:nil];
            [self getFinishTime];
            [self gotoRate];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
    
}

- (void)getFinishTime {
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programdetail/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{@"id":KStringIsNull(self.pid)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            self.infoModel = [BC_ExecuteModuleModel mj_objectWithKeyValues:dataDic[@"data"]];
            [self setupFinishUI];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
    }];
}

#pragma mark  去评分
- (void)gotoRate {
    BC_ExectorAddRateViewController *rate = [BC_ExectorAddRateViewController new];
    rate.pid = KStringIsNull(self.pid);
    [self.navigationController pushViewController:rate animated:YES];
}

#pragma mark  提交报价
- (void)quotPriceSubmit:(UIButton *)sender {
    
    if ([KStringIsNull(self.quotPriceTF.text) isEqualToString:@""] || [KStringIsNull(self.quotPriceTF.text) floatValue] == 0) {
        [BaseFunction showAlert:@"Please input price"];
        return;
    }
    
    [self.quotPriceTF resignFirstResponder];
    [sender dismissPresentingPopup];
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programgrab/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"id":KStringIsNull(self.pid), @"price":KStringIsNull(self.quotPriceTF.text)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [self setupHasGetOrderUI];
            [self.navigationController pushViewController:[BC_ExecutorQuotPriceSuccViewController new] animated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
    
}

- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
    
    if (string.length == 0) {
        return YES;
    }

    BOOL isHaveDian   = NO;
    BOOL willHaveDian = NO;

    // 判断是否有小数点
    if ([textField.text containsString:@"."]) {
        isHaveDian = YES;
    } else {
        isHaveDian = NO;
    }
    
    if ([string containsString:@"."]) {
        willHaveDian = YES;
    } else {
        willHaveDian = NO;
    }
    
    if (string.length > 0) {
        
        if (string.length > 1) {
            NSString *regex = @"^(([1-9]{1}\\d*)|([0]{1}))(\\.(\\d){0,2})?$"; // 小数
            NSPredicate *pred = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", regex];
            BOOL isCode = [pred evaluateWithObject:string];
            if (!isCode) {
                KLog(@"正则-您输入的格式不正确");
                return NO;
            }
        }
    
        // 当前输入的字符
        unichar single = [string characterAtIndex:0];
        
        // 不能输入.0~9以外的字符
        if (!((single >= '0' && single <= '9') || single == '.')){
            KLog(@"您输入的格式不正确");
            return NO;
        }
        
        // 只能有一个小数点
        if (isHaveDian && single == '.') {
            KLog(@"只能输入一个小数点");
            return NO;
        }
        
        if (isHaveDian && willHaveDian) {
            KLog(@"只能输入一个小数点");
            return NO;
        }
        
        // 如果第一位是.则前面加上0
        if ((textField.text.length == 0) && (single == '.')) {
            textField.text = @"0";
        }
        
        // 如果第一位是0则后面必须输入.
        if ([textField.text hasPrefix:@"0"]) {
            if (textField.text.length > 1) {
                NSString *secondStr = [textField.text substringWithRange:NSMakeRange(1, 1)];
                if (![secondStr isEqualToString:@"."]) {
                    NSLog(@"第二个字符必须是小数点");
                    return NO;
                }
            } else {
                if (![string isEqualToString:@"."]) {
                    NSLog(@"第二个字符必须是小数点");
                    return NO;
                }
            }
        }
        
        NSInteger pointNum = 2;
        
        // 小数点后最多能输入两位
        if (isHaveDian || willHaveDian) {
            NSString *tobeString = [textField.text stringByReplacingCharactersInRange:range withString:string];
            NSRange ran = [tobeString rangeOfString:@"."];
            if ((tobeString.length - ran.location - 1) > pointNum) {
                
                NSRange r = NSMakeRange(ran.location + 1, tobeString.length - ran.location - 1);
                
                NSString *frontString  = [tobeString substringToIndex:r.location];
                NSString *behindString = [[tobeString substringWithRange:r] substringToIndex:pointNum];
                
                NSString *fianlString = [NSString stringWithFormat:@"%@%@",frontString,behindString];
            
                textField.text = fianlString;
                NSLog(@"只能输入二两位小数");
                return NO;
            }
        }
    }
    
    return YES;
}

- (void)getPageData {
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programdetail/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{@"id":KStringIsNull(self.pid)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            self.infoModel = [BC_ExecuteModuleModel mj_objectWithKeyValues:dataDic[@"data"]];
            
            self.areaL.text = kStringFormat(@"%@,%@", KStringIsNull(self.infoModel.city), KStringIsNull(self.infoModel.province));
            CGSize size = [self.areaL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
            if (size.width >= (kScreenWidth - 70)) {
                size.width = kScreenWidth - 70;
            }
            [self.areaView mas_updateConstraints:^(MASConstraintMaker *make) {
                make.size.mas_equalTo(CGSizeMake(40+size.width, 24));
            }];
            
            self.cateL.text = KStringIsNull(self.infoModel.service_type);
            CGSize csize = [self.cateL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
            [self.cateL mas_updateConstraints:^(MASConstraintMaker *make) {
                make.size.mas_equalTo(CGSizeMake(24+csize.width, 28));
            }];
            
            self.timeL.text = KStringIsNull(self.infoModel.create_datetime);
            self.nameL.text = KStringIsNull(self.infoModel.name);
            self.descL.text = KStringIsNull(self.infoModel.desc);
                        
            if (self.infoModel.images.count > 0) {
                self.proPicArr = [NSMutableArray arrayWithArray:self.infoModel.images];
            }
            if (self.infoModel.contract_files.count > 0) {
                self.contractArr = [NSMutableArray arrayWithArray:self.infoModel.contract_files];
            }
            if (self.infoModel.sideagreement_files.count > 0) {
                self.agreeArr = [NSMutableArray arrayWithArray:self.infoModel.sideagreement_files];
            }
            
            [self.picCollectionView reloadData];
            [self.picCollectionView layoutIfNeeded];
            [self.picCollectionView mas_updateConstraints:^(MASConstraintMaker *make) {
                make.height.mas_equalTo(self.picCollectionView.collectionViewLayout.collectionViewContentSize.height);
            }];
            
            [self.contractCollectionView reloadData];
            [self.contractCollectionView layoutIfNeeded];
            [self.contractCollectionView mas_updateConstraints:^(MASConstraintMaker *make) {
                make.height.mas_equalTo(self.contractCollectionView.collectionViewLayout.collectionViewContentSize.height);
            }];
            
            [self.agreementCollectionView reloadData];
            [self.agreementCollectionView layoutIfNeeded];
            [self.agreementCollectionView mas_updateConstraints:^(MASConstraintMaker *make) {
                make.height.mas_equalTo(self.agreementCollectionView.collectionViewLayout.collectionViewContentSize.height);
            }];
        
            if (self.isFromHome) {
                if (self.isFromGrab) {
                    if ([KStringIsNull(self.infoModel.status) isEqualToString:@"20"] || [KStringIsNull(self.infoModel.status) isEqualToString:@"10"]) {
                        if ([KStringIsNull(self.infoModel.audit_status) isEqualToString:@"20"]) {
                            //已报价
                            [self setupHasGetOrderUI];
                        } else {
                            [self setupGrabUI];
                        }
                    } else if ([KStringIsNull(self.infoModel.status) isEqualToString:@"30"]) {
                        [self setupInProgressUI];
                    } else if ([KStringIsNull(self.infoModel.status) isEqualToString:@"40"]|| [KStringIsNull(self.infoModel.status) isEqualToString:@"50"]) {
                        [self setupFinishUI];
                    } else {
                        [self setupGrabUI];
                    }
                                        
                } else {
                    if ([KStringIsNull(self.infoModel.status) isEqualToString:@"20"] || [KStringIsNull(self.infoModel.status) isEqualToString:@"10"]) {
                        [self setupAssignUI];
                    } else if ([KStringIsNull(self.infoModel.status) isEqualToString:@"30"]) {
                        [self setupInProgressUI];
                    } else if ([KStringIsNull(self.infoModel.status) isEqualToString:@"40"]|| [KStringIsNull(self.infoModel.status) isEqualToString:@"50"]) {
                        [self setupFinishUI];
                    }
                }
            } else {
                if ([KStringIsNull(self.infoModel.status) isEqualToString:@"20"] || [KStringIsNull(self.infoModel.status) isEqualToString:@"10"]) {
                    [self setupHasGetOrderUI];
                } else if ([KStringIsNull(self.infoModel.status) isEqualToString:@"30"]) {
                    [self setupInProgressUI];
                } else if ([KStringIsNull(self.infoModel.status) isEqualToString:@"40"]|| [KStringIsNull(self.infoModel.status) isEqualToString:@"50"]) {
                    [self setupFinishUI];
                }
            }
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

@end
