//
//  BC_ExecutorRejectProjectViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/23.
//

#import "BC_ExecutorRejectProjectViewController.h"

@interface BC_ExecutorRejectProjectViewController ()
@property (nonatomic, strong) YYTextView *descTV;
@end

@implementation BC_ExecutorRejectProjectViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Refuse";
    [self setupUI];
}

- (void)setupUI {
    UIView *bgview = [JLFactoryUtil view];
    bgview.backgroundColor = kColorWithHex(@"#F5F5F5");
    [bgview setCorner:4 withType:JLCornerTypeAllCorner];
    [self.view addSubview:bgview];
    [bgview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(15);
        make.top.equalTo(self.view.mas_top).offset(15);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 160));
    }];
    
    self.descTV = [YYTextView new];
    self.descTV.placeholderFont = REGULARFONT(14);
    self.descTV.placeholderText = @"Please enter the reason for rejection";
    self.descTV.placeholderTextColor = kLightGrayTextColor;
    self.descTV.textColor = kMainTextColor;
    self.descTV.font = REGULARFONT(14);
    [bgview addSubview:self.descTV];
    [self.descTV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(bgview).insets(UIEdgeInsetsMake(10, 10, 10, 10));
    }];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitAction) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.view);
        make.top.equalTo(bgview.mas_bottom).offset(60);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
}

#pragma mark  提交
- (void)submitAction {
    if ([KStringIsNull(self.descTV.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please input content"];
        return;
    }
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/programexecuteuseraudit/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"id":KStringIsNull(self.pid), @"action":@"deny", @"reason":KStringIsNull(self.descTV.text)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [self showAlert];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
    
}

- (void)showAlert {
    UIImageView *contentView = [JLFactoryUtil imageViewWithImg:@"拒绝接单弹窗"];
    contentView.frame = CGRectMake(0, 0, 290, 200);
    contentView.userInteractionEnabled = YES;
    
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(closeAlert:)];
    [contentView addGestureRecognizer:tap];
        
    KLCPopupLayout layout = KLCPopupLayoutMake(KLCPopupHorizontalLayoutCenter, KLCPopupVerticalLayoutCenter);
    KLCPopup *popup = [KLCPopup popupWithContentView:contentView showType:KLCPopupShowTypeShrinkIn dismissType:KLCPopupDismissTypeShrinkOut maskType:KLCPopupMaskTypeDimmed dismissOnBackgroundTouch:NO dismissOnContentTouch:NO];
    [popup showWithLayout:layout];
}

- (void)closeAlert:(UIGestureRecognizer *)ges {
    [[ges view] dismissPresentingPopup];
    [self.navigationController popToRootViewControllerAnimated:YES];
}
@end
