//
//  BC_ExecutorProjectListViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/23.
//

#import "BC_ExecutorProjectListViewController.h"
#import "BC_ExecutorProjectSubListViewController.h"

#import <JXCategoryView.h>
@interface BC_ExecutorProjectListViewController ()<JXCategoryViewDelegate, JXCategoryListContainerViewDelegate>
@property (nonatomic, strong) JXCategoryTitleView *categoryView;
@property (nonatomic, strong) JXCategoryListContainerView *listContainerView;


@end

@implementation BC_ExecutorProjectListViewController
- (void)dealloc {
    [kNotificationCenter removeObserver:self];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"My project";
    self.isShowLeftBackBtn = NO;
    [kNotificationCenter addObserver:self selector:@selector(refreshPage) name:@"refreshExecuList" object:nil];
    [kNotificationCenter addObserver:self selector:@selector(refreshPage) name:@"refreshExecuListAfterEva" object:nil];
    [self setupUI];
}

- (void)refreshPage {
    [self.categoryView reloadData];
}

- (void)setupUI {
    self.categoryView = [[JXCategoryTitleView alloc] initWithFrame:CGRectMake(15, 5, kScreenWidth - 30, 40)];
    self.categoryView.delegate = self;
    self.categoryView.backgroundColor = kColorWithHex(@"#F5F5F5");
    self.categoryView.cellSpacing = 0;
    self.categoryView.titleColor = kMainTextColor;
    self.categoryView.titleSelectedColor = UIColor.whiteColor;
    self.categoryView.titleFont = REGULARFONT(15);
    self.categoryView.titleSelectedFont = REGULARFONT(15);
    self.categoryView.defaultSelectedIndex = 0;
    self.categoryView.titleColorGradientEnabled = YES;
    self.categoryView.averageCellSpacingEnabled = YES;
    self.categoryView.titles = @[@"Grab order", @"Process", @"Completed"];
    self.categoryView.cellWidth = (kScreenWidth - 30)/3;
    self.categoryView.layer.masksToBounds = YES;
    self.categoryView.layer.cornerRadius = 20;
    
    JXCategoryIndicatorBackgroundView *backgroundView = [[JXCategoryIndicatorBackgroundView alloc] init];
    backgroundView.indicatorWidth = (kScreenWidth - 30)/3-10;
    backgroundView.indicatorHeight = 36;
    backgroundView.indicatorCornerRadius = 18;
    backgroundView.indicatorColor = kMainThemeColor;
    [backgroundView setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 0) radius:8];
//    backgroundView.indicatorWidthIncrement = 60;
    self.categoryView.indicators = @[backgroundView];
    [self.view addSubview:self.categoryView];
    
    self.listContainerView = [[JXCategoryListContainerView alloc] initWithType:JXCategoryListContainerType_ScrollView delegate:self];
    self.listContainerView.frame = CGRectMake(0, 50, kScreenWidth, kScreenHeight - kTopHeight - 50 - kTabBarHeight);
    [self.view addSubview:self.listContainerView];
    self.categoryView.listContainer = self.listContainerView;
}

#pragma mark - JXCategoryViewDelegate
- (id<JXCategoryListContentViewDelegate>)listContainerView:(JXCategoryListContainerView *)listContainerView initListForIndex:(NSInteger)index {
    BC_ExecutorProjectSubListViewController *list = [BC_ExecutorProjectSubListViewController new];
    list.index = index;
    return list;
}

- (NSInteger)numberOfListsInlistContainerView:(JXCategoryListContainerView *)listContainerView {
    return 3;
}

@end
