//
//  BC_ExectorProjectListTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/23.
//

#import "BC_ExectorProjectListTableViewCell.h"
#import "BC_ExecuteModuleModel.h"
@implementation BC_ExectorProjectListTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    
    self.cateL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(14) textColor:UIColor.whiteColor];
    self.cateL.layer.masksToBounds = YES;
    self.cateL.layer.cornerRadius = 14;
    self.cateL.textAlignment = NSTextAlignmentCenter;
    self.cateL.backgroundColor = kColorWithHex(@"#05A833");
    [self.contentView addSubview:self.cateL];
    [self.cateL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
        make.size.mas_equalTo(CGSizeMake(30, 28));
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(12) textColor:kLightGrayTextColor];
    self.timeL.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.cateL.mas_centerY);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.width.mas_equalTo(120);
    }];
    
    self.proNameL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:self.proNameL];
    [self.proNameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.cateL.mas_right).offset(10);
        make.centerY.equalTo(self.cateL);
        make.right.lessThanOrEqualTo(self.timeL.mas_left).offset(-5);
    }];
    
    self.contentL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kColorWithHex(@"#777777")];
    self.contentL.numberOfLines = 2;
    [self.contentView addSubview:self.contentL];
    [self.contentL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.cateL.mas_bottom).offset(8);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.imgview1 = [JLFactoryUtil imageView];
    [self.imgview1 setCorner:5 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.imgview1];
    [self.imgview1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentL.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 40)/3, (kScreenWidth - 40)/3));
    }];
    
    self.imgview2 = [JLFactoryUtil imageView];
    [self.imgview2 setCorner:5 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.imgview2];
    [self.imgview2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.imgview1.mas_right).offset(5);
        make.top.equalTo(self.contentL.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 40)/3, (kScreenWidth - 40)/3));
    }];
    
    self.imgview3 = [JLFactoryUtil imageView];
    [self.imgview3 setCorner:5 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.imgview3];
    [self.imgview3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.imgview2.mas_right).offset(5);
        make.top.equalTo(self.contentL.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 40)/3, (kScreenWidth - 40)/3));
    }];
    
    self.areaView = [JLFactoryUtil view];
    self.areaView.backgroundColor = kColorWithHex(@"#ECF8EF");
    [self.areaView setCorner:12 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.areaView];
    [self.areaView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.imgview1.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake(30, 24));
        make.bottom.equalTo(self.contentView.mas_bottom).offset(-20);
    }];
    
    UIImageView *areaImg = [JLFactoryUtil imageViewWithImg:@"位置"];
    [self.areaView addSubview:areaImg];
    [areaImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(self.areaView.mas_left).offset(10);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    self.areaL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kColorWithHex(@"#05A833")];
    [self.areaView addSubview:self.areaL];
    [self.areaL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(areaImg.mas_right).offset(4);
        make.width.mas_lessThanOrEqualTo(kScreenWidth - 170);
    }];
    
    UIButton *repBtn = [JLFactoryUtil buttonWithImage:@"屏蔽"];
    [repBtn setTitle:@"shield" forState:0];
    repBtn.titleLabel.font = REGULARFONT(14);
    [repBtn setTitleColor:kMainTextColor forState:0];
    repBtn.titleEdgeInsets = UIEdgeInsetsMake(0, 5, 0, 0);
    [repBtn addTarget:self action:@selector(repBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:repBtn];
    [repBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-10);
        make.centerY.equalTo(self.areaView);
        make.size.mas_equalTo(CGSizeMake(90, 20));
    }];
    
    self.accomplishBtn = [JLFactoryUtil buttonWithTitle:@"accomplish" font:REGULARFONT(15) textColor:kMainThemeColor];
    [self.accomplishBtn setCorner:18 withType:JLCornerTypeAllCorner];
    self.accomplishBtn.layer.borderWidth = 1;
    self.accomplishBtn.layer.borderColor = kMainThemeColor.CGColor;
//    [self.accomplishBtn addTarget:self action:@selector(accomplishBtnClick) forControlEvents:UIControlEventTouchUpInside];
    self.accomplishBtn.enabled = NO;
    [self.contentView addSubview:self.accomplishBtn];
    
    self.executorToEvaBtn = [JLFactoryUtil buttonWithTitle:@"View rate" font:REGULARFONT(15) textColor:kMainThemeColor];
    [self.executorToEvaBtn setCorner:18 withType:JLCornerTypeAllCorner];
    self.executorToEvaBtn.layer.borderWidth = 1;
    self.executorToEvaBtn.layer.borderColor = kMainThemeColor.CGColor;
//    [self.executorToEvaBtn addTarget:self action:@selector(executorToEvaBtnClick) forControlEvents:UIControlEventTouchUpInside];
    self.executorToEvaBtn.enabled = NO;
    [self.contentView addSubview:self.executorToEvaBtn];
}

- (void)repBtnClick {
    if (self.delegate && [self.delegate respondsToSelector:@selector(shieldItem:)]) {
        [self.delegate shieldItem:_model];
    }
}

- (void)setPageIndex:(NSInteger)pageIndex {
    _pageIndex = pageIndex;
    if (pageIndex == 0) {
        self.accomplishBtn.hidden = YES;
        self.executorToEvaBtn.hidden = YES;

    } else if (pageIndex == 1) {
        self.accomplishBtn.hidden = NO;
        self.executorToEvaBtn.hidden = YES;
        
        [self.accomplishBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(self.contentView.mas_right).offset(-15);
            make.top.equalTo(self.areaView.mas_bottom).offset(15);
            make.size.mas_equalTo(CGSizeMake(110, 36));
        }];
        
    } else if (pageIndex == 2) {
        self.accomplishBtn.hidden = YES;
        self.executorToEvaBtn.hidden = NO;
        [self.executorToEvaBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(self.contentView.mas_right).offset(-15);
            make.top.equalTo(self.areaView.mas_bottom).offset(15);
            make.size.mas_equalTo(CGSizeMake(110, 36));
        }];

    }
}

- (void)accomplishBtnClick {
    if (self.delegate && [self.delegate respondsToSelector:@selector(finishTheProject)]) {
        [self.delegate finishTheProject];
    }
}

- (void)executorToEvaBtnClick {
    if (self.delegate && [self.delegate respondsToSelector:@selector(goToRateTheProject)]) {
        [self.delegate goToRateTheProject];
    }
}

- (void)setModel:(BC_ExecuteModuleModel *)model {
    _model = model;
    if ([KStringIsNull(model.is_score) isEqualToString:@"1"]) {
        [self.executorToEvaBtn setTitle:@"View rate" forState:0];
    } else {
        [self.executorToEvaBtn setTitle:@"Go to rate" forState:0];
    }
    
    if ([KStringIsNull(model.create_datetime) componentsSeparatedByString:@" "].count > 0) {
        self.timeL.text = KStringIsNull([KStringIsNull(model.create_datetime) componentsSeparatedByString:@" "].firstObject);
    } else {
        self.timeL.text = KStringIsNull(model.create_datetime);
    }
    self.proNameL.text = KStringIsNull(model.name);
    self.contentL.text = KStringIsNull(model.desc);

    self.cateL.text = KStringIsNull(model.service_type);
    CGSize csize = [self.cateL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
    [self.cateL mas_updateConstraints:^(MASConstraintMaker *make) {
        make.size.mas_equalTo(CGSizeMake(24+csize.width, 28));
    }];
    
    if (model.images.count == 0) {
        self.imgview1.hidden = YES;
        self.imgview2.hidden = YES;
        self.imgview3.hidden = YES;
        if (_pageIndex == 0) {
            [self.areaView mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.left.equalTo(self.contentView.mas_left).offset(15);
                make.top.equalTo(self.contentL.mas_bottom).offset(12);
                make.size.mas_equalTo(CGSizeMake(30, 24));
                make.bottom.equalTo(self.contentView.mas_bottom).offset(-20);
            }];
        } else {
            [self.areaView mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.left.equalTo(self.contentView.mas_left).offset(15);
                make.top.equalTo(self.contentL.mas_bottom).offset(12);
                make.size.mas_equalTo(CGSizeMake(30, 24));
                make.bottom.equalTo(self.contentView.mas_bottom).offset(-66);
            }];
        }
    } else {
        if (_pageIndex == 0) {
            [self.areaView mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.left.equalTo(self.contentView.mas_left).offset(15);
                make.top.equalTo(self.imgview1.mas_bottom).offset(8);
                make.size.mas_equalTo(CGSizeMake(30, 24));
                make.bottom.equalTo(self.contentView.mas_bottom).offset(-20);
            }];
        } else {
            [self.areaView mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.left.equalTo(self.contentView.mas_left).offset(15);
                make.top.equalTo(self.imgview1.mas_bottom).offset(12);
                make.size.mas_equalTo(CGSizeMake(30, 24));
                make.bottom.equalTo(self.contentView.mas_bottom).offset(-66);
            }];
        }
        
        NSArray *imgarr = model.images;
        if (imgarr.count == 1) {
            self.imgview1.hidden = NO;
            self.imgview2.hidden = YES;
            self.imgview3.hidden = YES;
            [self.imgview1 sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(imgarr[0])] placeholderImage:kPlaceHolderImg];
        } else if (imgarr.count == 2) {
            self.imgview1.hidden = NO;
            self.imgview2.hidden = NO;
            self.imgview3.hidden = YES;
            [self.imgview1 sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(imgarr[0])] placeholderImage:kPlaceHolderImg];
            [self.imgview2 sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(imgarr[1])] placeholderImage:kPlaceHolderImg];
        } if (imgarr.count >= 3) {
            self.imgview1.hidden = NO;
            self.imgview2.hidden = NO;
            self.imgview3.hidden = NO;
            [self.imgview1 sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(imgarr[0])] placeholderImage:kPlaceHolderImg];
            [self.imgview2 sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(imgarr[1])] placeholderImage:kPlaceHolderImg];
            [self.imgview3 sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(imgarr[2])] placeholderImage:kPlaceHolderImg];
        }
        
    }
    
    self.areaL.text = kStringFormat(@"%@,%@", KStringIsNull(model.city), KStringIsNull(model.province));
    CGSize size = [self.areaL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
    if (size.width >= (kScreenWidth - 170)) {
        size.width = kScreenWidth - 170;
    }
    [self.areaView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.size.mas_equalTo(CGSizeMake(40+size.width, 24));
    }];
}
@end
