//
//  BC_CreatePostViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/17.
//

#import "BC_CreatePostViewController.h"
#import "BC_CreatePostSuccViewController.h"

#import <TZImagePickerController.h>
#import "BC_UploadImgCollectionViewCell.h"
#import "ZlinkPhotoBrowserView.h"
#import <AVKit/AVKit.h>
#import "BRAddressPickerView.h"

#import "BC_UploadImgModel.h"
@interface BC_CreatePostViewController ()<TZImagePickerControllerDelegate, UICollectionViewDelegate, UICollectionViewDataSource, BC_UploadImgCollectionViewCellDelegate>
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;
@property (nonatomic, strong) UITextField *nameTF;
@property (nonatomic, strong) YYTextView *descTF;
@property (nonatomic, strong) UITextField *locationTF;
@property (nonatomic, strong) UITextField *addressTF;
@property (nonatomic, strong) BRAddressPickerView *areaPicker;

@property (nonatomic, strong) UICollectionView *photoCollectionView;
@property (nonatomic, copy) NSString *tempVideoPath;
@property (nonatomic, copy) NSString *uploadVideoUrl;
@property (nonatomic, strong) NSMutableArray *imgArr;
@property (nonatomic, strong) NSMutableArray *areaArr;
@property (nonatomic, copy) NSString *selectCityID;
@end

@implementation BC_CreatePostViewController
- (void)backBtnClicked {
    [self dismissViewControllerAnimated:YES completion:nil];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.isHidenNaviBar = YES;
    self.imgArr = [NSMutableArray array];
    self.areaArr = [NSMutableArray array];
    self.selectCityID = @"";
    
    BC_UploadImgModel *model = [BC_UploadImgModel new];
    model.type = @"add";
    model.imgurl = @"";
    [self.imgArr addObject:model];
    self.tempVideoPath = @"";
    self.uploadVideoUrl = @"";
    [self setupUI];
    
    [self getCityList];
}

- (void)setupUI {
    
    UIView *topNav = [JLFactoryUtil view];
    topNav.frame = CGRectMake(0, 0, kScreenWidth, kTopHeight);
    topNav.backgroundColor = UIColor.whiteColor;
    [self.view addSubview:topNav];
    
    UILabel *navL = [JLFactoryUtil labelWithText:@"New post" font:MEDIUMFONT(26) textColor:kMainTextColor];
    [topNav addSubview:navL];
    [navL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(topNav.mas_left).offset(15);
        make.bottom.equalTo(topNav.mas_bottom).offset(-5);
    }];
    
    UIButton *closeBtn = [JLFactoryUtil buttonWithImage:@"关闭icon"];
    [closeBtn addTarget:self action:@selector(backBtnClicked) forControlEvents:UIControlEventTouchUpInside];
    [topNav addSubview:closeBtn];
    [closeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(navL);
        make.right.equalTo(topNav.mas_right).offset(-15);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, kTopHeight, kScreenWidth, kScreenHeight - kTopHeight - HOME_INDICATOR_HEIGHT)];
    self.scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:self.scrollView];
    
    self.contentView = [UIView new];
    self.contentView.backgroundColor = [UIColor whiteColor];
    [self.scrollView addSubview:self.contentView];
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.scrollView);
        make.width.equalTo(self.scrollView);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Post name" font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
    }];
    
    self.nameTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(14) place:@"Fill in the title"];
    self.nameTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.nameTF];
    [self.nameTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    CALayer *layer = [CALayer layer];
    layer.frame = CGRectMake(0, 29, kScreenWidth - 30, 1);
    layer.backgroundColor = kColorWithHex(@"#F2F2F2").CGColor;
    [self.nameTF.layer addSublayer:layer];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Describe" font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.nameTF.mas_bottom).offset(20);
    }];
    
    UIView *descView = [JLFactoryUtil view];
    [descView setCorner:4 withType:JLCornerTypeAllCorner];
    descView.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:descView];
    [descView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label2.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 120));
    }];
    
    self.descTF = [YYTextView new];
    self.descTF.placeholderFont = REGULARFONT(14);
    self.descTF.placeholderText = @"Add text";
    self.descTF.placeholderTextColor = kLightGrayTextColor;
    [descView addSubview:self.descTF];
    [self.descTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(descView).insets(UIEdgeInsetsMake(10, 10, 10, 10));
    }];
    
    NSString *typeText = @"";
    if ([_type isEqualToString:@"1"]) {
        typeText = @"Photos";
    } else {
        typeText = @"Video";
    }
    UILabel *label3 = [JLFactoryUtil labelWithText:typeText font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label3];
    [label3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(descView.mas_bottom).offset(20);
    }];
    
    UICollectionViewFlowLayout *layout = [UICollectionViewFlowLayout new];
    layout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
    layout.minimumInteritemSpacing = 1;
    layout.minimumLineSpacing = 10;
    layout.itemSize = CGSizeMake(107, 107);
    layout.sectionInset = UIEdgeInsetsMake(10, 15, 10, 15);
    self.photoCollectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:layout];
    self.photoCollectionView.delegate = self;
    self.photoCollectionView.dataSource = self;
    self.photoCollectionView.backgroundColor = UIColor.clearColor;
    self.photoCollectionView.showsHorizontalScrollIndicator = NO;
    [self.photoCollectionView registerClass:[BC_UploadImgCollectionViewCell class] forCellWithReuseIdentifier:@"photocell"];
    [self.contentView addSubview:self.photoCollectionView];
    [self.photoCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView);
        make.left.equalTo(self.contentView);
        make.top.equalTo(label3.mas_bottom).offset(10);
        make.height.mas_equalTo(130);
    }];
    
    UIView *line1 = [JLFactoryUtil view];
    line1.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line1];
    [line1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.photoCollectionView.mas_bottom).offset(15);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UIView *line2 = [JLFactoryUtil view];
    line2.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line2];
    [line2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line1.mas_bottom).offset(52);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UIView *line3 = [JLFactoryUtil view];
    line3.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line3];
    [line3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line2.mas_bottom).offset(52);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UIView *areaView = [JLFactoryUtil view];
    [self.contentView addSubview:areaView];
    [areaView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.top.equalTo(line1.mas_bottom);
        make.bottom.equalTo(line2.mas_top);
    }];
    
    UIImageView *locImg = [JLFactoryUtil imageViewWithImg:@"位置"];
    [areaView addSubview:locImg];
    [locImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(areaView);
        make.left.equalTo(areaView.mas_left).offset(15);
        make.size.mas_equalTo(CGSizeMake(22, 22));
    }];
    
    self.locationTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(15) place:@"location"];
    self.locationTF.textColor = kColorWithHex(@"#05A833");
    [areaView addSubview:self.locationTF];
    [self.locationTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(areaView);
        make.left.equalTo(locImg.mas_right).offset(10);
        make.right.equalTo(areaView.mas_right).offset(-46);
        make.height.mas_equalTo(35);
    }];
    
    UIView *locClear = [JLFactoryUtil view];
    locClear.backgroundColor = UIColor.clearColor;
    [self.contentView addSubview:locClear];
    [locClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.centerY.equalTo(locImg);
        make.height.mas_equalTo(35);
    }];
    UITapGestureRecognizer *tapLoc = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseLoc)];
    [locClear addGestureRecognizer:tapLoc];
    
    self.addressTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(14) place:@"Please enter your full address"];
    self.addressTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.addressTF];
    [self.addressTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line2.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(line3.mas_bottom).offset(24);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(submitBtn.mas_bottom).offset(35);
    }];
}

#pragma mark  UICollectionView Delegate
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    if ([_type isEqualToString:@"1"]) {
        
        BC_UploadImgModel *model = self.imgArr[indexPath.item];
        if ([KStringIsNull(model.type) isEqualToString:@"add"]) {
            if (self.imgArr.count > 9) {
                [BaseFunction showAlert:@"The maximum number of pictures is 9"];
                return;
            }
            [self showChoosePic];
        } else {
            NSMutableArray *itemarr = [NSMutableArray array];
            for (BC_UploadImgModel *m in self.imgArr) {
                if ([KStringIsNull(m.type) isEqualToString:@""]) {
                    ZlinkPhotoGroupItem *item = [ZlinkPhotoGroupItem new];
                    item.thumbView = self.photoCollectionView;
                    item.largeImageURL = [NSURL URLWithString:KStringIsNull(m.imgurl)];
                    item.showimg = m.img;
                    [itemarr addObject:item];
                }
            }
            ZlinkPhotoBrowserView *browser = [[ZlinkPhotoBrowserView alloc] initWithGroupItems:itemarr];
            [browser presentFromImageView:self.photoCollectionView toContainer:self.navigationController.view animated:YES index:indexPath.item completion:^{
            }];
        }
    } else {
        
        
        
        BC_UploadImgModel *model = self.imgArr[indexPath.item];
        if ([KStringIsNull(model.type) isEqualToString:@"add"]) {
            if (self.imgArr.count > 1) {
                [BaseFunction showAlert:@"Only one video can be uploaded"];
                return;
            }
            [self showChooseVideo];
        } else {
            NSString *encodedString = [KStringIsNull(model.serviceVideoPath) stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
            NSURL *url = [NSURL URLWithString:encodedString];
            AVPlayer *player = [AVPlayer playerWithURL:url];
            AVPlayerViewController *playerViewController = [AVPlayerViewController new];
            playerViewController.player = player;
            [self presentViewController:playerViewController animated:YES completion:^{
                [player play];
            }];
        }
    }
    
}

- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    BC_UploadImgCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"photocell" forIndexPath:indexPath];
    cell.delegate = self;
    [cell setModel:_imgArr[indexPath.item]];
    return cell;
}

- (void)removeImgModel:(BC_UploadImgModel *)model {
    [self.imgArr removeObject:model];
    [self.photoCollectionView reloadData];
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    return self.imgArr.count;
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView {
    return 1;
}

- (void)showChoosePic {
    TZImagePickerController *imagePickerVc = [[TZImagePickerController alloc] initWithMaxImagesCount:9 - self.imgArr.count + 1 delegate:self];
    imagePickerVc.barItemTextColor = [UIColor whiteColor];
    [imagePickerVc.navigationBar setTitleTextAttributes:@{NSForegroundColorAttributeName : [UIColor whiteColor]}];
    imagePickerVc.navigationBar.tintColor = [UIColor whiteColor];
    if (@available(iOS 15.0, *)) {
        UINavigationBarAppearance *barApp = [UINavigationBarAppearance new];
        barApp.backgroundColor = [UIColor whiteColor];
        barApp.shadowColor = [UIColor clearColor];
        imagePickerVc.navigationController.navigationBar.scrollEdgeAppearance = barApp;
        imagePickerVc.navigationController.navigationBar.standardAppearance = barApp;
    } else {
        imagePickerVc.navigationBar.barTintColor = [UIColor whiteColor];
    }
    imagePickerVc.oKButtonTitleColorDisabled = [UIColor lightGrayColor];
    imagePickerVc.navigationBar.translucent = NO;
    imagePickerVc.iconThemeColor = kMainThemeColor;
    imagePickerVc.showSelectedIndex = YES;
    imagePickerVc.allowTakePicture = YES;
    imagePickerVc.allowTakeVideo = NO;   // 在内部显示拍视频按
    imagePickerVc.showPhotoCannotSelectLayer = YES;
    imagePickerVc.cannotSelectLayerColor = [[UIColor whiteColor] colorWithAlphaComponent:0.8];
    imagePickerVc.allowPickingVideo = NO;
    imagePickerVc.allowPickingOriginalPhoto = NO;
    imagePickerVc.allowPickingImage = YES;
    imagePickerVc.allowPickingGif = NO;
    imagePickerVc.statusBarStyle = UIStatusBarStyleDefault;
    imagePickerVc.preferredLanguage = @"en";
    imagePickerVc.modalPresentationStyle = UIModalPresentationFullScreen;
    [self presentViewController:imagePickerVc animated:YES completion:nil];
}

- (void)tz_imagePickerControllerDidCancel:(TZImagePickerController *)picker {
}

- (void)imagePickerController:(TZImagePickerController *)picker didFinishPickingPhotos:(NSArray<UIImage *> *)photos sourceAssets:(NSArray *)assets isSelectOriginalPhoto:(BOOL)isSelectOriginalPhoto {
    if (photos.count > 0) {
        for (UIImage *img in photos) {
            BC_UploadImgModel *model = [BC_UploadImgModel new];
            model.type = @"";
            model.img = img;
            [self.imgArr insertObject:model atIndex:0];
        }
        [self.photoCollectionView reloadData];
    }
}

- (void)showChooseVideo {
    TZImagePickerController *imagePickerVc = [[TZImagePickerController alloc] initWithMaxImagesCount:1 delegate:self];
    imagePickerVc.barItemTextColor = [UIColor whiteColor];
    [imagePickerVc.navigationBar setTitleTextAttributes:@{NSForegroundColorAttributeName : [UIColor whiteColor]}];
    imagePickerVc.navigationBar.tintColor = [UIColor whiteColor];
    if (@available(iOS 15.0, *)) {
        UINavigationBarAppearance *barApp = [UINavigationBarAppearance new];
        barApp.backgroundColor = [UIColor whiteColor];
        barApp.shadowColor = [UIColor clearColor];
        imagePickerVc.navigationController.navigationBar.scrollEdgeAppearance = barApp;
        imagePickerVc.navigationController.navigationBar.standardAppearance = barApp;
    } else {
        imagePickerVc.navigationBar.barTintColor = [UIColor whiteColor];
    }
    imagePickerVc.oKButtonTitleColorDisabled = [UIColor lightGrayColor];
    imagePickerVc.navigationBar.translucent = NO;
    imagePickerVc.iconThemeColor = kMainThemeColor;
    imagePickerVc.showSelectedIndex = YES;
    imagePickerVc.allowTakePicture = NO;
    imagePickerVc.allowTakeVideo = YES;   // 在内部显示拍视频按
    imagePickerVc.showPhotoCannotSelectLayer = YES;
    imagePickerVc.cannotSelectLayerColor = [[UIColor whiteColor] colorWithAlphaComponent:0.8];
    imagePickerVc.allowPickingVideo = YES;
    imagePickerVc.allowPickingOriginalPhoto = NO;
    imagePickerVc.allowPickingImage = NO;
    imagePickerVc.allowPickingGif = NO;
    imagePickerVc.allowPickingMultipleVideo = NO;
    imagePickerVc.statusBarStyle = UIStatusBarStyleDefault;
    imagePickerVc.preferredLanguage = @"en";
    imagePickerVc.modalPresentationStyle = UIModalPresentationFullScreen;
    [self presentViewController:imagePickerVc animated:YES completion:nil];
}

- (void)imagePickerController:(TZImagePickerController *)picker didFinishPickingVideo:(UIImage *)coverImage sourceAssets:(PHAsset *)asset {
    dispatch_async(dispatch_get_main_queue(), ^{
        
        [MBProgressHUD showHUDAddTo:self.view alertMsg:@"Processing video..." animated:YES];
    });
    [[TZImageManager manager] getVideoOutputPathWithAsset:asset presetName:AVAssetExportPresetMediumQuality success:^(NSString *outputPath) {
        dispatch_async(dispatch_get_main_queue(), ^{
            [MBProgressHUD hideHUDForView:self.view animated:YES];
        });
        KLog(@"视频导出到本地完成,沙盒路径为:%@",outputPath);
        self.tempVideoPath = KStringIsNull(outputPath);
        [self uploadVideo:[NSURL fileURLWithPath:self.tempVideoPath] coverImg:coverImage];
    } failure:^(NSString *errorMessage, NSError *error) {
        dispatch_async(dispatch_get_main_queue(), ^{
            [MBProgressHUD hideHUDForView:self.view animated:YES];
        });
    }];
}

//- (BOOL)isAssetCanBeDisplayed:(PHAsset *)asset {
//    switch (asset.mediaType) {
//        case PHAssetMediaTypeVideo: {
//            // 视频时长
//            NSTimeInterval duration = asset.duration;
//            if (duration > 61) {
//                return NO;
//            } else {
//                return YES;
//            }
//
//        } break;
//        case PHAssetMediaTypeImage: {
//            return YES;
//        } break;
//        case PHAssetMediaTypeAudio:
//            return NO;
//            break;
//        case PHAssetMediaTypeUnknown:
//            return NO;
//            break;
//        default: break;
//    }
//    return YES;
//}

- (void)chooseLoc {
    if (self.areaArr.count == 0) return;

    [self.view endEditing:YES];
    [self.areaPicker show];
}

#pragma mark  上传图片
- (void)uploadAllImg {
    
    if (self.imgArr.count == 1) {
        [BaseFunction showAlert:@"Please upload picture"];
        return;
    }
                
    [MBProgressHUD showHUDAddTo:kAppWindow alertMsg:@"Uploading..." animated:YES];
    
    [self.imgArr enumerateObjectsUsingBlock:^(BC_UploadImgModel *  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        if ([KStringIsNull(obj.type) isEqualToString:@""]) {
            if ([KStringIsNull(obj.imgurl) isEqualToString:@""]) {
                UIImage *newImage;
                if (obj.img.size.width > 1024) {  //分辨率大的则重绘，否则不重绘
                    //获取原图片宽高比
                    CGFloat sourceImageAspectRatio = obj.img.size.width/obj.img.size.height;
                    CGSize newSize = CGSizeMake(1024, 1024/sourceImageAspectRatio);
                    //重绘图片
                    UIGraphicsBeginImageContextWithOptions(newSize, NO, 0);
    //                UIGraphicsBeginImageContext(newSize);
                    [obj.img drawInRect:CGRectMake(0, 0, newSize.width,newSize.height)];
                    newImage = UIGraphicsGetImageFromCurrentImageContext();
                    UIGraphicsEndImageContext();
                } else {
                    newImage = obj.img;
                }
                obj.img = newImage;
            }
        }
    }];
    
    dispatch_group_t uploadGroup = dispatch_group_create();
    
    NSMutableArray *errorArr = [NSMutableArray array];
    
    NSString *url = [NSString stringWithFormat:@"%@/api/app/uploadimage/",KMainUrl];
    for (int i = 0; i < self.imgArr.count; i++) {
        BC_UploadImgModel *model = self.imgArr[i];
        if ([KStringIsNull(model.type) isEqualToString:@""]) {
            if ([KStringIsNull(model.imgurl) isEqualToString:@""]) {
                //还没有上传
                dispatch_group_enter(uploadGroup);
                [PPNetworkHelper uploadImagesWithURL:url parameters:@{} name:@"file" images:@[model.img] fileNames:nil imageScale:0.8 imageType:@"png" progress:^(NSProgress *progress) {
                    
                } success:^(id responseObject) {
                    KLog(@"上传成功===%@", responseObject);
                    NSDictionary *resdic = (NSDictionary *)responseObject;
                    if ([resdic[@"code"] integerValue] == 2000) {
                        NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
                        NSArray *arr = (NSArray *)dataDic[@"data"];
                        if (arr.count > 0) {
                            model.imgurl = KStringIsNull(arr[0]);
                        }
                    } else {
                        [errorArr addObject:@"1"];
                    }
                    dispatch_group_leave(uploadGroup);
                } failure:^(NSError *error) {
                    KLog(@"上传失败===%@", error);
                    [errorArr addObject:@"1"];
                    dispatch_group_leave(uploadGroup);
                }];
            } else {
                continue;
            }
        } else {
            continue;
        }
    }
    
    dispatch_group_notify(uploadGroup, dispatch_get_main_queue(), ^{
        [MBProgressHUD hideHUDForView:kAppWindow animated:YES];
        if (errorArr.count > 0) {
            [BaseFunction showAlert:@"Some errors have occurred, please upload again"];
        } else {
            //发布
            [self publishPicPost];
        }
    });

}

#pragma mark  上传视频
-(void)uploadVideo:(NSURL*)URL coverImg:(UIImage *)img{
        
    NSString *filepath = [URL absoluteString];
    NSString *upurl = [NSString stringWithFormat:@"%@/api/app/uploadimage/",KMainUrl];
    __block MBProgressHUD *hud;
    dispatch_async(dispatch_get_main_queue(), ^{
        hud = [MBProgressHUD showHUDAddedTo:self.view animated:YES];
        hud.mode = MBProgressHUDModeDeterminate;
        hud.contentColor = kMainThemeColor;
        hud.bezelView.style = MBProgressHUDBackgroundStyleSolidColor;
        hud.bezelView.color = [UIColor blackColor];
        hud.label.text = @"Uploading...";
        hud.label.textColor = UIColor.whiteColor;
    });
    [PPNetworkHelper uploadFileWithURL:upurl parameters:@{} name:@"file" filePath:filepath progress:^(NSProgress *progress) {
        dispatch_async(dispatch_get_main_queue(), ^{
            hud.progressObject = progress;
        });
    } success:^(id responseObject) {
        KLog(@"上传视频===%@",responseObject);
        dispatch_async(dispatch_get_main_queue(), ^{
            [MBProgressHUD hideHUDForView:self.view animated:YES];
        });
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSArray *arr = (NSArray *)dataDic[@"data"];
            if (arr.count > 0) {
                self.uploadVideoUrl = arr[0];
            }
            [BaseFunction showAlert:@"Success"];
            if ([[NSFileManager defaultManager] fileExistsAtPath:KStringIsNull(self.tempVideoPath)]) {
                //上传后删除本地缓存
                [[NSFileManager defaultManager] removeItemAtPath:KStringIsNull(self.tempVideoPath) error:nil];
            }
            
            BC_UploadImgModel *model = [BC_UploadImgModel new];
            model.type = @"";
            model.img = img;
            model.serviceVideoPath = self.uploadVideoUrl;
            [self.imgArr insertObject:model atIndex:0];
            
            [self.photoCollectionView reloadData];
        } else {
            [BaseFunction showAlert:@"Error"];
        }
    } failure:^(NSError *error) {
        dispatch_async(dispatch_get_main_queue(), ^{
            [MBProgressHUD hideHUDForView:self.view animated:YES];
            [BaseFunction showAlert:@"Error"];
        });
    }];
    
}

- (void)publishPicPost {
    
    NSMutableArray *imgArr = [NSMutableArray array];
    for (BC_UploadImgModel *model in self.imgArr) {
        if ([KStringIsNull(model.type) isEqualToString:@""]) {
            [imgArr addObject:KStringIsNull(model.imgurl)];
        }
    }
    
    NSString *files = KStringIsNull([imgArr mj_JSONString]);
    files = [KStringIsNull(files) stringByReplacingOccurrencesOfString:@"\\" withString:@""];
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/posts/", KMainUrl];
    NSDictionary *para = @{@"file_type":@"2", @"files":KStringIsNull(files), @"name":KStringIsNull(self.nameTF.text), @"desc":KStringIsNull(self.descTF.text), @"place":KStringIsNull(self.addressTF.text), @"city":KStringIsNull(self.selectCityID)};
    KLog(@"para===%@", para);
    [PPNetworkHelper POST:url parameters:para success:^(id responseObject) {
        KLog(@"图片贴成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [self.navigationController pushViewController:[BC_CreatePostSuccViewController new] animated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)publishVideoPost {
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/posts/", KMainUrl];
    
    NSMutableArray *varr = [NSMutableArray array];
    [varr addObject:KStringIsNull(self.uploadVideoUrl)];
    NSString *files = KStringIsNull([varr mj_JSONString]);
    files = [KStringIsNull(files) stringByReplacingOccurrencesOfString:@"\\" withString:@""];
    
    NSDictionary *para = @{@"file_type":@"1", @"files":KStringIsNull(files), @"name":KStringIsNull(self.nameTF.text), @"desc":KStringIsNull(self.descTF.text), @"place":KStringIsNull(self.addressTF.text), @"city":KStringIsNull(self.selectCityID)};
    KLog(@"para===%@", para);
    [PPNetworkHelper POST:url parameters:para success:^(id responseObject) {
        KLog(@"视频贴成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [self.navigationController pushViewController:[BC_CreatePostSuccViewController new] animated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)submitBtnClick {
    
    if ([KStringIsNull(self.nameTF.text) isEqualToString:@""] || [KStringIsNull(self.descTF.text) isEqualToString:@""] || [KStringIsNull(self.addressTF.text) isEqualToString:@""] || [KStringIsNull(self.locationTF.text) isEqualToString:@""] || [KStringIsNull(self.selectCityID) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please complete post info"];
        return;
    }
    
    if ([_type isEqualToString:@"1"]) {
        if (self.imgArr.count == 1) {
            [BaseFunction showAlert:@"Please upload picture"];
            return;
        }
    } else {
        if (self.imgArr.count == 1) {
            [BaseFunction showAlert:@"Please upload video"];
            return;
        }
    }
    
    [self.view endEditing:YES];
    
    if ([_type isEqualToString:@"1"]) {
        [self uploadAllImg];
    } else {
        [self publishVideoPost];
    }
}

- (void)getCityList {
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getprovinceareaslist/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSArray *arr = (NSArray *)dataDic[@"data"];
            NSMutableArray *dataSource = [NSMutableArray array];

            [arr enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
                NSDictionary *pdic = arr[idx];
                NSMutableArray *cityModelArr = [NSMutableArray array];
                NSArray *cityArr = (NSArray *)pdic[@"childlist"];
                [cityArr enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx1, BOOL * _Nonnull stop) {
                    NSDictionary *adic = cityArr[idx1];
                    BRCityModel *cmodel = [BRCityModel new];
                    cmodel.name = adic[@"name"];
                    cmodel.code = adic[@"id"];
                    cmodel.index = idx1;
                    [cityModelArr addObject:cmodel];
                }];
                BRProvinceModel *model = [BRProvinceModel new];
                model.name = pdic[@"name"];
                model.citylist = cityModelArr;
                model.code = pdic[@"id"];
                model.index = idx;
                [dataSource addObject:model];
            }];

            [self.areaArr removeAllObjects];
            [self.areaArr addObjectsFromArray:dataSource];
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (BRAddressPickerView *)areaPicker {
    if (!_areaPicker) {
        _areaPicker = [[BRAddressPickerView alloc] initWithPickerMode:BRAddressPickerModeCity];
        _areaPicker.dataSourceArr = self.areaArr;
        @weakify(self);
        _areaPicker.resultBlock = ^(BRProvinceModel * _Nullable province, BRCityModel * _Nullable city, BRAreaModel * _Nullable area) {
            @strongify(self);
            self.locationTF.text = kStringFormat(@"%@ %@", KStringIsNull(province.name), KStringIsNull(city.name));
            self.selectCityID = KStringIsNull(city.code);
        };
    }
    return _areaPicker;
}

@end
