//
//  BC_GroupMemberCollectionViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/14.
//

#import "BC_GroupMemberCollectionViewCell.h"
#import "BC_GroupInfoModel.h"
@implementation BC_GroupMemberCollectionViewCell
- (instancetype)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.avatar = [JLFactoryUtil imageView];
    [self.avatar setCorner:24 withType:JLCornerTypeAllCorner];
    [self addSubview:self.avatar];
    [self.avatar mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self);
        make.top.equalTo(self.mas_top).offset(0);
        make.size.mas_equalTo(CGSizeMake(48, 48));
    }];
    
    self.nameL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kMainTextColor];
    [self addSubview:self.nameL];
    [self.nameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self);
        make.top.equalTo(self.avatar.mas_bottom).offset(6);
        make.width.mas_lessThanOrEqualTo(self.bounds.size.width-10);
    }];
        
}

- (void)setModel:(BC_GroupInfoModel *)model {
    [self.avatar sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(model.avatar)] placeholderImage:kAvatarPlaceHolderImg];
    self.nameL.text = KStringIsNull(model.nickname);
}

- (void)setDic:(NSDictionary *)dic {
    
    if ([KStringIsNull(dic[@"type"]) isEqualToString:@""]) {
        [self.avatar sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(dic[@"avatar"])] placeholderImage:kAvatarPlaceHolderImg];
        self.nameL.text = KStringIsNull(dic[@"name"]);
    } else {
        self.avatar.image = [UIImage imageNamed:@"添加成员"];
        self.nameL.text = @"invitation";
    }
}

@end
