//
//  BC_NoticeDetailViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/15.
//

#import "BC_NoticeDetailViewController.h"
#import <WebKit/WebKit.h>

@interface BC_NoticeDetailViewController ()
@property (nonatomic, strong) WKWebView *webView;

@end

@implementation BC_NoticeDetailViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Notice";
    [self setupUI];
}

- (void)setupUI {
    
    NSString *jScript = @"var meta = document.createElement('meta'); meta.setAttribute('name', 'viewport'); meta.setAttribute('content', 'width=device-width'); document.getElementsByTagName('head')[0].appendChild(meta);";
    WKUserScript *wkUScript = [[WKUserScript alloc] initWithSource:jScript injectionTime:WKUserScriptInjectionTimeAtDocumentEnd forMainFrameOnly:YES];
    WKUserContentController *wkUController = [[WKUserContentController alloc] init];
    [wkUController addUserScript:wkUScript];
    WKWebViewConfiguration *wkWebConfig = [[WKWebViewConfiguration alloc] init];
    wkWebConfig.userContentController = wkUController;
    self.webView = [[WKWebView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight) configuration:wkWebConfig];
    [self.view addSubview:self.webView];
    
    NSString *first = @"<!DOCTYPE html><html><head><meta charset='utf-8' /><meta name='viewport' content='width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0'><meta name='apple-mobile-web-app-capable' content='yes'><title></title><style>  body{background-color:#fff;margin:0px !important;padding:15px !important} img{display:block;width:100% !important;height:auto} *{word-break: break-all;color:#000} p{margin-left:-10px;margin:0px !important;padding:0px !important} </style></head><body>";
    NSString *second = @"</body><html>";
    NSString *temp = [first stringByAppendingString:KStringIsNull(self.contentStr)];
    NSString *final = [temp stringByAppendingString:second];
    [self.webView loadHTMLString:final baseURL:nil];
    
    CGSize tsize = [KStringIsNull(self.titleStr) boundingRectWithSize:CGSizeMake(kScreenWidth - 30, MAXFLOAT) options:NSStringDrawingUsesLineFragmentOrigin|NSStringDrawingUsesFontLeading attributes:@{NSFontAttributeName:MEDIUMFONT(17)} context:nil].size;
    CGFloat headH = tsize.height + 80;
    [self.webView.scrollView setContentInset:UIEdgeInsetsMake(headH, 0, 0, 0)];
                
    UILabel *titleL = [UILabel new];
    titleL.font = MEDIUMFONT(17);
    titleL.text = KStringIsNull(self.titleStr);
    titleL.textColor = kMainTextColor;
    titleL.numberOfLines = 0;
    [self.webView.scrollView addSubview:titleL];
    [titleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.webView.scrollView.mas_left).offset(15);
        make.width.mas_lessThanOrEqualTo(kScreenWidth - 30);
        make.top.equalTo(self.webView.scrollView.mas_top).offset(-(headH-30));
    }];
    
    UILabel *timeL = [UILabel new];
    timeL.font = REGULARFONT(12);
    timeL.text = KStringIsNull(self.timeStr);
    timeL.textColor = kColorWithHex(@"#777777");
    [self.webView.scrollView addSubview:timeL];
    [timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.webView.scrollView.mas_left).offset(15);
        make.top.equalTo(titleL.mas_bottom).offset(15);
        make.width.mas_lessThanOrEqualTo(kScreenWidth - 30);
    }];
    
}


@end
