//
//  BC_NoticeListTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/15.
//

#import "BC_NoticeListTableViewCell.h"
#import "BC_HomeNoticeModel.h"
@implementation BC_NoticeListTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.titleL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(16) textColor:kMainTextColor];
    self.titleL.numberOfLines = 0;
    [self.contentView addSubview:self.titleL];
    [self.titleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-100);
    }];
    
    self.contentL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kColorWithHex(@"#777777")];
    self.contentL.numberOfLines = 0;
    [self.contentView addSubview:self.contentL];
    [self.contentL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.titleL.mas_bottom).offset(10);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
        make.bottom.equalTo(self.contentView.mas_bottom).offset(-15);
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(12) textColor:kColorWithHex(@"#777777")];
    self.timeL.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(self.titleL);
        make.width.mas_equalTo(80);
    }];
        
}

- (void)setModel:(BC_HomeNoticeModel *)model {
    self.titleL.text = KStringIsNull(model.title);
    self.contentL.text = KStringIsNull(model.desc);
    self.timeL.text = KStringIsNull(model.create_datetime);
}
@end
