//
//  BC_ReportPostViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/15.
//

#import "BC_ReportPostViewController.h"
#import "BC_ReportSuccViewController.h"

@interface BC_ReportPostViewController ()
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;
@property (nonatomic, strong) UILabel *typeL;
@property (nonatomic, strong) YYTextView *textView;
@property (nonatomic, strong) UIView *tview;
@property (nonatomic, strong) UIView *typeView;

@property (nonatomic, strong) UILabel *typeOneL;
@property (nonatomic, strong) UILabel *typeTwoL;
@property (nonatomic, strong) UIImageView *selImg;

@property (nonatomic, assign) BOOL isShowType;
@end

@implementation BC_ReportPostViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Report";
    self.isShowType = NO;
    [self setupUI];
}

- (void)setupUI {
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight)];
    self.scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:self.scrollView];
    
    self.contentView = [UIView new];
    self.contentView.backgroundColor = [UIColor whiteColor];
    [self.scrollView addSubview:self.contentView];
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.scrollView);
        make.width.equalTo(self.scrollView);
    }];
    
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Reason description" font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
    }];
    
    UIView *tvview = [JLFactoryUtil view];
    tvview.backgroundColor = kColorWithHex(@"#F5F5F5");
    [tvview setCorner:4 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:tvview];
    [tvview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label2.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 180));
    }];
    
    self.textView = [[YYTextView alloc] init];
    self.textView.placeholderFont = REGULARFONT(14);
    self.textView.placeholderText = @"Describe the reason for the report in detail";
    self.textView.placeholderTextColor = kLightGrayTextColor;
    self.textView.font = REGULARFONT(14);
    self.textView.backgroundColor = kColorWithHex(@"#F5F5F5");
    [tvview addSubview:self.textView];
    [self.textView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(tvview).insets(UIEdgeInsetsMake(10, 10, 10, 10));
    }];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(tvview.mas_bottom).offset(50);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(submitBtn.mas_bottom).offset(20);
    }];
    
}

- (void)submitBtnClick {
    
    if ([KStringIsNull(self.textView.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please input description"];
        return;
    }
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/reportpost/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"id":KStringIsNull(self.postid), @"reason":KStringIsNull(@""), @"content":KStringIsNull(self.textView.text)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [self.navigationController pushViewController:[BC_ReportSuccViewController new] animated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
    
}
@end
