//
//  BC_SearchGroupChatListTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/14.
//

#import "BC_SearchGroupChatListTableViewCell.h"

@implementation BC_SearchGroupChatListTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.avatar = [JLFactoryUtil imageView];
    [self.avatar setCorner:26 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.avatar];
    [self.avatar mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.size.mas_equalTo(CGSizeMake(52, 52));
    }];
    
    self.groupNameL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.groupNameL];
    [self.groupNameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.avatar.mas_right).offset(10);
        make.bottom.equalTo(self.avatar.mas_centerY).offset(-2);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-90);
    }];
    
    self.cateL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kColorWithHex(@"#777777")];
    [self.contentView addSubview:self.cateL];
    [self.cateL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.avatar.mas_right).offset(10);
        make.top.equalTo(self.avatar.mas_centerY).offset(2);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-90);
    }];
    
    self.joinBtn = [JLFactoryUtil buttonWithTitle:@"Join in" font:MEDIUMFONT(13) textColor:UIColor.whiteColor];
    [self.joinBtn setCorner:16 withType:JLCornerTypeAllCorner];
    self.joinBtn.backgroundColor = kMainThemeColor;
    [self.joinBtn addTarget:self action:@selector(joinBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:self.joinBtn];
    [self.joinBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(self.contentView);
        make.size.mas_equalTo(CGSizeMake(72, 32));
    }];
    
    self.avatar.backgroundColor = kRANDOM_COLOR;
    self.groupNameL.text = @"group name";
    self.cateL.text = kStringFormat(@"Belonging: %@", @"name");
    
}

- (void)joinBtnClick {
    
}
@end
