//
//  BC_PostItemListHasVideoTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/14.
//

#import "BC_PostItemListHasVideoTableViewCell.h"
#import "BC_PostListModel.h"
@implementation BC_PostItemListHasVideoTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.avatar = [JLFactoryUtil imageView];
    [self.avatar setCorner:20 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.avatar];
    [self.avatar mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
        make.size.mas_equalTo(CGSizeMake(40, 40));
    }];
    
    self.nicknameL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.nicknameL];
    [self.nicknameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.avatar.mas_right).offset(10);
        make.bottom.equalTo(self.avatar.mas_centerY).offset(-1);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-10);
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(12) textColor:kLightGrayTextColor];
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.avatar.mas_right).offset(10);
        make.top.equalTo(self.avatar.mas_centerY).offset(1);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-10);
    }];
    
    self.titleL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(14) textColor:kMainTextColor];
    self.titleL.numberOfLines = 0;
    [self.contentView addSubview:self.titleL];
    [self.titleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.avatar.mas_bottom).offset(12);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.contentL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kColorWithHex(@"#777777")];
    self.contentL.numberOfLines = 2;
    [self.contentView addSubview:self.contentL];
    [self.contentL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.titleL.mas_bottom).offset(8);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.imgview1 = [JLFactoryUtil imageView];
    [self.imgview1 setCorner:5 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.imgview1];
    [self.imgview1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentL.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, (kScreenWidth - 30)*180/345));
    }];
    UIImageView *playimg = [JLFactoryUtil imageViewWithImg:@"播放icon"];
    [self.imgview1 addSubview:playimg];
    [playimg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.centerX.equalTo(self.imgview1);
        make.size.mas_equalTo(CGSizeMake(48, 48));
    }];
    
    self.areaView = [JLFactoryUtil view];
    self.areaView.backgroundColor = kColorWithHex(@"#ECF8EF");
    [self.areaView setCorner:12 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.areaView];
    [self.areaView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.imgview1.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake(30, 24));
        make.bottom.equalTo(self.contentView.mas_bottom).offset(-20);
    }];
    
    UIImageView *areaImg = [JLFactoryUtil imageViewWithImg:@"位置"];
    [self.areaView addSubview:areaImg];
    [areaImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(self.areaView.mas_left).offset(10);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    self.areaL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kColorWithHex(@"#05A833")];
    [self.areaView addSubview:self.areaL];
    [self.areaL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(areaImg.mas_right).offset(3);
        make.width.mas_lessThanOrEqualTo(250);
    }];
        
    self.commentNumL = [JLFactoryUtil labelWithText:@"0" font:REGULARFONT(14) textColor:kMainTextColor];
    [self.contentView addSubview:self.commentNumL];
    [self.commentNumL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(self.areaView);
    }];
    
    UIImageView *commentImg = [JLFactoryUtil imageViewWithImg:@"评论"];
    [self.contentView addSubview:commentImg];
    [commentImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.commentNumL.mas_left).offset(-8);
        make.centerY.equalTo(self.commentNumL);
        make.size.mas_equalTo(CGSizeMake(18, 18));
    }];
    
    UIButton *repBtn = [JLFactoryUtil buttonWithImage:@"屏蔽"];
    [repBtn setTitle:@"shield" forState:0];
    repBtn.titleLabel.font = REGULARFONT(14);
    [repBtn setTitleColor:kMainTextColor forState:0];
    repBtn.titleEdgeInsets = UIEdgeInsetsMake(0, 5, 0, 0);
    [repBtn addTarget:self action:@selector(repBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:repBtn];
    [repBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(commentImg.mas_left).offset(-12);
        make.centerY.equalTo(self.commentNumL);
        make.size.mas_equalTo(CGSizeMake(90, 20));
    }];

}

- (void)repBtnClick {
    if (self.delegate && [self.delegate respondsToSelector:@selector(shieldVideoItem:)]) {
        [self.delegate shieldVideoItem:_model];
    }
}

- (void)setModel:(BC_PostListModel *)model {
    _model = model;
    [self.avatar sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(model.user_avatar)] placeholderImage:kAvatarPlaceHolderImg];
    self.nicknameL.text = KStringIsNull(model.user_name).length == 0 ? @"User":KStringIsNull(model.user_name);    self.timeL.text = KStringIsNull(model.create_datetime);
    self.titleL.text = KStringIsNull(model.name);
    self.contentL.text = KStringIsNull(model.desc);
    self.areaL.text = KStringIsNull(model.city);
    CGSize size = [self.areaL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
    if (size.width >= 250) {
        size.width = 250;
    }
    [self.areaView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.size.mas_equalTo(CGSizeMake(40+size.width, 24));
    }];
    self.commentNumL.text = KStringIsNull(model.post_comment_count);
    self.imgview1.image = kPlaceHolderImg;
    if (model.files.count > 0) {
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
            UIImage *img = [BaseFunction thumbnailImageForVideo:[NSURL URLWithString:KStringIsNull(model.files[0])] atTime:0.1];
            dispatch_async(dispatch_get_main_queue(), ^{
                self.imgview1.image = img;
            });
        });
    }
    
}
@end
