//
//  BC_UploadImgCollectionViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/13.
//

#import "BC_UploadImgCollectionViewCell.h"
#import "BC_UploadImgModel.h"
@implementation BC_UploadImgCollectionViewCell
- (instancetype)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        self.photoImg = [UIImageView new];
        self.photoImg.contentMode = UIViewContentModeScaleAspectFill;
        self.photoImg.clipsToBounds = YES;
        [self addSubview:self.photoImg];
        [self.photoImg mas_makeConstraints:^(MASConstraintMaker *make) {
            make.edges.equalTo(self);
        }];
        
        self.delbtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [self.delbtn setImage:[UIImage imageNamed:@"删除"] forState:0];
        [self.delbtn addTarget:self action:@selector(delbtnClick) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:self.delbtn];
        [self.delbtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.right.top.equalTo(self);
            make.size.mas_equalTo(CGSizeMake(18, 18));
        }];
        
        self.playImg = [JLFactoryUtil imageViewWithImg:@"播放icon"];
        [self addSubview:self.playImg];
        [self.playImg mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerY.centerX.equalTo(self);
            make.size.mas_equalTo(CGSizeMake(30, 30));
        }];
    }
    return self;
}

- (void)setModel:(BC_UploadImgModel *)model {
    _model = model;
    if ([KStringIsNull(model.type) isEqualToString:@"add"]) {
        self.delbtn.hidden = YES;
        self.playImg.hidden = YES;
        self.photoImg.image = [UIImage imageNamed:@"添加"];
    } else {
        if ([KStringIsNull(model.serviceVideoPath) isEqualToString:@""]) {
            self.delbtn.hidden = NO;
            self.playImg.hidden = YES;
            if ([KStringIsNull(model.imgurl) isEqualToString:@""]) {
                self.photoImg.image = model.img;
            } else {
                [self.photoImg sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(model.imgurl)]];
            }
        } else {
            self.delbtn.hidden = NO;
            self.playImg.hidden = NO;
            self.photoImg.image = model.img;
        }
    }
}

- (void)delbtnClick {
    if (self.delegate && [self.delegate respondsToSelector:@selector(removeImgModel:)]) {
        [self.delegate removeImgModel:_model];
    }
}

@end
