//
//  BC_CompleteUserInfoViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/13.
//

#import "BC_CompleteUserInfoViewController.h"
#import "BC_RegisterSuccViewController.h"
#import "BC_LoginViewController.h"

#import "BC_UploadImgCollectionViewCell.h"
#import "BC_UserTagCollectionViewCell.h"
#import "ZlinkPhotoBrowserView.h"
#import <TZImagePickerController.h>
#import "BRDatePickerView.h"
#import "BRStringPickerView.h"

#import "BC_UploadImgModel.h"

@interface BC_CompleteUserInfoViewController ()<UICollectionViewDelegate, UICollectionViewDataSource, TZImagePickerControllerDelegate, UIImagePickerControllerDelegate, UINavigationControllerDelegate, BC_UploadImgCollectionViewCellDelegate>
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;
@property (nonatomic, strong) UITextField *usernameTF;
@property (nonatomic, strong) UITextField *dateTF;
@property (nonatomic, strong) UITextField *addressTF;
@property (nonatomic, strong) UITextField *phoneTF;
@property (nonatomic, strong) UITextField *emailTF;
@property (nonatomic, strong) UICollectionView *tagCollectionView;
@property (nonatomic, strong) UICollectionView *photoCollectionView;
@property (nonatomic, strong) BRDatePickerView *datePicker;
@property (nonatomic, strong) UITextField *licentypeTF;
@property (nonatomic, strong) BRStringPickerView *licentypePicker;
@property (nonatomic, strong) UITextField *licenNumberTF;
@property (nonatomic, strong) UITextField *licenIssuerTF;
@property (nonatomic, strong) UITextField *licenExpiryTF;

@property (nonatomic, strong) NSMutableArray *tagArr;
@property (nonatomic, strong) NSMutableArray *imgArr;
@property (nonatomic, strong) NSMutableArray *licenseArr;
@property (nonatomic, strong) NSMutableArray *licenseNameArr;
@property (nonatomic, copy) NSString *selectCateId;
@property (nonatomic, copy) NSString *selectLicenseId;
@end

@implementation BC_CompleteUserInfoViewController
- (void)backBtnClicked {
    if (self.presentingViewController) {
        [self dismissViewControllerAnimated:YES completion:nil];
    } else {
        for (UIViewController *vc in self.navigationController.viewControllers) {
            if ([vc isKindOfClass:[BC_LoginViewController class]]) {
                [self.navigationController popToViewController:vc animated:YES];
                break;
            }
        }
    }
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Complete Your Profile";
    self.isShowLeftBackBtn = NO;
    self.selectCateId = @"";
    self.selectLicenseId = @"";
    self.tagArr = [NSMutableArray array];
    self.imgArr = [NSMutableArray array];
    self.licenseArr = [NSMutableArray array];
    self.licenseNameArr = [NSMutableArray array];

    BC_UploadImgModel *model = [BC_UploadImgModel new];
    model.type = @"add";
    model.imgurl = @"";
    [self.imgArr addObject:model];
    [self setupUI];
    
    [self getCateList];
    [self getLicenseList];
}

- (void)setupUI {
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight)];
    self.scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:self.scrollView];
    
    self.contentView = [UIView new];
    self.contentView.backgroundColor = [UIColor whiteColor];
    [self.scrollView addSubview:self.contentView];
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.scrollView);
        make.width.equalTo(self.scrollView);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"User Info" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"User Full Name" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(15);
    }];
    
    self.usernameTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Please type in your name"];
    self.usernameTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.usernameTF];
    [self.usernameTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label2.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    
    CALayer *nameLayer = [CALayer layer];
    nameLayer.frame = CGRectMake(0, 29, kScreenWidth - 30, 1);
    nameLayer.backgroundColor = kColorWithHex(@"#DDDDDD").CGColor;
    [self.usernameTF.layer addSublayer:nameLayer];

    UILabel *label3 = [JLFactoryUtil labelWithText:@"Date of Birth" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label3];
    [label3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.usernameTF.mas_bottom).offset(20);
    }];
    
    self.dateTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"        month        year"];
    self.dateTF.enabled = NO;
    self.dateTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.dateTF];
    [self.dateTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label3.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    CALayer *dateLayer = [CALayer layer];
    dateLayer.frame = CGRectMake(0, 29, kScreenWidth - 30, 1);
    dateLayer.backgroundColor = kColorWithHex(@"#DDDDDD").CGColor;
    [self.dateTF.layer addSublayer:dateLayer];
    
    UIView *dateClear = [JLFactoryUtil view];
    dateClear.backgroundColor = UIColor.clearColor;
    [self.contentView addSubview:dateClear];
    [dateClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.dateTF);
        make.left.right.equalTo(self.contentView);
        make.height.mas_equalTo(30);
    }];
    UITapGestureRecognizer *tapDate = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseDate)];
    [dateClear addGestureRecognizer:tapDate];
    
    UILabel *label4 = [JLFactoryUtil labelWithText:@"Home Address" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label4];
    [label4 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.dateTF.mas_bottom).offset(20);
    }];
    
    self.addressTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Please enter your home address"];
    self.addressTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.addressTF];
    [self.addressTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label4.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    CALayer *addrLayer = [CALayer layer];
    addrLayer.frame = CGRectMake(0, 29, kScreenWidth - 30, 1);
    addrLayer.backgroundColor = kColorWithHex(@"#DDDDDD").CGColor;
    [self.addressTF.layer addSublayer:addrLayer];
    
    UILabel *label5 = [JLFactoryUtil labelWithText:@"Phone" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label5];
    [label5 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.addressTF.mas_bottom).offset(20);
    }];
    
    self.phoneTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Please enter your phone number"];
    self.phoneTF.keyboardType = UIKeyboardTypePhonePad;
    self.phoneTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.phoneTF];
    [self.phoneTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label5.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    CALayer *phoneLayer = [CALayer layer];
    phoneLayer.frame = CGRectMake(0, 29, kScreenWidth - 30, 1);
    phoneLayer.backgroundColor = kColorWithHex(@"#DDDDDD").CGColor;
    [self.phoneTF.layer addSublayer:phoneLayer];
    
    UILabel *label6 = [JLFactoryUtil labelWithText:@"Email" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label6];
    [label6 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.phoneTF.mas_bottom).offset(20);
    }];
    
    self.emailTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Please enter email address"];
    self.emailTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.emailTF];
    [self.emailTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label6.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    CALayer *emailLayer = [CALayer layer];
    emailLayer.frame = CGRectMake(0, 29, kScreenWidth - 30, 1);
    emailLayer.backgroundColor = kColorWithHex(@"#DDDDDD").CGColor;
    [self.emailTF.layer addSublayer:emailLayer];
    
    UILabel *label7 = [JLFactoryUtil labelWithText:@"Classification" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label7];
    [label7 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.emailTF.mas_bottom).offset(20);
    }];
    
    UICollectionViewFlowLayout *taglayout = [UICollectionViewFlowLayout new];
    taglayout.scrollDirection = UICollectionViewScrollDirectionVertical;
    taglayout.minimumInteritemSpacing = 0;
    taglayout.minimumLineSpacing = 10;
    taglayout.itemSize = CGSizeMake(kScreenWidth/3, 55);
    taglayout.sectionInset = UIEdgeInsetsMake(0, 0, 0, 0);
    self.tagCollectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:taglayout];
    self.tagCollectionView.delegate = self;
    self.tagCollectionView.dataSource = self;
    self.tagCollectionView.backgroundColor = UIColor.whiteColor;
    self.tagCollectionView.showsVerticalScrollIndicator = NO;
    self.tagCollectionView.scrollEnabled = NO;
    [self.tagCollectionView registerClass:[BC_UserTagCollectionViewCell class] forCellWithReuseIdentifier:@"tagcell"];
    [self.contentView addSubview:self.tagCollectionView];
    [self.tagCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView);
        make.left.equalTo(self.contentView);
        make.top.equalTo(label7.mas_bottom).offset(10);
        make.height.mas_equalTo(1);
    }];
    
    UILabel *label8 = [JLFactoryUtil labelWithText:@"License Type" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label8];
    [label8 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.tagCollectionView.mas_bottom).offset(20);
    }];
    
    UIView *licenseView = [JLFactoryUtil view];
    licenseView.layer.borderWidth = 1;
    licenseView.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
    [licenseView setCorner:8 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:licenseView];
    [licenseView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label8.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 48));
    }];
    
    self.licentypeTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(14) place:@"License Type"];
    self.licentypeTF.enabled = NO;
    self.licentypeTF.textColor = kMainTextColor;
    [licenseView addSubview:self.licentypeTF];
    [self.licentypeTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(licenseView.mas_left).offset(10);
        make.centerY.equalTo(licenseView);
        make.right.equalTo(licenseView.mas_right).offset(-40);
        make.height.mas_equalTo(30);
    }];
    
    UIImageView *arrow = [JLFactoryUtil imageViewWithImg:@"展开"];
    [licenseView addSubview:arrow];
    [arrow mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(licenseView.mas_right).offset(-10);
        make.centerY.equalTo(licenseView);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    UIView *typeClear = [JLFactoryUtil view];
    typeClear.backgroundColor = UIColor.clearColor;
    [self.contentView addSubview:typeClear];
    [typeClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label8.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 48));
    }];
    UITapGestureRecognizer *tapType = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseLicenseType)];
    [typeClear addGestureRecognizer:tapType];
    
    UILabel *label9 = [JLFactoryUtil labelWithText:@"License number" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label9];
    [label9 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(licenseView.mas_bottom).offset(20);
    }];
    
    self.licenNumberTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Please enter the ID number"];
    self.licenNumberTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.licenNumberTF];
    [self.licenNumberTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label9.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    CALayer *numLayer = [CALayer layer];
    numLayer.frame = CGRectMake(0, 29, kScreenWidth - 30, 1);
    numLayer.backgroundColor = kColorWithHex(@"#DDDDDD").CGColor;
    [self.licenNumberTF.layer addSublayer:numLayer];
    
    UILabel *label10 = [JLFactoryUtil labelWithText:@"License Issuer" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label10];
    [label10 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.licenNumberTF.mas_bottom).offset(20);
    }];
    
    self.licenIssuerTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Please enter the license issuer"];
    self.licenIssuerTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.licenIssuerTF];
    [self.licenIssuerTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label10.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    CALayer *issueLayer = [CALayer layer];
    issueLayer.frame = CGRectMake(0, 29, kScreenWidth - 30, 1);
    issueLayer.backgroundColor = kColorWithHex(@"#DDDDDD").CGColor;
    [self.licenIssuerTF.layer addSublayer:issueLayer];
    
    UILabel *label11 = [JLFactoryUtil labelWithText:@"License Expiry Date" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label11];
    [label11 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.licenIssuerTF.mas_bottom).offset(20);
    }];
    
    self.licenExpiryTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Please enter the license validity period"];
    self.licenExpiryTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.licenExpiryTF];
    [self.licenExpiryTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label11.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 30));
    }];
    CALayer *expLayer = [CALayer layer];
    expLayer.frame = CGRectMake(0, 29, kScreenWidth - 30, 1);
    expLayer.backgroundColor = kColorWithHex(@"#DDDDDD").CGColor;
    [self.licenExpiryTF.layer addSublayer:expLayer];
    
    UILabel *label12 = [JLFactoryUtil labelWithText:@"Add qualification" font:MEDIUMFONT(17) textColor:kMainTextColor];
    [self.contentView addSubview:label12];
    [label12 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.licenExpiryTF.mas_bottom).offset(20);
    }];
        
    UICollectionViewFlowLayout *layout = [UICollectionViewFlowLayout new];
    layout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
    layout.minimumInteritemSpacing = 1;
    layout.minimumLineSpacing = 10;
    layout.itemSize = CGSizeMake(107, 107);
    layout.sectionInset = UIEdgeInsetsMake(10, 15, 10, 15);
    self.photoCollectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:layout];
    self.photoCollectionView.delegate = self;
    self.photoCollectionView.dataSource = self;
    self.photoCollectionView.backgroundColor = UIColor.clearColor;
    self.photoCollectionView.showsHorizontalScrollIndicator = NO;
    [self.photoCollectionView registerClass:[BC_UploadImgCollectionViewCell class] forCellWithReuseIdentifier:@"photocell"];
    [self.contentView addSubview:self.photoCollectionView];
    [self.photoCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView);
        make.left.equalTo(self.contentView);
        make.top.equalTo(label12.mas_bottom).offset(15);
        make.height.mas_equalTo(130);
    }];
        
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(uploadAllImg) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(28);
        make.top.equalTo(self.photoCollectionView.mas_bottom).offset(40);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 56, 48));
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(submitBtn.mas_bottom).offset(50);
    }];
    
}

#pragma mark  UICollectionView Delegate
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    if (collectionView == self.photoCollectionView) {
        BC_UploadImgModel *model = self.imgArr[indexPath.item];
        if ([KStringIsNull(model.type) isEqualToString:@"add"]) {
            
            [self chooseImg];
        } else {
            NSMutableArray *itemarr = [NSMutableArray array];
            for (BC_UploadImgModel *m in self.imgArr) {
                if ([KStringIsNull(m.type) isEqualToString:@""]) {
                    ZlinkPhotoGroupItem *item = [ZlinkPhotoGroupItem new];
                    item.thumbView = self.photoCollectionView;
                    item.largeImageURL = [NSURL URLWithString:KStringIsNull(m.imgurl)];
                    item.showimg = m.img;
                    [itemarr addObject:item];
                }
            }

            ZlinkPhotoBrowserView *browser = [[ZlinkPhotoBrowserView alloc] initWithGroupItems:itemarr];
            [browser presentFromImageView:self.photoCollectionView toContainer:self.navigationController.view animated:YES index:indexPath.item-1 completion:^{
            }];
        }
    } else {
        for (int i = 0; i < self.tagArr.count; i++) {
            NSMutableDictionary *mudic = [NSMutableDictionary dictionaryWithDictionary:self.tagArr[i]];
            [mudic setObject:@"0" forKey:@"isselect"];
            [self.tagArr replaceObjectAtIndex:i withObject:mudic];
        }
        NSMutableDictionary *dic = [NSMutableDictionary dictionaryWithDictionary:self.tagArr[indexPath.item]];
        [dic setValue:@"1" forKey:@"isselect"];
        [self.tagArr replaceObjectAtIndex:indexPath.item withObject:dic];
        [self.tagCollectionView reloadData];
        self.selectCateId = KStringIsNull(dic[@"id"]);
    }
}

- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    if (collectionView == self.photoCollectionView) {
        BC_UploadImgCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"photocell" forIndexPath:indexPath];
        cell.delegate = self;
        [cell setModel:_imgArr[indexPath.item]];
        return cell;
    } else {
        BC_UserTagCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"tagcell" forIndexPath:indexPath];
        [cell setDic:self.tagArr[indexPath.item]];
        return cell;
    }
    
}

- (void)removeImgModel:(BC_UploadImgModel *)model {
    [self.imgArr removeObject:model];
    [self.photoCollectionView reloadData];
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    if (collectionView == self.photoCollectionView) {
        return self.imgArr.count;
    } else {
        return self.tagArr.count;
    }
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView {
    return 1;
}

- (void)chooseImg {
    
    [self.view endEditing:YES];
    if (self.imgArr.count > 9) {
        [BaseFunction showAlert:@"The maximum number of pictures is 9"];
        return;
    }
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"" message:nil preferredStyle:UIAlertControllerStyleActionSheet];
    UIAlertAction *action1 = [UIAlertAction actionWithTitle:@"Camera" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        [self choosePhotoFromCamera];
    }];
    UIAlertAction *action2 = [UIAlertAction actionWithTitle:@"Photo" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        [self photoAction];
    }];
    UIAlertAction *action3 = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
        
    }];
    [alert addAction:action1];
    [alert addAction:action2];
    [alert addAction:action3];
    [self presentViewController:alert animated:YES completion:nil];
}

- (void)choosePhotoFromCamera {
    if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
        UIImagePickerController *imagePickerController = [[UIImagePickerController alloc] init];
        imagePickerController.delegate = self;
        imagePickerController.sourceType = UIImagePickerControllerSourceTypeCamera;
        [self presentViewController:imagePickerController animated:YES completion:nil];
    }
}

- (void)photoAction {
    TZImagePickerController *imagePickerVc = [[TZImagePickerController alloc] initWithMaxImagesCount:9 - self.imgArr.count + 1 delegate:self];
    imagePickerVc.barItemTextColor = [UIColor whiteColor];
    [imagePickerVc.navigationBar setTitleTextAttributes:@{NSForegroundColorAttributeName : [UIColor whiteColor]}];
    imagePickerVc.navigationBar.tintColor = [UIColor whiteColor];
    if (@available(iOS 15.0, *)) {
        UINavigationBarAppearance *barApp = [UINavigationBarAppearance new];
        barApp.backgroundColor = [UIColor whiteColor];
        barApp.shadowColor = [UIColor clearColor];
        imagePickerVc.navigationController.navigationBar.scrollEdgeAppearance = barApp;
        imagePickerVc.navigationController.navigationBar.standardAppearance = barApp;
    } else {
        imagePickerVc.navigationBar.barTintColor = [UIColor whiteColor];
    }
    imagePickerVc.oKButtonTitleColorDisabled = [UIColor lightGrayColor];
    imagePickerVc.navigationBar.translucent = NO;
    imagePickerVc.iconThemeColor = kMainThemeColor;
    imagePickerVc.showSelectedIndex = YES;
    imagePickerVc.allowTakePicture = YES;
    imagePickerVc.allowTakeVideo = NO;   // 在内部显示拍视频按
    imagePickerVc.showPhotoCannotSelectLayer = YES;
    imagePickerVc.cannotSelectLayerColor = [[UIColor whiteColor] colorWithAlphaComponent:0.8];
    imagePickerVc.allowPickingVideo = NO;
    imagePickerVc.allowPickingOriginalPhoto = YES;
    imagePickerVc.allowPickingImage = YES;
    imagePickerVc.allowPickingGif = NO;
    imagePickerVc.statusBarStyle = UIStatusBarStyleDefault;
    imagePickerVc.preferredLanguage = @"en";
    imagePickerVc.modalPresentationStyle = UIModalPresentationFullScreen;
    [self presentViewController:imagePickerVc animated:YES completion:nil];
}

- (void)tz_imagePickerControllerDidCancel:(TZImagePickerController *)picker {
}

- (void)imagePickerController:(TZImagePickerController *)picker didFinishPickingPhotos:(NSArray<UIImage *> *)photos sourceAssets:(NSArray *)assets isSelectOriginalPhoto:(BOOL)isSelectOriginalPhoto {
    if (photos.count > 0) {
        for (UIImage *img in photos) {
            BC_UploadImgModel *model = [BC_UploadImgModel new];
            model.type = @"";
            model.img = img;
            [self.imgArr insertObject:model atIndex:0];
        }
        [self.photoCollectionView reloadData];
    }
}

#pragma mark  拍照选择回调
- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary<UIImagePickerControllerInfoKey,id> *)info {
    if ([info objectForKey:UIImagePickerControllerOriginalImage]) {
        UIImage *editimage = [info objectForKey:UIImagePickerControllerOriginalImage];
        [picker dismissViewControllerAnimated:YES completion:nil];
        BC_UploadImgModel *model = [BC_UploadImgModel new];
        model.type = @"";
        model.img = editimage;
        [self.imgArr insertObject:model atIndex:0];
        [self.photoCollectionView reloadData];
    }
}

- (void)chooseDate {
    [self.view endEditing:YES];
    [self.datePicker show];
}

- (void)chooseLicenseType {
    [self.view endEditing:YES];
    if (self.licenseNameArr.count == 0) {
        return;
    }
    [self.licentypePicker show];
}

- (BRDatePickerView *)datePicker {
    if (!_datePicker) {
        _datePicker = [[BRDatePickerView alloc] initWithPickerMode:BRDatePickerModeYM];
        @weakify(self);
        _datePicker.resultBlock = ^(NSDate * _Nullable selectDate, NSString * _Nullable selectValue) {
            @strongify(self);
            self.dateTF.text = KStringIsNull([selectDate stringWithFormat:@"MM/yyyy"]);
        };
    }
    return _datePicker;
}

- (BRStringPickerView *)licentypePicker {
    if (!_licentypePicker) {
        _licentypePicker = [[BRStringPickerView alloc] initWithPickerMode:BRStringPickerComponentSingle];
        _licentypePicker.dataSourceArr = self.licenseNameArr;
        @weakify(self);
        _licentypePicker.resultModelBlock = ^(BRResultModel * _Nullable resultModel) {
            @strongify(self);
            self.licentypeTF.text = KStringIsNull(resultModel.value);
            NSDictionary *dic = self.licenseArr[resultModel.index];
            self.selectLicenseId = KStringIsNull(dic[@"id"]);
        };
    }
    return _licentypePicker;
}

- (void)getCateList {
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getsettledclassifylist/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSArray *arr = (NSArray *)dataDic[@"data"];
            for (NSDictionary *dic in arr) {
                NSMutableDictionary *mudic = [NSMutableDictionary dictionaryWithDictionary:dic];
                [mudic setObject:@"0" forKey:@"isselect"];
                [self.tagArr addObject:mudic];
            }
            [self.tagCollectionView reloadData];
            [self.tagCollectionView layoutIfNeeded];
            [self.tagCollectionView mas_updateConstraints:^(MASConstraintMaker *make) {
                make.height.mas_equalTo(self.tagCollectionView.collectionViewLayout.collectionViewContentSize.height);
            }];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)getLicenseList {
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getlicensetypelist/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSArray *arr = (NSArray *)dataDic[@"data"];
            for (NSDictionary *dic in arr) {
                [self.licenseArr addObject:dic];
                [self.licenseNameArr addObject:KStringIsNull(dic[@"name"])];
            }
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

#pragma mark  上传图片
- (void)uploadAllImg {
    
    if ([KStringIsNull(_usernameTF.text) isEqualToString:@""] || [KStringIsNull(_dateTF.text) isEqualToString:@""] || [KStringIsNull(_addressTF.text) isEqualToString:@""] || [KStringIsNull(_phoneTF.text) isEqualToString:@""] || [KStringIsNull(_emailTF.text) isEqualToString:@""] || [KStringIsNull(self.selectCateId) isEqualToString:@""] || [KStringIsNull(_licentypeTF.text) isEqualToString:@""] || [KStringIsNull(_licenNumberTF.text) isEqualToString:@""] || [KStringIsNull(_licenIssuerTF.text) isEqualToString:@""] || [KStringIsNull(_licenExpiryTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please complete the information"];
        return;
    }
    
    if (self.imgArr.count == 1) {
        [BaseFunction showAlert:@"Please upload image"];
        return;
    }
            
    [self.view endEditing:YES];
    
    [MBProgressHUD showHUDAddTo:kAppWindow alertMsg:@"" animated:YES];

    [self.imgArr enumerateObjectsUsingBlock:^(BC_UploadImgModel *  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        if ([KStringIsNull(obj.type) isEqualToString:@""]) {
            if ([KStringIsNull(obj.imgurl) isEqualToString:@""]) {
                UIImage *newImage;
                if (obj.img.size.width > 1024) {  //分辨率大的则重绘，否则不重绘
                    //获取原图片宽高比
                    CGFloat sourceImageAspectRatio = obj.img.size.width/obj.img.size.height;
                    CGSize newSize = CGSizeMake(1024, 1024/sourceImageAspectRatio);
                    //重绘图片
                    UIGraphicsBeginImageContextWithOptions(newSize, NO, 0);
                    [obj.img drawInRect:CGRectMake(0, 0, newSize.width,newSize.height)];
                    newImage = UIGraphicsGetImageFromCurrentImageContext();
                    UIGraphicsEndImageContext();
                } else {
                    newImage = obj.img;
                }
                obj.img = newImage;
            }
        }
    }];
    
    dispatch_group_t uploadGroup = dispatch_group_create();
    
    NSMutableArray *errorArr = [NSMutableArray array];
    
    NSString *url = [NSString stringWithFormat:@"%@/api/app/uploadimage/",KMainUrl];
    for (int i = 0; i < self.imgArr.count; i++) {
        BC_UploadImgModel *model = self.imgArr[i];
        if ([KStringIsNull(model.type) isEqualToString:@""]) {
            if ([KStringIsNull(model.imgurl) isEqualToString:@""]) {
                //还没有上传
                dispatch_group_enter(uploadGroup);
                [PPNetworkHelper uploadImagesWithURL:url parameters:@{} name:@"file" images:@[model.img] fileNames:nil imageScale:0.8 imageType:@"png" progress:^(NSProgress *progress) {
                    
                } success:^(id responseObject) {
                    KLog(@"上传成功===%@", responseObject);
                    NSDictionary *resdic = (NSDictionary *)responseObject;
                    if ([resdic[@"code"] integerValue] == 2000) {
                        NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
                        NSArray *arr = (NSArray *)dataDic[@"data"];
                        if (arr.count > 0) {
                            model.imgurl = KStringIsNull(arr[0]);
                        }
                    } else {
                        [errorArr addObject:@"error"];
                    }
                    dispatch_group_leave(uploadGroup);
                } failure:^(NSError *error) {
                    KLog(@"上传失败===%@", error);
                    [errorArr addObject:@"error"];
                    dispatch_group_leave(uploadGroup);
                }];
            } else {
                continue;
            }
        } else {
            continue;
        }
    }
    
    dispatch_group_notify(uploadGroup, dispatch_get_main_queue(), ^{
        [MBProgressHUD hideHUDForView:kAppWindow animated:YES];
        if (errorArr.count > 0) {
            [BaseFunction showAlert:@"Some errors have occurred, please upload again"];
        } else {
            //发布
            [self publish];
        }
    });

}

- (void)publish {
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];

    NSMutableArray *imgs = [NSMutableArray array];
    for (BC_UploadImgModel *model in self.imgArr) {
        if ([KStringIsNull(model.type) isEqualToString:@""]) {
            [imgs addObject:KStringIsNull(model.imgurl)];
        }
    }
    NSString *files = KStringIsNull([imgs mj_JSONString]);
    files = [KStringIsNull(files) stringByReplacingOccurrencesOfString:@"\\" withString:@""];
    
    NSString *url = [NSString stringWithFormat:@"%@/api/app/perfectiinfo/", KMainUrl];
    NSDictionary *para = @{@"userid":KStringIsNull(self.userid), @"name":KStringIsNull(_usernameTF.text), @"birth":KStringIsNull(_dateTF.text), @"phone":KStringIsNull(_phoneTF.text), @"place":KStringIsNull(_addressTF.text), @"email":KStringIsNull(_emailTF.text), @"classify":KStringIsNull(self.selectCateId), @"license_type":KStringIsNull(self.selectLicenseId), @"license_number":KStringIsNull(_licenNumberTF.text), @"license_issuer":KStringIsNull(_licenIssuerTF.text), @"license_expire_date":KStringIsNull(_licenExpiryTF.text), @"certificates":KStringIsNull(files)};
    KLog(@"完善信息===%@", para);
    [PPNetworkHelper POST:url parameters:para success:^(id responseObject) {
        KLog(@"完善成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [self.navigationController pushViewController:[BC_RegisterSuccViewController new] animated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

@end
