//
//  BC_LoginViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/13.
//

#import "BC_LoginViewController.h"
#import "BC_ForgetPWViewController.h"
#import "EVTPhoneAreaCodeViewController.h"
#import "BC_RegisterViewController.h"
#import "BC_UserProtocolViewController.h"
#import "MainTabbarViewController.h"
#import "BC_CompleteUserInfoViewController.h"

#import "TUILogin.h"
#import "GenerateTestUserSig.h"
@interface BC_LoginViewController ()
@property (nonatomic, strong) UILabel *areaCodeL;
@property (nonatomic, strong) UITextField *accTF;
@property (nonatomic, strong) UITextField *pwTF;
@property (nonatomic, strong) UIButton *close;
@property (nonatomic, assign) BOOL isAgree;
@end

@implementation BC_LoginViewController
- (void)closeBtnClick {
    [self dismissViewControllerAnimated:YES completion:nil];
}
- (void)dealloc {
    KLog(@"BC_LoginViewController dealloc");
    [kNotificationCenter removeObserver:self];
}
- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.isHidenNaviBar = YES;
    self.isAgree = NO;
    [kNotificationCenter addObserver:self selector:@selector(hideBtn) name:@"hideLoginPopBtn" object:nil];
    [self setupUI];
}

- (void)hideBtn {
    if (_close) {
        _close.hidden = YES;
    }
}

- (void)setupUI {
    
    if (self.presentingViewController) {
        UIButton *close = [JLFactoryUtil buttonWithImage:@"关闭icon"];
        [close addTarget:self action:@selector(closeBtnClick) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:close];
        [close mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.view.mas_left).offset(15);
            make.top.equalTo(self.view.mas_top).offset(kStatusBarHeight+5);
            make.size.mas_equalTo(CGSizeMake(30, 30));
        }];
        _close = close;
    }
    
    UIImageView *logo = [JLFactoryUtil imageViewWithImg:@"loginlogo"];
    [self.view addSubview:logo];
    [logo mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.top.equalTo(self.view.mas_top).offset(kTopHeight);
        make.size.mas_equalTo(CGSizeMake(84, 84));
    }];
    
    UILabel *tips = [JLFactoryUtil labelWithText:@"Welcome Back!" font:SEMIBOLDFONT(20) textColor:kMainTextColor];
    [self.view addSubview:tips];
    [tips mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(logo.mas_left);
        make.top.equalTo(logo.mas_bottom).offset(12);
    }];
    
    UIView *accview = [JLFactoryUtil view];
    [accview setCorner:8 withType:JLCornerTypeAllCorner];
    accview.layer.borderWidth = 1;
    accview.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
    [self.view addSubview:accview];
    [accview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.top.equalTo(tips.mas_bottom).offset(50);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    UIImageView *accImg = [JLFactoryUtil imageViewWithImg:@"账号icon"];
    [accview addSubview:accImg];
    [accImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(accview.mas_left).offset(15);
        make.centerY.equalTo(accview);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    self.areaCodeL = [JLFactoryUtil labelWithText:@"+86" font:REGULARFONT(13) textColor:kLightGrayTextColor];
    self.areaCodeL.textAlignment = NSTextAlignmentCenter;
    self.areaCodeL.userInteractionEnabled = YES;
    [accview addSubview:self.areaCodeL];
    [self.areaCodeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(accImg.mas_right).offset(0);
        make.width.mas_equalTo(55);
        make.centerY.equalTo(accImg);
    }];
    UITapGestureRecognizer *tapArea = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseAreaCode)];
    [self.areaCodeL addGestureRecognizer:tapArea];
    
    UIView *vline = [JLFactoryUtil view];
    vline.backgroundColor = kColorWithHex(@"#E6E6E6");
    [accview addSubview:vline];
    [vline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.areaCodeL.mas_right);
        make.centerY.equalTo(self.areaCodeL);
        make.size.mas_equalTo(CGSizeMake(1, 12));
    }];
    
    self.accTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Input phone number"];
    self.accTF.keyboardType = UIKeyboardTypePhonePad;
    self.accTF.textColor = kMainTextColor;
    [accview addSubview:self.accTF];
    [self.accTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(accview);
        make.left.equalTo(vline.mas_right).offset(10);
        make.right.equalTo(accview.mas_right).offset(-10);
        make.height.mas_equalTo(35);
    }];
    
    UIView *pwview = [JLFactoryUtil view];
    [pwview setCorner:8 withType:JLCornerTypeAllCorner];
    pwview.layer.borderWidth = 1;
    pwview.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
    [self.view addSubview:pwview];
    [pwview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.top.equalTo(accview.mas_bottom).offset(16);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    UIImageView *pwImg = [JLFactoryUtil imageViewWithImg:@"密码icon"];
    [pwview addSubview:pwImg];
    [pwImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(pwview.mas_left).offset(15);
        make.centerY.equalTo(pwview);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    self.pwTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Password"];
    self.pwTF.textColor = kMainTextColor;
    [pwview addSubview:self.pwTF];
    [self.pwTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(pwview);
        make.left.equalTo(pwImg.mas_right).offset(10);
        make.right.equalTo(pwview.mas_right).offset(-10);
        make.height.mas_equalTo(35);
    }];
    
    UIButton *forgetBtn = [JLFactoryUtil buttonWithTitle:@"Foegot password?" font:REGULARFONT(13) textColor:kMainTextColor];
    [forgetBtn addTarget:self action:@selector(forgetBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:forgetBtn];
    [forgetBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(pwview.mas_right);
        make.top.equalTo(pwview.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(140, 22));
    }];
    
    UIButton *loginBtn = [JLFactoryUtil buttonWithTitle:@"Login" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [loginBtn setCorner:24 withType:JLCornerTypeAllCorner];
    loginBtn.backgroundColor = kMainThemeColor;
    [loginBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [loginBtn addTarget:self action:@selector(loginBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:loginBtn];
    [loginBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(accview.mas_left);
        make.top.equalTo(forgetBtn.mas_bottom).offset(40);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"New User?" font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.view addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.view.mas_centerX);
        make.top.equalTo(loginBtn.mas_bottom).offset(15);
    }];
    
    UIButton *regBtn = [JLFactoryUtil buttonWithTitle:@"Sign Up" font:REGULARFONT(13) textColor:kMainTextColor];
    regBtn.contentEdgeInsets = UIEdgeInsetsMake(0, 5, 0, 5);
    [regBtn addTarget:self action:@selector(regBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:regBtn];
    [regBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_centerX);
        make.centerY.equalTo(label1);
    }];
    
    UIButton *proBtn = [JLFactoryUtil buttonWithTitle:@"Read Terms of User" font:REGULARFONT(13) textColor:kMainTextColor];
    [proBtn addTarget:self action:@selector(proBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:proBtn];
    [proBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(self.view.mas_bottom).offset(-100-HOME_INDICATOR_HEIGHT);
        make.centerX.equalTo(self.view);
        make.size.mas_equalTo(CGSizeMake(130, 22));
    }];
    
    UIButton *agreeBtn = [JLFactoryUtil buttonWithImage:@"未选中icon"];
    [agreeBtn setImage:[UIImage imageNamed:@"选中icon"] forState:UIControlStateSelected];
    [agreeBtn addTarget:self action:@selector(agreeBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:agreeBtn];
    [agreeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(proBtn.mas_left).offset(-1);
        make.centerY.equalTo(proBtn);
        make.size.mas_equalTo(CGSizeMake(30, 30));
    }];
    
    if (![UserManager shareManager].isLogin) {
        UIView *guestLoginView = [JLFactoryUtil view];
        [guestLoginView setCorner:24 withType:JLCornerTypeAllCorner];
        guestLoginView.layer.borderWidth = 1;
        guestLoginView.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
        [self.view addSubview:guestLoginView];
        [guestLoginView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(self.view);
            make.bottom.equalTo(self.view.mas_bottom).offset(-20-HOME_INDICATOR_HEIGHT);
            make.size.mas_equalTo(CGSizeMake(160, 48));
        }];
        UITapGestureRecognizer *tapGuest = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(guestLogin)];
        [guestLoginView addGestureRecognizer:tapGuest];
        
        UIImageView *guesImg = [JLFactoryUtil imageViewWithImg:@"游客"];
        guesImg.userInteractionEnabled = YES;
        [guestLoginView addSubview:guesImg];
        [guesImg mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerY.equalTo(guestLoginView);
            make.left.equalTo(guestLoginView.mas_left).offset(20);
            make.size.mas_equalTo(CGSizeMake(24, 24));
        }];
        
        UILabel *guesL = [JLFactoryUtil labelWithText:@"Guest Login" font:REGULARFONT(16) textColor:kMainTextColor];
        guesL.userInteractionEnabled = YES;
        [guestLoginView addSubview:guesL];
        [guesL mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerY.equalTo(guestLoginView);
            make.left.equalTo(guesImg.mas_right).offset(6);
        }];
    }
        
}

- (void)agreeBtnClick:(UIButton *)sender {
    sender.selected = !sender.selected;
    self.isAgree = sender.selected;
}

#pragma mark  协议
- (void)proBtnClick {
    [self.navigationController pushViewController:[BC_UserProtocolViewController new] animated:YES];
}

#pragma mark  忘记密码
- (void)forgetBtnClick {
    [self.navigationController pushViewController:[BC_ForgetPWViewController new] animated:YES];
}

#pragma mark  注册
- (void)regBtnClick {
    [self.navigationController pushViewController:[BC_RegisterViewController new] animated:YES];
}

#pragma mark  区号
- (void)chooseAreaCode {
    EVTPhoneAreaCodeViewController *code = [[EVTPhoneAreaCodeViewController alloc] init];
    code.localeEn = YES;
    @weakify(self);
    code.completion = ^(NSString *name, NSString *code) {
        @strongify(self);
        self.areaCodeL.text = kStringFormat(@"+%@", KStringIsNull(code));
    };
    [self.navigationController pushViewController:code animated:YES];
}

- (void)loginBtnClick {
    if (!_isAgree) {
        [BaseFunction showAlert:@"Please Read Terms of User"];
        return;
    }
    
    if ([KStringIsNull(self.accTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"please input phone number"];
        return;
    }
    
    if ([KStringIsNull(self.pwTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"please input password"];
        return;
    }
    
    [self.view endEditing:YES];
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/login/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"username":KStringIsNull(self.accTF.text), @"password":KStringIsNull(self.pwTF.text), @"logintype":@"1"} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSDictionary *infoDic = (NSDictionary *)dataDic[@"data"];
            [PPNetworkHelper setValue:kStringFormat(@"JWT %@", KStringIsNull(infoDic[@"access"])) forHTTPHeaderField:@"Authorization"];

            [self getUserSig:infoDic];
                                    
        } else if ([resdic[@"code"] integerValue] == 301) {
            //执行者完善信息
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSString *acc = @"";
            if ([KStringIsNull([UserManager shareManager].getUserInfo.access) isEqualToString:@""]) {
                acc = KStringIsNull(dataDic[@"access"]);
            } else {
                acc = KStringIsNull([UserManager shareManager].getUserInfo.access);
            }
            [PPNetworkHelper setValue:kStringFormat(@"JWT %@", KStringIsNull(acc)) forHTTPHeaderField:@"Authorization"];
            BC_CompleteUserInfoViewController *complete = [BC_CompleteUserInfoViewController new];
            complete.userid = KStringIsNull(dataDic[@"userId"]);
            [self.navigationController pushViewController:complete animated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
    
}

- (void)getUserSig:(NSDictionary *)infoDic {
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getusersig/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"getUserSig成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];

            NSString *iden = kStringFormat(@"%@", KStringIsNull(infoDic[@"userId"]));
            NSString *sig = KStringIsNull(dataDic[@"data"]);
            
            KLog(@"iden===%@ ===%@", iden, sig);
            [TUILogin login:SDKAPPID userID:iden userSig:sig succ:^{
                BaseUserModel *umodel = [BaseUserModel new];
                umodel.member_id = KStringIsNull(infoDic[@"userId"]);
                umodel.identity = KStringIsNull(infoDic[@"identity"]);
                umodel.access = KStringIsNull(infoDic[@"access"]);
                umodel.member_nickname = @"";
                umodel.member_avatar = @"";
                umodel.member_phone = KStringIsNull(self.accTF.text);
                umodel.TUIIden = KStringIsNull(iden);
                umodel.TUISig = KStringIsNull(sig);
                [[UserManager shareManager] saveUserInfoWithModel:umodel];
                [UserManager shareManager].isLogin = YES;
                [BaseFunction showAlert:@"Login success"];

                MainTabbarViewController *tabbar = [MainTabbarViewController new];
                kAppDelegate.window.backgroundColor = UIColor.whiteColor;
                kAppDelegate.window.rootViewController = tabbar;
                if ([KStringIsNull(umodel.identity) isEqualToString:@"1"]) {
                    //游客
                    [tabbar setupGuestTab];
                } else if ([KStringIsNull(umodel.identity) isEqualToString:@"2"]) {
                    //专业用户
                    [tabbar setupProfessionTab];
                } else if ([KStringIsNull(umodel.identity) isEqualToString:@"3"]) {
                    //执行者
                    [tabbar setupExecutorTab];
                } else if ([KStringIsNull(umodel.identity) isEqualToString:@"4"]) {
                    //督导
                    [tabbar setupSupervisorTab];
                }
                [kAppDelegate.window makeKeyAndVisible];
            } fail:^(int code, NSString *msg) {
                [BaseFunction showAlert:kStringFormat(@"IM login failed %i msg:%@ uid:%@ sig:%@", code, KStringIsNull(msg), KStringIsNull(iden), KStringIsNull(sig))];
            }];
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)getGueUserSig:(NSDictionary *)infoDic {
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getusersig/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"getUserSig成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];

            NSString *iden = kStringFormat(@"%@", KStringIsNull(infoDic[@"userId"]));
            NSString *sig = KStringIsNull(dataDic[@"data"]);
            [TUILogin login:SDKAPPID userID:iden userSig:sig succ:^{
                BaseUserModel *umodel = [BaseUserModel new];
                umodel.member_id = KStringIsNull(infoDic[@"userId"]);
                umodel.identity = KStringIsNull(infoDic[@"identity"]);
                umodel.access = KStringIsNull(infoDic[@"access"]);
                umodel.member_nickname = @"";
                umodel.member_avatar = @"";
                umodel.member_phone = @"";
                umodel.TUIIden = KStringIsNull(iden);
                umodel.TUISig = KStringIsNull(sig);
                [[UserManager shareManager] saveUserInfoWithModel:umodel];
                [kUserDefaults setObject:KStringIsNull(infoDic[@"userId"]) forKey:@"guestid"];
                [kUserDefaults synchronize];
                
                [UserManager shareManager].isLogin = YES;
                [BaseFunction showAlert:@"Login success"];
                
                MainTabbarViewController *tabbar = [MainTabbarViewController new];
                kAppDelegate.window.backgroundColor = UIColor.whiteColor;
                kAppDelegate.window.rootViewController = tabbar;
                [tabbar setupGuestTab];
                [kAppDelegate.window makeKeyAndVisible];
            } fail:^(int code, NSString *msg) {
                [BaseFunction showAlert:kStringFormat(@"IM login failed %i msg:%@ uid:%@ sig:%@", code, KStringIsNull(msg), KStringIsNull(iden), KStringIsNull(sig))];
            }];
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [BaseFunction showAlert:@"Error"];
    }];
}

#pragma mark  游客登录
- (void)guestLogin {
    if (!_isAgree) {
        [BaseFunction showAlert:@"Please Read Terms of User"];
        return;
    }
    NSString *gueid = KStringIsNull([kUserDefaults objectForKey:@"guestid"]);
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/login/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"username":KStringIsNull(gueid), @"password":KStringIsNull(gueid), @"logintype":@"2"} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSDictionary *infoDic = (NSDictionary *)dataDic[@"data"];
            [PPNetworkHelper setValue:kStringFormat(@"JWT %@", KStringIsNull(infoDic[@"access"])) forHTTPHeaderField:@"Authorization"];

            [self getGueUserSig:infoDic];
            
        } else {
            if ([resdic[@"code"] integerValue] == 501) {
                //清除访客id
                [kUserDefaults setObject:@"" forKey:@"guestid"];
                [kUserDefaults synchronize];
            }
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}
@end
