//
//  BC_RegisterTwoViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/13.
//

#import "BC_RegisterTwoViewController.h"
#import "EVTPhoneAreaCodeViewController.h"
#import "BC_LoginViewController.h"
#import "BC_UserProtocolViewController.h"
#import "BC_CompleteUserInfoViewController.h"
#import "MainTabbarViewController.h"
#import "TUILogin.h"
#import "GenerateTestUserSig.h"
@interface BC_RegisterTwoViewController ()
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;
@property (nonatomic, strong) UILabel *areaCodeL;
@property (nonatomic, strong) UITextField *accTF;
@property (nonatomic, strong) UITextField *codeTF;
@property (nonatomic, strong) UITextField *pwTF;
@property (nonatomic, strong) UITextField *confirmPWTF;
@property (nonatomic, strong) UIButton *getCodeBtn;

@property (nonatomic, assign) BOOL isAgree;
@end

@implementation BC_RegisterTwoViewController
- (void)backBtnClicked {
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.isAgree = NO;
    [self setupUI];
}

- (void)setupUI {
    
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight - HOME_INDICATOR_HEIGHT - 68)];
    self.scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:self.scrollView];
    
    self.contentView = [UIView new];
    self.contentView.backgroundColor = [UIColor whiteColor];
    [self.scrollView addSubview:self.contentView];
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.scrollView);
        make.width.equalTo(self.scrollView);
    }];
    
    UIImageView *logo = [JLFactoryUtil imageViewWithImg:@"loginlogo"];
    [self.contentView addSubview:logo];
    [logo mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(self.contentView.mas_top).offset(10);
        make.size.mas_equalTo(CGSizeMake(84, 84));
    }];
    
    UILabel *tips = [JLFactoryUtil labelWithText:@"Register an account" font:SEMIBOLDFONT(20) textColor:kMainTextColor];
    [self.contentView addSubview:tips];
    [tips mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(logo.mas_left);
        make.top.equalTo(logo.mas_bottom).offset(12);
    }];
    
    UIView *accview = [JLFactoryUtil view];
    [accview setCorner:8 withType:JLCornerTypeAllCorner];
    accview.layer.borderWidth = 1;
    accview.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
    [self.contentView addSubview:accview];
    [accview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(tips.mas_bottom).offset(40);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    UIImageView *accImg = [JLFactoryUtil imageViewWithImg:@"账号icon"];
    [accview addSubview:accImg];
    [accImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(accview.mas_left).offset(15);
        make.centerY.equalTo(accview);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    self.areaCodeL = [JLFactoryUtil labelWithText:@"+86" font:REGULARFONT(13) textColor:kLightGrayTextColor];
    self.areaCodeL.textAlignment = NSTextAlignmentCenter;
    self.areaCodeL.userInteractionEnabled = YES;
    [accview addSubview:self.areaCodeL];
    [self.areaCodeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(accImg.mas_right).offset(0);
        make.width.mas_equalTo(55);
        make.centerY.equalTo(accImg);
    }];
    UITapGestureRecognizer *tapArea = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseAreaCode)];
    [self.areaCodeL addGestureRecognizer:tapArea];
    
    UIView *vline = [JLFactoryUtil view];
    vline.backgroundColor = kColorWithHex(@"#E6E6E6");
    [accview addSubview:vline];
    [vline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.areaCodeL.mas_right);
        make.centerY.equalTo(self.areaCodeL);
        make.size.mas_equalTo(CGSizeMake(1, 12));
    }];
    
    self.accTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Input mobile Phone number"];
    self.accTF.keyboardType = UIKeyboardTypePhonePad;
    self.accTF.textColor = kMainTextColor;
    [accview addSubview:self.accTF];
    [self.accTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(accview);
        make.left.equalTo(vline.mas_right).offset(10);
        make.right.equalTo(accview.mas_right).offset(-10);
        make.height.mas_equalTo(35);
    }];
    
    UIView *codeView = [JLFactoryUtil view];
    [codeView setCorner:8 withType:JLCornerTypeAllCorner];
    codeView.layer.borderWidth = 1;
    codeView.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
    [self.contentView addSubview:codeView];
    [codeView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(accview.mas_bottom).offset(16);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    self.codeTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Please enter verification code"];
    self.codeTF.textColor = kMainTextColor;
    if (@available(iOS 12.0, *)) {
        self.codeTF.textContentType = UITextContentTypeOneTimeCode;
    } else {
        // Fallback on earlier versions
    }
    [codeView addSubview:self.codeTF];
    [self.codeTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(codeView);
        make.left.equalTo(codeView.mas_left).offset(10);
        make.right.equalTo(codeView.mas_right).offset(-112);
        make.height.mas_equalTo(35);
    }];
    
    self.getCodeBtn = [JLFactoryUtil buttonWithTitle:@"Verification" font:REGULARFONT(14) textColor:UIColor.whiteColor];
    self.getCodeBtn.backgroundColor = kMainThemeColor;
    [self.getCodeBtn setCorner:18 withType:JLCornerTypeAllCorner];
    [self.getCodeBtn setLayerShadow:[UIColor colorWithRed:230/255.0 green:0/255.0 blue:0/255.0 alpha:0.6] offset:CGSizeMake(0, 0) radius:4];
    [self.getCodeBtn addTarget:self action:@selector(getCodeBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [codeView addSubview:self.getCodeBtn];
    [self.getCodeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.codeTF);
        make.left.equalTo(self.codeTF.mas_right).offset(10);
        make.right.equalTo(codeView.mas_right).offset(-10);
        make.height.mas_equalTo(36);
    }];
    
    UIView *pwview = [JLFactoryUtil view];
    [pwview setCorner:8 withType:JLCornerTypeAllCorner];
    pwview.layer.borderWidth = 1;
    pwview.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
    [self.contentView addSubview:pwview];
    [pwview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(codeView.mas_bottom).offset(16);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    UIImageView *pwImg = [JLFactoryUtil imageViewWithImg:@"密码icon"];
    [pwview addSubview:pwImg];
    [pwImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(pwview.mas_left).offset(15);
        make.centerY.equalTo(pwview);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    self.pwTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Set Password"];
    self.pwTF.textColor = kMainTextColor;
    [pwview addSubview:self.pwTF];
    [self.pwTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(pwview);
        make.left.equalTo(pwImg.mas_right).offset(10);
        make.right.equalTo(pwview.mas_right).offset(-10);
        make.height.mas_equalTo(35);
    }];
    
    UIView *pwview2 = [JLFactoryUtil view];
    [pwview2 setCorner:8 withType:JLCornerTypeAllCorner];
    pwview2.layer.borderWidth = 1;
    pwview2.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
    [self.contentView addSubview:pwview2];
    [pwview2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(pwview.mas_bottom).offset(16);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    UIImageView *pwImg2 = [JLFactoryUtil imageViewWithImg:@"密码icon"];
    [pwview2 addSubview:pwImg2];
    [pwImg2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(pwview2.mas_left).offset(15);
        make.centerY.equalTo(pwview2);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    self.confirmPWTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Confirm Password"];
    self.confirmPWTF.textColor = kMainTextColor;
    [pwview2 addSubview:self.confirmPWTF];
    [self.confirmPWTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(pwview2);
        make.left.equalTo(pwImg2.mas_right).offset(10);
        make.right.equalTo(pwview2.mas_right).offset(-10);
        make.height.mas_equalTo(35);
    }];
    
    UIButton *agreeBtn = [JLFactoryUtil buttonWithImage:@"未选中icon"];
    [agreeBtn setImage:[UIImage imageNamed:@"选中icon"] forState:UIControlStateSelected];
    [agreeBtn addTarget:self action:@selector(agreeBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:agreeBtn];
    [agreeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(pwview2.mas_left);
        make.top.equalTo(pwview2.mas_bottom).offset(15);
        make.size.mas_equalTo(CGSizeMake(30, 30));
    }];
    
    UIButton *proBtn = [JLFactoryUtil buttonWithTitle:@"Read Terms of User" font:REGULARFONT(13) textColor:kMainTextColor];
    [proBtn addTarget:self action:@selector(proBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:proBtn];
    [proBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(agreeBtn);
        make.left.equalTo(agreeBtn.mas_right).offset(1);
        make.size.mas_equalTo(CGSizeMake(130, 22));
    }];
        
    UIButton *loginBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [loginBtn setCorner:24 withType:JLCornerTypeAllCorner];
    loginBtn.backgroundColor = kMainThemeColor;
    [loginBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [loginBtn addTarget:self action:@selector(loginBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:loginBtn];
    [loginBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(accview.mas_left);
        make.top.equalTo(proBtn.mas_bottom).offset(40);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    UIButton *signinBtn = [JLFactoryUtil buttonWithTitle:@"Sign in" font:REGULARFONT(13) textColor:kMainTextColor];
    [signinBtn addTarget:self action:@selector(signinBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:signinBtn];
    [signinBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(loginBtn.mas_right);
        make.top.equalTo(loginBtn.mas_bottom).offset(15);
        make.size.mas_equalTo(CGSizeMake(60, 22));
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(signinBtn.mas_bottom).offset(50);
    }];
    
    if (![UserManager shareManager].isLogin) {
        UIView *guestLoginView = [JLFactoryUtil view];
        [guestLoginView setCorner:24 withType:JLCornerTypeAllCorner];
        guestLoginView.layer.borderWidth = 1;
        guestLoginView.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
        [self.view addSubview:guestLoginView];
        [guestLoginView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(self.view);
            make.bottom.equalTo(self.view.mas_bottom).offset(-20-HOME_INDICATOR_HEIGHT);
            make.size.mas_equalTo(CGSizeMake(160, 48));
        }];
        UITapGestureRecognizer *tapGuest = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(guestLogin)];
        [guestLoginView addGestureRecognizer:tapGuest];
        
        UIImageView *guesImg = [JLFactoryUtil imageViewWithImg:@"游客"];
        guesImg.userInteractionEnabled = YES;
        [guestLoginView addSubview:guesImg];
        [guesImg mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerY.equalTo(guestLoginView);
            make.left.equalTo(guestLoginView.mas_left).offset(20);
            make.size.mas_equalTo(CGSizeMake(24, 24));
        }];
        
        UILabel *guesL = [JLFactoryUtil labelWithText:@"Guest Login" font:REGULARFONT(16) textColor:kMainTextColor];
        guesL.userInteractionEnabled = YES;
        [guestLoginView addSubview:guesL];
        [guesL mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerY.equalTo(guestLoginView);
            make.left.equalTo(guesImg.mas_right).offset(6);
        }];
    }
}

- (void)agreeBtnClick:(UIButton *)sender {
    sender.selected = !sender.selected;
    self.isAgree = sender.selected;
}

#pragma mark  协议
- (void)proBtnClick {
    [self.navigationController pushViewController:[BC_UserProtocolViewController new] animated:YES];
}

#pragma mark  游客登录
- (void)guestLogin {
    [self.view endEditing:YES];
    NSString *gueid = KStringIsNull([kUserDefaults objectForKey:@"guestid"]);
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/login/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"username":KStringIsNull(gueid), @"password":KStringIsNull(gueid), @"logintype":@"2"} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSDictionary *infoDic = (NSDictionary *)dataDic[@"data"];
            [PPNetworkHelper setValue:kStringFormat(@"JWT %@", KStringIsNull(infoDic[@"access"])) forHTTPHeaderField:@"Authorization"];

            [self getUserSig:infoDic];
        } else {
            if ([resdic[@"code"] integerValue] == 501) {
                //清除访客id
                [kUserDefaults setObject:@"" forKey:@"guestid"];
                [kUserDefaults synchronize];
            }
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)getUserSig:(NSDictionary *)infoDic {
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getusersig/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"getUserSig成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];

            NSString *iden = kStringFormat(@"%@", KStringIsNull(infoDic[@"userId"]));
            NSString *sig = KStringIsNull(dataDic[@"data"]);

            [TUILogin login:SDKAPPID userID:iden userSig:sig succ:^{
                BaseUserModel *umodel = [BaseUserModel new];
                umodel.member_id = KStringIsNull(infoDic[@"userId"]);
                umodel.identity = KStringIsNull(infoDic[@"identity"]);
                umodel.access = KStringIsNull(infoDic[@"access"]);
                umodel.member_nickname = @"";
                umodel.member_avatar = @"";
                umodel.member_phone = @"";
                umodel.TUIIden = KStringIsNull(iden);
                umodel.TUISig = KStringIsNull(sig);
                [[UserManager shareManager] saveUserInfoWithModel:umodel];
                [UserManager shareManager].isLogin = YES;
                [BaseFunction showAlert:@"Login success"];
                [kUserDefaults setObject:KStringIsNull(infoDic[@"userId"]) forKey:@"guestid"];
                [kUserDefaults synchronize];
                MainTabbarViewController *tabbar = [MainTabbarViewController new];
                kAppDelegate.window.backgroundColor = UIColor.whiteColor;
                kAppDelegate.window.rootViewController = tabbar;
                [tabbar setupGuestTab];
                [kAppDelegate.window makeKeyAndVisible];
            } fail:^(int code, NSString *msg) {
                [BaseFunction showAlert:KStringIsNull(msg)];
            }];
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)signinBtnClick {
    for (UIViewController *vc in self.navigationController.viewControllers) {
        if ([vc isKindOfClass:[BC_LoginViewController class]]) {
            [self.navigationController popToViewController:vc animated:YES];
            break;
        }
    }
}

#pragma mark  区号
- (void)chooseAreaCode {
    EVTPhoneAreaCodeViewController *code = [[EVTPhoneAreaCodeViewController alloc] init];
    code.localeEn = YES;
    @weakify(self);
    code.completion = ^(NSString *name, NSString *code) {
        @strongify(self);
        self.areaCodeL.text = kStringFormat(@"+%@", KStringIsNull(code));
    };
    [self.navigationController pushViewController:code animated:YES];
}

- (void)getCodeBtnClick {
    if ([KStringIsNull(self.accTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"please input phone number"];
        return;
    }
    [self.view endEditing:YES];
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/sendsms/", KMainUrl];
    NSString *ccode = [KStringIsNull(self.areaCodeL.text) substringFromIndex:1];
    [PPNetworkHelper POST:url parameters:@{@"mobile":KStringIsNull(self.accTF.text), @"smstype":@"register", @"countrycode":KStringIsNull(ccode)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [BaseFunction showAlert:@"Send success"];
            [self countTime];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)countTime {
    __block int timeout=60; //倒计时时间
    dispatch_queue_t queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    dispatch_source_t _timer = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0,queue);
    dispatch_source_set_timer(_timer,dispatch_walltime(NULL, 0),1.0*NSEC_PER_SEC, 0); //每秒执行
    dispatch_source_set_event_handler(_timer, ^{
        if(timeout<=0){ //倒计时结束，关闭
            dispatch_source_cancel(_timer);
            //dispatch_release(_timer);
            dispatch_async(dispatch_get_main_queue(), ^{
                self->_getCodeBtn.enabled = YES;
                [self->_getCodeBtn setTitle:@"Verification" forState:0];
            });
        }else{
            dispatch_async(dispatch_get_main_queue(), ^{
                self->_getCodeBtn.enabled = NO;
                [self->_getCodeBtn setTitle:[NSString stringWithFormat:@"%ds",timeout] forState:0];
            });
            timeout--;
        }
    });
    dispatch_resume(_timer);
}

- (void)loginBtnClick {
    
    
    if (!_isAgree) {
        [BaseFunction showAlert:@"Please Read Terms of User"];
        return;
    }
    
    if ([KStringIsNull(self.accTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"please input phone number"];
        return;
    }
    
    if ([KStringIsNull(self.codeTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"please input verification code"];
        return;
    }
    
    if ([KStringIsNull(self.pwTF.text) isEqualToString:@""] || [KStringIsNull(self.confirmPWTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"please input password"];
        return;
    }
    
    if (![KStringIsNull(self.pwTF.text) isEqualToString:KStringIsNull(self.confirmPWTF.text)]) {
        [BaseFunction showAlert:@"Passwords are not the same"];
        return;
    }
    
    [self.view endEditing:YES];
    
    NSString *visiid = @"";
    if ([KStringIsNull([UserManager shareManager].getUserInfo.identity) isEqualToString:@"1"]) {
        visiid = KStringIsNull([UserManager shareManager].getUserInfo.member_id);
    } else {
        visiid = @"";
    }
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/register/", KMainUrl];
    NSDictionary *para = @{@"mobile":KStringIsNull(self.accTF.text), @"code":KStringIsNull(self.codeTF.text), @"password":KStringIsNull(self.pwTF.text), @"password2":KStringIsNull(self.confirmPWTF.text), @"identity":KStringIsNull(self.type), @"visitorid":visiid};
    KLog(@"para====%@", para);
    [PPNetworkHelper POST:url parameters:para success:^(id responseObject) {
        KLog(@"注册成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            [BaseFunction showAlert:@"Success"];
            if ([KStringIsNull(self.type) isEqualToString:@"2"]) {
                //专业用户成功
                [[UserManager shareManager] cleanUserInfo];
                [UserManager shareManager].isLogin = NO;
                [kNotificationCenter postNotificationName:@"hideLoginPopBtn" object:nil];
                for (UIViewController *vc in self.navigationController.viewControllers) {
                    if ([vc isKindOfClass:[BC_LoginViewController class]]) {
                        [self.navigationController popToViewController:vc animated:YES];
                        break;
                    }
                }
            } else {
                BC_CompleteUserInfoViewController *complete = [BC_CompleteUserInfoViewController new];
                complete.userid = KStringIsNull(dataDic[@"data"]);
                [self.navigationController pushViewController:complete animated:YES];
            }
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
    
}
@end
