//
//  BC_RegisterViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/13.
//

#import "BC_RegisterViewController.h"
#import "BC_RegisterTwoViewController.h"
#import "MainTabbarViewController.h"
#import "TUILogin.h"
#import "GenerateTestUserSig.h"
@interface BC_RegisterViewController ()

@end

@implementation BC_RegisterViewController

- (void)backBtnClicked {
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    UIImageView *userImg = [JLFactoryUtil imageViewWithImg:@"用户注册"];
    userImg.userInteractionEnabled = YES;
    [self.view addSubview:userImg];
    [userImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(28);
        make.top.equalTo(self.view.mas_top).offset(12);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth  -56, 120));
    }];
    UITapGestureRecognizer *tapUser = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseUser)];
    [userImg addGestureRecognizer:tapUser];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"I look for a contractor\n-Registration" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    label1.numberOfLines = 0;
    label1.userInteractionEnabled = YES;
    [userImg addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(userImg.mas_left).offset(20);
        make.top.equalTo(userImg.mas_top).offset(30);
        make.width.mas_equalTo(175);
    }];
    
    UIImageView *workerImg = [JLFactoryUtil imageViewWithImg:@"工人注册"];
    workerImg.userInteractionEnabled = YES;
    [self.view addSubview:workerImg];
    [workerImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(28);
        make.top.equalTo(userImg.mas_bottom).offset(30);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth  -56, 120));
    }];
    UITapGestureRecognizer *tapWorker = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseWorker)];
    [workerImg addGestureRecognizer:tapWorker];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"I am a service provider\n-Registration" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    label2.numberOfLines = 0;
    label2.userInteractionEnabled = YES;
    [workerImg addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(workerImg.mas_left).offset(20);
        make.top.equalTo(workerImg.mas_top).offset(30);
        make.width.mas_equalTo(175);
    }];
    
    if (![UserManager shareManager].isLogin) {
        
        UIImageView *imgv = [JLFactoryUtil imageViewWithImg:@"游客登录"];
        imgv.userInteractionEnabled = YES;
        [self.view addSubview:imgv];
        [imgv mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(self.view);
            make.bottom.equalTo(self.view.mas_bottom).offset(-40-HOME_INDICATOR_HEIGHT);
            make.size.mas_equalTo(CGSizeMake(176, 64));
        }];
        UITapGestureRecognizer *tapGuest = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(guestLogin)];
        [imgv addGestureRecognizer:tapGuest];
        
        UILabel *guesL = [JLFactoryUtil labelWithText:@"Guest Login" font:MEDIUMFONT(16) textColor:kColorWithHex(@"#FE8351")];
        guesL.userInteractionEnabled = YES;
        [imgv addSubview:guesL];
        [guesL mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerY.equalTo(imgv);
            make.left.equalTo(imgv.mas_left).offset(10);
        }];
    
    }
}

#pragma mark  游客登录
- (void)guestLogin {

    NSString *gueid = KStringIsNull([kUserDefaults objectForKey:@"guestid"]);
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/login/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"username":KStringIsNull(gueid), @"password":KStringIsNull(gueid), @"logintype":@"2"} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSDictionary *infoDic = (NSDictionary *)dataDic[@"data"];
            [PPNetworkHelper setValue:kStringFormat(@"JWT %@", KStringIsNull(infoDic[@"access"])) forHTTPHeaderField:@"Authorization"];

            [self getUserSig:infoDic];
            
        } else {
            if ([resdic[@"code"] integerValue] == 501) {
                //清除访客id
                [kUserDefaults setObject:@"" forKey:@"guestid"];
                [kUserDefaults synchronize];
            }
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)getUserSig:(NSDictionary *)infoDic {
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getusersig/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"getUserSig成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];

            NSString *iden = kStringFormat(@"%@", KStringIsNull(infoDic[@"userId"]));
            NSString *sig = KStringIsNull(dataDic[@"data"]);

            [TUILogin login:SDKAPPID userID:iden userSig:sig succ:^{
                BaseUserModel *umodel = [BaseUserModel new];
                umodel.member_id = KStringIsNull(infoDic[@"userId"]);
                umodel.identity = KStringIsNull(infoDic[@"identity"]);
                umodel.access = KStringIsNull(infoDic[@"access"]);
                umodel.member_nickname = @"";
                umodel.member_avatar = @"";
                umodel.member_phone = @"";
                umodel.TUIIden = KStringIsNull(iden);
                umodel.TUISig = KStringIsNull(sig);
                [[UserManager shareManager] saveUserInfoWithModel:umodel];
                [UserManager shareManager].isLogin = YES;
                [BaseFunction showAlert:@"Login success"];
                [kUserDefaults setObject:KStringIsNull(infoDic[@"userId"]) forKey:@"guestid"];
                [kUserDefaults synchronize];
                MainTabbarViewController *tabbar = [MainTabbarViewController new];
                kAppDelegate.window.backgroundColor = UIColor.whiteColor;
                kAppDelegate.window.rootViewController = tabbar;
                [tabbar setupGuestTab];
                [kAppDelegate.window makeKeyAndVisible];
            } fail:^(int code, NSString *msg) {
                [BaseFunction showAlert:KStringIsNull(msg)];
            }];
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)chooseUser {
    BC_RegisterTwoViewController *reg = [BC_RegisterTwoViewController new];
    reg.type = @"2";
    [self.navigationController pushViewController:reg animated:YES];
}

- (void)chooseWorker {
    BC_RegisterTwoViewController *reg = [BC_RegisterTwoViewController new];
    reg.type = @"3";
    [self.navigationController pushViewController:reg animated:YES];
}

@end
