//
//  AreaCodeViewController.m
//  AreaCodeViewController
//
//  Created by everettjf on 16/6/8.
//  Copyright © 2016年 everettjf. All rights reserved.
//

#import "EVTPhoneAreaCodeViewController.h"

#define UIColorFromRGBA(rgbValue, alphaValue) \
    [UIColor \
    colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 \
    green:((float)((rgbValue & 0x00FF00) >> 8))/255.0 \
    blue:((float)(rgbValue & 0x0000FF))/255.0 \
    alpha:alphaValue]

@implementation EVTPhoneAreaCodeViewControllerTheme

- (instancetype)init
{
    self = [super init];
    if (self) {
//        _backgroundColor = UIColorFromRGBA(0x8ee2d3, 1.0);
        _backgroundColor = UIColorFromRGBA(0xf0f7f6, 1.0);
        _sectionBackgroundColor = UIColorFromRGBA(0xf0f7f6, 1.0);
        _sectionForegroundColor = UIColorFromRGBA(0x808080, 1.0);
        _tableViewBackgroundColor = UIColorFromRGBA(0xf0f7f6, 1.0);
        _tableViewSeparatorColor = UIColorFromRGBA(0xc8c7cc, 1.0);
        _sectionIndexBackgroundColor = [UIColor clearColor];
        _sectionIndexColor = UIColorFromRGBA(0x6a6677, 1.0);
        _searchBarTintColor = [UIColor whiteColor];
        _searchBarBackgroundColor = UIColorFromRGBA(0xf0f7f6, 1.0);
        
        _sectionFont = [UIFont systemFontOfSize:18];
        _sectionHeight = 25;
        _title = @"选择国家";
        _titleEn = @"Choose Area Code";
        _searchBarPlaceHolder = @"搜索";
        _searchBarPlaceHolderEn = @"Search";
    }
    return self;
}

+ (EVTPhoneAreaCodeViewControllerTheme *)defaultTheme{
    EVTPhoneAreaCodeViewControllerTheme *t = [[EVTPhoneAreaCodeViewControllerTheme alloc]init];
    return t;
}

+ (EVTPhoneAreaCodeViewControllerTheme *)whiteTheme{
    EVTPhoneAreaCodeViewControllerTheme *t = [[EVTPhoneAreaCodeViewControllerTheme alloc]init];
    t.backgroundColor = [UIColor whiteColor];
    t.sectionBackgroundColor = [UIColor whiteColor];
    t.sectionForegroundColor = [UIColor blackColor];
    t.tableViewBackgroundColor = [UIColor whiteColor];
    t.tableViewSeparatorColor = [UIColor blackColor];
    t.sectionIndexBackgroundColor = [UIColor clearColor];
    t.sectionIndexColor = [UIColor blackColor];
    t.searchBarTintColor = [UIColor whiteColor];
    t.searchBarBackgroundColor = [UIColor whiteColor];
    
    return t;
}

+ (EVTPhoneAreaCodeViewControllerTheme *)grayTheme{
    EVTPhoneAreaCodeViewControllerTheme *t = [[EVTPhoneAreaCodeViewControllerTheme alloc]init];
    t.backgroundColor = [UIColor grayColor];
    t.sectionBackgroundColor = [UIColor grayColor];
    t.sectionForegroundColor = [UIColor whiteColor];
    t.tableViewBackgroundColor = [UIColor grayColor];
    t.tableViewSeparatorColor = [UIColor blackColor];
    t.sectionIndexBackgroundColor = [UIColor clearColor];
    t.sectionIndexColor = [UIColor grayColor];
    t.searchBarTintColor = [UIColor grayColor];
    t.searchBarBackgroundColor = [UIColor whiteColor];
    
    return t;
}

+ (EVTPhoneAreaCodeViewControllerTheme *)greenTheme{
    EVTPhoneAreaCodeViewControllerTheme *t = [[EVTPhoneAreaCodeViewControllerTheme alloc]init];
    t.backgroundColor = [UIColor greenColor];
    t.sectionBackgroundColor = [UIColor greenColor];
    t.sectionForegroundColor = [UIColor whiteColor];
    t.tableViewBackgroundColor = [UIColor greenColor];
    t.tableViewSeparatorColor = [UIColor blackColor];
    t.sectionIndexBackgroundColor = [UIColor clearColor];
    t.sectionIndexColor = [UIColor greenColor];
    t.searchBarTintColor = [UIColor greenColor];
    t.searchBarBackgroundColor = [UIColor whiteColor];
    
    return t;
}

+ (EVTPhoneAreaCodeViewControllerTheme *)redTheme{
    EVTPhoneAreaCodeViewControllerTheme *t = [[EVTPhoneAreaCodeViewControllerTheme alloc]init];
    t.backgroundColor = [UIColor redColor];
    t.sectionBackgroundColor = [UIColor redColor];
    t.sectionForegroundColor = [UIColor whiteColor];
    t.tableViewBackgroundColor = [UIColor redColor];
    t.tableViewSeparatorColor = [UIColor blackColor];
    t.sectionIndexBackgroundColor = [UIColor clearColor];
    t.sectionIndexColor = [UIColor redColor];
    t.searchBarTintColor = [UIColor redColor];
    t.searchBarBackgroundColor = [UIColor whiteColor];
    
    return t;
}

+ (EVTPhoneAreaCodeViewControllerTheme *)orangeTheme{
    EVTPhoneAreaCodeViewControllerTheme *t = [[EVTPhoneAreaCodeViewControllerTheme alloc]init];
    t.backgroundColor = [UIColor orangeColor];
    t.sectionBackgroundColor = [UIColor orangeColor];
    t.sectionForegroundColor = [UIColor whiteColor];
    t.tableViewBackgroundColor = [UIColor orangeColor];
    t.tableViewSeparatorColor = [UIColor blackColor];
    t.sectionIndexBackgroundColor = [UIColor clearColor];
    t.sectionIndexColor = [UIColor orangeColor];
    t.searchBarTintColor = [UIColor orangeColor];
    t.searchBarBackgroundColor = [UIColor whiteColor];
    
    return t;
}

@end

@interface EVTPhoneAreaCode: NSObject
@property (strong,nonatomic) NSString *name;
@property (strong,nonatomic) NSString *alphaName;
@property (strong,nonatomic) NSString *code;
@property (strong,nonatomic) NSString *firstChar;
@end
@implementation EVTPhoneAreaCode
@end

@interface EVTPhoneAreaCodeViewController ()<UITableViewDelegate, UITableViewDataSource, UISearchBarDelegate>{
    NSMutableArray<NSMutableArray<EVTPhoneAreaCode*>*> *_codes;
    NSMutableArray<NSString*> *_sectionTitles;
    
    NSMutableArray<EVTPhoneAreaCode*> *_allCodes;
    
    UITableView *_tableView;
    
    NSArray<EVTPhoneAreaCode*> *_filterCodes;
}
@property (nonatomic, strong) UISearchBar *search;
@property (nonatomic, strong) UITableView *resultTB;
@property (nonatomic, strong) UILabel *rightLabel;
@end

@implementation EVTPhoneAreaCodeViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    if(!_theme)_theme = [[EVTPhoneAreaCodeViewControllerTheme alloc]init];
    
    self.navigationItem.title = _localeEn?_theme.titleEn:_theme.title;
    
    _codes = [NSMutableArray new];
    _sectionTitles = [NSMutableArray new];
    _filterCodes = @[];
    
    [self _setupUI];
    
    [self _loadData];
}

- (void)_setupUI{
    self.view.backgroundColor = _theme.backgroundColor;
    
    UISearchBar *search = [[UISearchBar alloc] initWithFrame:CGRectMake(15, 10, kScreenWidth - 30, 36)];
    search.placeholder = @"Search";
    search.searchBarStyle = UISearchBarStyleMinimal;
    search.delegate = self;
    [self.view addSubview:search];
    _search = search;
    
    _tableView = [[UITableView alloc]initWithFrame:CGRectMake(0, 56, kScreenWidth, kScreenHeight - kTopHeight - 56) style:UITableViewStylePlain];
    _tableView.delegate = self;
    _tableView.dataSource = self;
    [_tableView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"Cell"];
    _tableView.allowsSelection = YES;
    
    if(_theme.sectionIndexBackgroundColor)
        _tableView.sectionIndexBackgroundColor = _theme.sectionIndexBackgroundColor;
    if(_theme.sectionIndexColor)
        _tableView.sectionIndexColor = _theme.sectionIndexColor;
    if(_theme.tableViewBackgroundColor)
        _tableView.backgroundColor = _theme.tableViewBackgroundColor;
    [self.view addSubview:_tableView];
    
    _resultTB = [[UITableView alloc]initWithFrame:CGRectMake(0, 56, kScreenWidth, kScreenHeight - kTopHeight) style:UITableViewStylePlain];
    _resultTB.delegate = self;
    _resultTB.dataSource = self;
    [_resultTB registerClass:[UITableViewCell class] forCellReuseIdentifier:@"Cell"];
    _resultTB.allowsSelection = YES;
    [self.view addSubview:_resultTB];
    if(_theme.sectionIndexBackgroundColor)
        _resultTB.sectionIndexBackgroundColor = _theme.sectionIndexBackgroundColor;
    if(_theme.sectionIndexColor)
        _resultTB.sectionIndexColor = _theme.sectionIndexColor;
    if(_theme.tableViewBackgroundColor)
        _resultTB.backgroundColor = _theme.tableViewBackgroundColor;
    _resultTB.hidden = YES;
}

- (NSString *)_readFromMainBundle:(NSString*)resource{
    NSBundle *bundle = [NSBundle mainBundle];
    NSURL *codePath = [[bundle resourceURL] URLByAppendingPathComponent:resource];
    NSError *error;
    NSString *codeSource = [NSString stringWithContentsOfURL:codePath encoding:NSUTF8StringEncoding error:&error];
    if(error)return nil;
    return codeSource;
}

- (void)_loadData{
    NSString *resName = @"evt_phone_area_code_zh.txt";
    if(_localeEn) resName = @"evt_phone_area_code_en.txt";
    NSString *codeSource = [self _readFromMainBundle:resName];
    if(!codeSource) return;
    
    NSArray<NSString*> *lines = [codeSource componentsSeparatedByCharactersInSet:[NSCharacterSet newlineCharacterSet]];
    
    _allCodes = [NSMutableArray new];
    
    NSMutableDictionary * dicts = [NSMutableDictionary new];
    for (NSString *line in lines) {
        NSArray<NSString*> *parts = [line componentsSeparatedByString:@"="];
        
        EVTPhoneAreaCode *code = [EVTPhoneAreaCode new];
        if(parts.count == 3){
            code.name = parts[0];
            code.alphaName = parts[1];
            code.code = parts[2];
        }else if(parts.count == 2){
            code.name = parts[0];
            code.alphaName = parts[0];
            code.code = parts[1];
        }else{
            continue;
        }
        
        code.firstChar = [code.alphaName substringToIndex:1];
        
        NSMutableArray *items = [dicts objectForKey:code.firstChar];
        if(!items) {
            items = [NSMutableArray new];
            [dicts setObject:items forKey:code.firstChar];
        }
        
        [items addObject:code];
        [_allCodes addObject:code];
    }
    
    _codes = [NSMutableArray new];
    for (NSString *firstChar in dicts) {
        [_codes addObject:[dicts objectForKey:firstChar]];
    }
    [_codes sortUsingComparator:^NSComparisonResult(NSMutableArray<EVTPhoneAreaCode*>*  _Nonnull obj1, NSMutableArray<EVTPhoneAreaCode*>*  _Nonnull obj2) {
        return [obj1.firstObject.firstChar compare:obj2.firstObject.firstChar];
    }];
    
    _sectionTitles = [NSMutableArray new];
    for (NSMutableArray<EVTPhoneAreaCode*> *code in _codes) {
        [_sectionTitles addObject:code.firstObject.firstChar];
    }
    
    [_tableView reloadData];
    
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    if(tableView == _tableView)
        return _theme.sectionHeight;
    return 0;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 50;
}

- (NSArray<NSString *> *)sectionIndexTitlesForTableView:(UITableView *)tableView{
    if(tableView == _tableView)
        return _sectionTitles;
    return @[];
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
    if(tableView == _tableView)
        return _sectionTitles[section];
    return @"";
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    if(tableView == _tableView)
        return _codes.count;
    return 1;
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    if(tableView == _tableView){
        return _codes[section].count;
    }else{
        NSPredicate *predicate = [NSPredicate predicateWithFormat:@"name contains[cd] %@ or alphaName contains[cd] %@",
                                  KStringIsNull(_search.text),
                                  KStringIsNull(_search.text)
                                  ];
        _filterCodes = [_allCodes filteredArrayUsingPredicate:predicate];
        return _filterCodes.count;
    }
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{

    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"Cell" forIndexPath:indexPath];
    
    [cell.contentView removeAllSubviews];
    UILabel *rightLabel = [UILabel new];
    rightLabel.font = REGULARFONT(16);
    rightLabel.textColor = kColorWithHex(@"#8E8E8E");
    [cell.contentView addSubview:rightLabel];
    [rightLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(cell.contentView);
        make.right.equalTo(cell.contentView.mas_right).offset(-15);
    }];
    
    if(tableView == _tableView){
        cell.textLabel.text = _codes[indexPath.section][indexPath.row].name;
        rightLabel.text = kStringFormat(@"+%@", KStringIsNull(_codes[indexPath.section][indexPath.row].code));
    }else{
        cell.textLabel.text = _filterCodes[indexPath.row].name;
        rightLabel.text = kStringFormat(@"+%@", KStringIsNull(_filterCodes[indexPath.row].code));
    }
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    // select
    EVTPhoneAreaCode *code;
    if(tableView == _tableView) code = _codes[indexPath.section][indexPath.row];
    else code = _filterCodes[indexPath.row];
    
    if(self.completion) {
        self.completion(code.name,code.code);
    }
    [self.navigationController popViewControllerAnimated:YES];
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section{
    if(tableView != _tableView)
        return nil;
    
    UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, _theme.sectionHeight)];
    
    label.backgroundColor = _theme.sectionBackgroundColor;
    label.text = [NSString stringWithFormat:@"    %@", _sectionTitles[section]];
    label.font = _theme.sectionFont;
    label.textColor = _theme.sectionForegroundColor;
    return label;
}

- (void)searchBarCancelButtonClicked:(UISearchBar *)searchBar {
    self.search.text = @"";
    [self.search resignFirstResponder];
    [searchBar setShowsCancelButton:NO animated:YES];
    self.resultTB.hidden = YES;
}

- (void)searchBarTextDidEndEditing:(UISearchBar *)searchBar {
    [searchBar setShowsCancelButton:NO animated:YES];
}

-(void)searchBarTextDidBeginEditing:(UISearchBar *)searchBar {
    [searchBar setShowsCancelButton:YES animated:YES];
}

- (void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText {
    if (![KStringIsNull(searchText) isEqualToString:@""]) {
        self.resultTB.hidden = NO;
    }
    [self.resultTB reloadData];
}

@end
