//
//  BC_MessageViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/13.
//

#import "BC_MessageViewController.h"
#import "BC_GroupChatListViewController.h"

#import "BC_NotifySubListViewController.h"
#import "BC_UserCommentViewController.h"

#import <JXCategoryView.h>
@interface BC_MessageViewController ()<JXCategoryViewDelegate, JXCategoryListContainerViewDelegate>
@property (nonatomic, strong) JXCategoryTitleView *categoryView;
@property (nonatomic, strong) JXCategoryListContainerView *listContainerView;
@end

@implementation BC_MessageViewController
- (void)dealloc {
    KLog(@"BC_MessageViewController dealloc");
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"News";
    [self setupUI];
}

- (void)setupUI {
    
    self.categoryView = [[JXCategoryTitleView alloc] initWithFrame:CGRectMake(15, 5, kScreenWidth - 30, 40)];
    self.categoryView.delegate = self;
    self.categoryView.backgroundColor = kColorWithHex(@"#F5F5F5");
    self.categoryView.cellSpacing = 0;
    self.categoryView.titleColor = kMainTextColor;
    self.categoryView.titleSelectedColor = UIColor.whiteColor;
    self.categoryView.titleFont = REGULARFONT(15);
    self.categoryView.titleSelectedFont = REGULARFONT(15);
    self.categoryView.defaultSelectedIndex = 0;
    self.categoryView.titleColorGradientEnabled = YES;
    self.categoryView.averageCellSpacingEnabled = YES;
    //督导没有评论消息
    CGFloat cellW = 0;
    if ([KStringIsNull([UserManager shareManager].getUserInfo.identity) isEqualToString:@"4"] || [KStringIsNull([UserManager shareManager].getUserInfo.identity) isEqualToString:@"3"]) {
        self.categoryView.titles = @[@"Notify", @"Group chat"];
        cellW = (kScreenWidth - 30)/2;
    } else {
        self.categoryView.titles = @[@"Notify", @"Group chat", @"Comment"];
        cellW = (kScreenWidth - 30)/3;
    }
    self.categoryView.cellWidth = cellW;
    self.categoryView.layer.masksToBounds = YES;
    self.categoryView.layer.cornerRadius = 20;
    
    JXCategoryIndicatorBackgroundView *backgroundView = [[JXCategoryIndicatorBackgroundView alloc] init];
    backgroundView.indicatorWidth = cellW-10;
    backgroundView.indicatorHeight = 36;
    backgroundView.indicatorCornerRadius = 18;
    backgroundView.indicatorColor = kMainThemeColor;
    [backgroundView setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 0) radius:8];
    self.categoryView.indicators = @[backgroundView];
    [self.view addSubview:self.categoryView];
    
    self.listContainerView = [[JXCategoryListContainerView alloc] initWithType:JXCategoryListContainerType_ScrollView delegate:self];
    self.listContainerView.frame = CGRectMake(0, 50, kScreenWidth, kScreenHeight - kTopHeight - 50 - kTabBarHeight);
    [self.view addSubview:self.listContainerView];
    self.categoryView.listContainer = self.listContainerView;
    self.categoryView.listContainer.contentScrollView.scrollEnabled = NO;
}

#pragma mark - JXCategoryViewDelegate
- (id<JXCategoryListContentViewDelegate>)listContainerView:(JXCategoryListContainerView *)listContainerView initListForIndex:(NSInteger)index {
    if (index == 0) {
        BC_NotifySubListViewController *list = [BC_NotifySubListViewController new];
        return list;
    } else if (index == 1) {
        BC_GroupChatListViewController *list = [BC_GroupChatListViewController new];
        return list;
    } else {
        BC_UserCommentViewController *list = [BC_UserCommentViewController new];
        return list;
    }
}

- (NSInteger)numberOfListsInlistContainerView:(JXCategoryListContainerView *)listContainerView {
    //督导和项目执行者没有评论消息
    if ([KStringIsNull([UserManager shareManager].getUserInfo.identity) isEqualToString:@"4"] || [KStringIsNull([UserManager shareManager].getUserInfo.identity) isEqualToString:@"3"]) {
        return 2;
    } else {
        return 3;
    }
}
@end
