//
//  BC_GroupChatListViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2022/1/18.
//

#import "BC_GroupChatListViewController.h"
#import "BC_GroupChatViewController.h"
#import "TUIConversationListController.h"
#import "TUIChatConversationModel.h"
@interface BC_GroupChatListViewController ()<TUIConversationListControllerListener>
@property (nonatomic, strong) TUIConversationListController *conv;
@end

@implementation BC_GroupChatListViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.conv = [[TUIConversationListController alloc] init];
    self.conv.isEnableSearch = NO;
    self.conv.delegate = self;
    [self addChildViewController:self.conv];
    self.conv.view.frame = CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight - 50 - kTabBarHeight);
    [self.view addSubview:self.conv.view];
    //如果不加这一行代码，依然可以实现点击反馈，但反馈会有轻微延迟，体验不好。
    self.conv.tableView.delaysContentTouches = NO;
}

#pragma mark - JXCategoryListContentViewDelegate
- (UIView *)listView {
    return self.view;
}

/**
 *  点击会话回调
 */
- (void)conversationListController:(TUIConversationListController *)conversationController didSelectConversation:(TUIConversationCell *)conversationCell
{

    TUIChatConversationModel *model = [[TUIChatConversationModel alloc] init];
    model.conversationID = conversationCell.convData.conversationID;
    model.groupID = conversationCell.convData.groupID;
    model.groupType = conversationCell.convData.groupType;
    model.title = conversationCell.convData.title;
    model.faceUrl = conversationCell.convData.faceUrl;
    model.avatarImage = conversationCell.convData.avatarImage;
    model.draftText = conversationCell.convData.draftText;
    
    BC_GroupChatViewController *chat = [[BC_GroupChatViewController alloc] init];
    chat.conversationData = model;
    [self.navigationController pushViewController:chat animated:YES];
//    if ([conversationCell.convData.groupID isEqualToString:@"im_demo_admin"] || [conversationCell.convData.userID isEqualToString:@"im_demo_admin"]) {
//    }
//    if ([conversationCell.convData.groupID isEqualToString:@"@TGS#33NKXK5FK"] || [conversationCell.convData.userID isEqualToString:@"@TGS#33NKXK5FK"]) {
//    }
}

@end
