//
//  BC_GroupChatViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2022/1/18.
//

#import "BC_GroupChatViewController.h"
#import "TUIGroupChatViewController.h"
#import "BC_ManageMyGroupViewController.h"
#import "BC_GroupInfoViewController.h"

@interface BC_GroupChatViewController ()
@property (nonatomic, strong) TUIGroupChatViewController *chat;
@end

@implementation BC_GroupChatViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    _chat = [[TUIGroupChatViewController alloc] init];
    [_chat setConversationData:self.conversationData];
    [self addChildViewController:_chat];
    [self.view addSubview:_chat.view];
    
    self.navigationItem.title = KStringIsNull(self.conversationData.title);
    
    UIBarButtonItem *item = [[UIBarButtonItem alloc] initWithImage:[UIImage imageNamed:@"群组信息"] style:UIBarButtonItemStylePlain target:self action:@selector(pushGroupInfo)];
    self.navigationItem.rightBarButtonItem = item;
    
    NSMutableArray *array = [NSMutableArray arrayWithArray:_chat.moreMenus];
    [array removeLastObject]; // 删除最后一个菜单
    [array removeLastObject]; // 删除最后一个菜单
    [array removeLastObject]; // 删除最后一个菜单
    _chat.moreMenus = array; // 重新设置属性，立即生效
    
    _chat.inputController.inputBar.moreButton.hidden = YES;
}

- (void)pushGroupInfo {
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    @weakify(self);
    [[V2TIMManager sharedInstance] getGroupsInfo:@[KStringIsNull(self.conversationData.groupID)] succ:^(NSArray<V2TIMGroupInfoResult *> *groupResultList) {
        @strongify(self);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        if (groupResultList.count > 0) {
            V2TIMGroupInfoResult *res = groupResultList[0];
            if (res.info.role == V2TIM_GROUP_MEMBER_ROLE_SUPER) {
                //我的群
                BC_ManageMyGroupViewController *manage = [BC_ManageMyGroupViewController new];
                manage.groupid = KStringIsNull(res.info.groupID);
                [self.navigationController pushViewController:manage animated:YES];
            } else {
                BC_GroupInfoViewController *info = [BC_GroupInfoViewController new];
                info.ifHasJoin = YES;
                info.groupid = KStringIsNull(res.info.groupID);
                [self.navigationController pushViewController:info animated:YES];
            }
        } else {
            [BaseFunction showAlert:@"Get info failed"];
        }
    } fail:^(int code, NSString *desc) {
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Get info failed"];
    }];
}


@end
