//
//  BC_SearchMsgByDateViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/21.
//

#import "BC_SearchMsgByDateViewController.h"
#import "FSCalendar.h"
@interface BC_SearchMsgByDateViewController ()<FSCalendarDelegate, FSCalendarDataSource>
@property (nonatomic, strong) FSCalendar *calendar;
@property (strong, nonatomic) NSCalendar *gregorian;

@end

@implementation BC_SearchMsgByDateViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Find chat";
    self.gregorian = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    [self setupUI];
}

- (void)setupUI {
    
    FSCalendar *calendar = [[FSCalendar alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, 400)];
    calendar.dataSource = self;
    calendar.delegate = self;
    calendar.today = nil;
    calendar.locale = [NSLocale localeWithLocaleIdentifier:@"en"];
    calendar.appearance.headerMinimumDissolvedAlpha = 0;
    calendar.appearance.selectionColor = kMainThemeColor;
    calendar.calendarHeaderView.scrollEnabled = YES;
    calendar.placeholderType = FSCalendarPlaceholderTypeNone;
    [self.view addSubview:calendar];
    self.calendar = calendar;
    
    UIButton *nextMonth = [JLFactoryUtil buttonWithImage:@"下一月"];
    [nextMonth addTarget:self action:@selector(nextMonth) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:nextMonth];
    [nextMonth mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.view.mas_top).offset(17);
        make.left.equalTo(self.view.mas_centerX).offset(90);
        make.size.mas_equalTo(CGSizeMake(22, 22));
    }];
    
    UIButton *nextYear = [JLFactoryUtil buttonWithImage:@"下一年"];
    [nextYear addTarget:self action:@selector(nextYear) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:nextYear];
    [nextYear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.view.mas_top).offset(17);
        make.left.equalTo(nextMonth.mas_right).offset(20);
        make.size.mas_equalTo(CGSizeMake(22, 22));
    }];
    
    UIButton *preMonth = [JLFactoryUtil buttonWithImage:@"上一月"];
    [preMonth addTarget:self action:@selector(preMonth) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:preMonth];
    [preMonth mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.view.mas_top).offset(17);
        make.right.equalTo(self.view.mas_centerX).offset(-90);
        make.size.mas_equalTo(CGSizeMake(22, 22));
    }];
    
    UIButton *preYear = [JLFactoryUtil buttonWithImage:@"上一年"];
    [preYear addTarget:self action:@selector(preYear) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:preYear];
    [preYear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.view.mas_top).offset(17);
        make.right.equalTo(preMonth.mas_left).offset(-20);
        make.size.mas_equalTo(CGSizeMake(22, 22));
    }];
}

- (void)calendar:(FSCalendar *)calendar didSelectDate:(NSDate *)date atMonthPosition:(FSCalendarMonthPosition)monthPosition {
    
}

- (void)nextMonth {
//    NSDate *nextMonth = [self.calendar.currentPage dateByAddingMonths:1];
//    [self.calendar setCurrentPage:nextMonth animated:YES];
    
    NSDate *currentMonth = self.calendar.currentPage;
    NSDate *nextMonth = [self.gregorian dateByAddingUnit:NSCalendarUnitMonth value:1 toDate:currentMonth options:0];
    [self.calendar setCurrentPage:nextMonth animated:YES];
}

- (void)nextYear {
//    NSDate *nextYear = [self.calendar.currentPage dateByAddingYears:1];
//    [self.calendar setCurrentPage:nextYear animated:YES];
    
    NSDate *currentMonth = self.calendar.currentPage;
    NSDate *nextMonth = [self.gregorian dateByAddingUnit:NSCalendarUnitYear value:1 toDate:currentMonth options:0];
    [self.calendar setCurrentPage:nextMonth animated:YES];
}

- (void)preMonth {
//    NSDate *preMonth = [self.calendar.currentPage dateByAddingMonths:-1];
//    [self.calendar setCurrentPage:preMonth animated:YES];
    
    NSDate *currentMonth = self.calendar.currentPage;
    NSDate *nextMonth = [self.gregorian dateByAddingUnit:NSCalendarUnitMonth value:-1 toDate:currentMonth options:0];
    [self.calendar setCurrentPage:nextMonth animated:YES];
}

- (void)preYear {
//    NSDate *preYear = [self.calendar.currentPage dateByAddingYears:-1];
//    [self.calendar setCurrentPage:preYear animated:YES];
    
    NSDate *currentMonth = self.calendar.currentPage;
    NSDate *nextMonth = [self.gregorian dateByAddingUnit:NSCalendarUnitYear value:-1 toDate:currentMonth options:0];
    [self.calendar setCurrentPage:nextMonth animated:YES];
}

@end
