//
//  BC_NotifyListTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/15.
//

#import "BC_NotifyListTableViewCell.h"
#import "BC_MessageVCModel.h"
@implementation BC_NotifyListTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(12) textColor:kColorWithHex(@"#777777")];
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.contentView);
        make.top.equalTo(self.contentView.mas_top).offset(15);
        make.width.mas_lessThanOrEqualTo(kScreenWidth - 30);
    }];
    
    self.bgview = [JLFactoryUtil view];
    self.bgview.backgroundColor = kColorWithHex(@"#F8F8F8");
    [self.bgview setCorner:8 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.bgview];
    [self.bgview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.contentView).insets(UIEdgeInsetsMake(40, 15, 15, 15));
    }];
    
    self.titleL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(16) textColor:kMainTextColor];
    self.titleL.numberOfLines = 0;
    [self.contentView addSubview:self.titleL];
    [self.titleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(self.timeL.mas_bottom).offset(30);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-55);
    }];
    
    UIButton *moreBtn = [JLFactoryUtil buttonWithImage:@"操作"];
    [moreBtn addTarget:self action:@selector(moreBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:moreBtn];
    [moreBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.titleL);
        make.right.equalTo(self.contentView.mas_right).offset(-30);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    _moreBtn = moreBtn;
    
    self.contentImg = [JLFactoryUtil imageView];
    [self.contentImg setCorner:4 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.contentImg];
    [self.contentImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.titleL);
        make.top.equalTo(self.titleL.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, (kScreenWidth - 60)*160/311));
    }];
    
    self.contentL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kColorWithHex(@"#777777")];
    self.contentL.numberOfLines = 2;
    [self.contentView addSubview:self.contentL];
    [self.contentL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(self.contentImg.mas_bottom).offset(15);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-30);
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#EEEEEE");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.titleL.mas_left);
        make.top.equalTo(self.contentL.mas_bottom).offset(12);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 1));
    }];
    
    UIImageView *arrow = [JLFactoryUtil imageViewWithImg:@"更多"];
    [self.contentView addSubview:arrow];
    [arrow mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(line.mas_bottom).offset(10);
        make.right.equalTo(line.mas_right);
        make.size.mas_equalTo(CGSizeMake(16, 16));
        make.bottom.equalTo(self.contentView.mas_bottom).offset(-30);
    }];
    
    
    self.contentImg.hidden = YES;
    [self.contentL mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(30);
        make.top.equalTo(self.titleL.mas_bottom).offset(15);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-30);
    }];
    
    self.pubPostBgImg = [JLFactoryUtil imageViewWithImg:@"删除消息背景"];
    self.pubPostBgImg.userInteractionEnabled = YES;
    [self.contentView addSubview:self.pubPostBgImg];
    [self.pubPostBgImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.moreBtn.mas_bottom);
        make.right.equalTo(self.contentView);
        make.size.mas_equalTo(CGSizeMake(84, 63));
    }];
    UITapGestureRecognizer *tapItem2 = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(delMsg)];
    [self.pubPostBgImg addGestureRecognizer:tapItem2];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Delete" font:MEDIUMFONT(15) textColor:kMainTextColor];
    label1.userInteractionEnabled = YES;
    [self.pubPostBgImg addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.centerX.equalTo(self.pubPostBgImg);
    }];
    self.pubPostBgImg.hidden = YES;
    
//    self.contentImg.hidden = NO;
//    [self.contentL mas_remakeConstraints:^(MASConstraintMaker *make) {
//        make.left.equalTo(self.contentView.mas_left).offset(30);
//        make.top.equalTo(self.contentImg.mas_bottom).offset(15);
//        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-30);
//    }];
        
}

- (void)moreBtnClick:(UIButton *)sender {
    sender.selected = !sender.selected;
    if (sender.selected) {
        _model.ifShowDel = YES;
        @weakify(self);
        self.pubPostBgImg.hidden = NO;
        self.pubPostBgImg.alpha = 0;
        [UIView animateWithDuration:0.15 delay:0 options:UIViewAnimationOptionCurveEaseIn animations:^{
            @strongify(self);
            self.pubPostBgImg.alpha = 1;
        } completion:nil];
    } else {
        [self hidePopView];
    }
    
}

- (void)hidePopView {
    _model.ifShowDel = NO;
    self.moreBtn.selected = NO;
    @weakify(self);
    [UIView animateWithDuration:0.15 delay:0 options:UIViewAnimationOptionCurveEaseOut animations:^{
        @strongify(self);
        self.pubPostBgImg.alpha = 0;
    } completion:^(BOOL finished) {
        @strongify(self);
        [self.pubPostBgImg setHidden:YES];
    }];
}

- (void)delMsg {
    if (self.delegate && [self.delegate respondsToSelector:@selector(msgClickDelBtn:)]) {
        [self.delegate msgClickDelBtn:_model];
    }
}

- (void)setModel:(BC_MessageVCModel *)model {
    _model = model;
    self.timeL.text = KStringIsNull(model.create_datetime);
    self.titleL.text = KStringIsNull(model.msg_title);
    self.contentL.text = KStringIsNull([BaseFunction filterHTML:KStringIsNull(model.msg_content)]);
    
    [self.pubPostBgImg setHidden:YES];
    if (model.ifShowDel) {
        self.pubPostBgImg.hidden = NO;
    } else {
        self.pubPostBgImg.hidden = YES;
    }
}
@end
