//
//  BC_SearchUserTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2022/3/1.
//

#import "BC_SearchUserTableViewCell.h"
#import "BC_GroupInfoModel.h"
@implementation BC_SearchUserTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.avatar = [JLFactoryUtil imageView];
    [self.avatar setCorner:24 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.avatar];
    [self.avatar mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.size.mas_equalTo(CGSizeMake(48, 48));
    }];
    
    self.nicknameL = [JLFactoryUtil labelWithText:@"" font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:self.nicknameL];
    [self.nicknameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.avatar.mas_right).offset(12);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-100);
    }];
    
    self.inviteBtn = [JLFactoryUtil buttonWithTitle:@"invitation" font:MEDIUMFONT(13) textColor:UIColor.whiteColor];
    self.inviteBtn.backgroundColor = kColorWithHex(@"#E60000");
    [self.inviteBtn addTarget:self action:@selector(inviteClick) forControlEvents:UIControlEventTouchUpInside];
    [self.inviteBtn setCorner:16 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.inviteBtn];
    [self.inviteBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.size.mas_equalTo(CGSizeMake(72, 32));
    }];
}

- (void)inviteClick {
    if (self.delegate && [self.delegate respondsToSelector:@selector(inviteUser:)]) {
        [self.delegate inviteUser:_model];
    }
}

- (void)setModel:(BC_GroupInfoModel *)model {
    _model = model;
    [self.avatar sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(model.avatar)] placeholderImage:kAvatarPlaceHolderImg];
    self.nicknameL.text = KStringIsNull(model.nickname).length==0?@"-":KStringIsNull(model.nickname);
}
@end
