//
//  BC_IntegralListTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_IntegralListTableViewCell.h"
#import "BC_MineModuleModel.h"

@implementation BC_IntegralListTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.titleL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.titleL];
    [self.titleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(self.contentView.mas_centerY).offset(-2);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-80);
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_centerY).offset(2);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-85);
    }];
    
    self.numL = [JLFactoryUtil labelWithText:@" " font:SEMIBOLDFONT(22) textColor:kMainThemeColor];
    self.numL.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:self.numL];
    [self.numL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView.mas_centerY);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.width.mas_equalTo(70);
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(self.contentView.mas_bottom);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
}

- (void)setModel:(BC_MineModuleModel *)model {
    _model = model;
    self.titleL.text = KStringIsNull(model.type);
    self.timeL.text = KStringIsNull(model.create_datetime);
    if ([KStringIsNull(model.type_int) isEqualToString:@"4"]) {
        self.numL.text = kStringFormat(@"-%@", KStringIsNull(model.integral));
    } else {
        self.numL.text = kStringFormat(@"+%@", KStringIsNull(model.integral));
    }
    
}
@end
