//
//  BC_InviteRuleViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_InviteRuleViewController.h"
#import <WebKit/WebKit.h>
@interface BC_InviteRuleViewController ()
@property (nonatomic, strong) WKWebView *webview;

@end

@implementation BC_InviteRuleViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Invitation rules";

    NSString *jScript = @"var meta = document.createElement('meta'); meta.setAttribute('name', 'viewport'); meta.setAttribute('content', 'width=device-width'); document.getElementsByTagName('head')[0].appendChild(meta);";

    WKUserScript *wkUScript = [[WKUserScript alloc] initWithSource:jScript injectionTime:WKUserScriptInjectionTimeAtDocumentEnd forMainFrameOnly:YES];
    WKUserContentController *wkUController = [[WKUserContentController alloc] init];
    [wkUController addUserScript:wkUScript];

    WKWebViewConfiguration *wkWebConfig = [[WKWebViewConfiguration alloc] init];
    wkWebConfig.userContentController = wkUController;

    self.webview = [[WKWebView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight) configuration:wkWebConfig];
    [self.view addSubview:self.webview];
        
    [self getProtocol];
}

- (void)getProtocol {
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getothersettings/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{@"key":@"spreadrules"} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *infodic = (NSDictionary *)resdic[@"data"];
            NSDictionary *vdic = (NSDictionary *)infodic[@"data"];
            NSString *first = @"<!DOCTYPE html><html><head><meta charset='utf-8' /><meta name='viewport' content='width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0'><meta name='apple-mobile-web-app-capable' content='yes'><title></title><style>  body{background-color:#fff;} img{width:100% !important;height:auto} *{word-break: break-all;color:#000} p{margin:0px !important;padding:0px !important} img{margin:0px !important;padding:0px !important;vertical-align:top;vertical-align:bottom;} </style></head><body>";
            NSString *second = @"</body><html>";
            NSString *temp = [first stringByAppendingString:KStringIsNull(vdic[@"value"])];
            NSString *final = [temp stringByAppendingString:second];
            [self.webview loadHTMLString:final baseURL:nil];
        } else {
            [BaseFunction showAlert:KStringIsNull(resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        
    }];
}

@end
