//
//  BC_InviteUserViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_InviteUserViewController.h"
#import "BC_InviteRuleViewController.h"

#import "BC_InviteUserTableViewCell.h"
#import <Photos/Photos.h>
#import "BC_MineModuleModel.h"

@interface BC_InviteUserViewController ()<UITableViewDelegate, UITableViewDataSource>
@property (nonatomic, strong) UITableView *tableView;
@property (nonatomic, strong) NSMutableArray *dataArr;
@property (nonatomic, strong) UIView *shareView;
@property (nonatomic, strong) UILabel *inviteNumL;
@property (nonatomic, strong) UIImageView *qrimgView;
@end

@implementation BC_InviteUserViewController
- (UIStatusBarStyle)preferredStatusBarStyle {
    return UIStatusBarStyleLightContent;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.isHidenNaviBar = YES;
    self.dataArr = [NSMutableArray array];
    [self setupUI];
    [self getListData];
}

- (void)setupUI {
    
    UIImageView *bgimg = [JLFactoryUtil imageViewWithImg:@"邀请背景"];
    bgimg.userInteractionEnabled = YES;
    [self.view addSubview:bgimg];
    [bgimg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.top.right.equalTo(self.view);
        make.bottom.equalTo(self.view.mas_bottom);
    }];
    
    UIButton *wbackBtn = [JLFactoryUtil buttonWithImage:@"whiteback"];
    [wbackBtn addTarget:self action:@selector(backBtnClicked) forControlEvents:UIControlEventTouchUpInside];
    [bgimg addSubview:wbackBtn];
    [wbackBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(bgimg.mas_left).offset(15);
        make.top.equalTo(bgimg.mas_top).offset(kStatusBarHeight+7);
        make.size.mas_equalTo(CGSizeMake(30, 30));
    }];
    
    UILabel *label = [JLFactoryUtil labelWithText:@"Invite users" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [bgimg addSubview:label];
    [label mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(bgimg);
        make.centerY.equalTo(wbackBtn);
    }];
    
    UIButton *inviteRuleBtn = [JLFactoryUtil buttonWithTitle:@"Invitation rules" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    inviteRuleBtn.backgroundColor = [UIColor.whiteColor colorWithAlphaComponent:0.4];
    [inviteRuleBtn addTarget:self action:@selector(inviteRuleBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [inviteRuleBtn setCorner:20 withType:JLCornerTypeTopLeftAndBottomLeft];
    [bgimg addSubview:inviteRuleBtn];
    [inviteRuleBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(bgimg.mas_right);
        make.top.equalTo(bgimg.mas_top).offset(kTopHeight);
        make.size.mas_equalTo(CGSizeMake(132, 40));
    }];
    
    UIView *qrview = [JLFactoryUtil view];
    [qrview setCorner:12 withType:JLCornerTypeAllCorner];
    qrview.backgroundColor = UIColor.whiteColor;
    qrview.layer.borderWidth = 6;
    qrview.layer.borderColor = kColorWithHex(@"#FF7E1F").CGColor;
    [bgimg addSubview:qrview];
    [qrview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(bgimg);
        make.top.equalTo(bgimg.mas_top).offset(140);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 40, 297));
    }];
    
    self.shareView = [JLFactoryUtil view];
    self.shareView.backgroundColor = UIColor.whiteColor;
    [qrview addSubview:self.shareView];
    [self.shareView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(qrview.mas_top).offset(6);
        make.left.equalTo(qrview.mas_left).offset(6);
        make.right.equalTo(qrview.mas_right).offset(-6);
        make.bottom.equalTo(qrview.mas_bottom).offset(-80);
    }];
    
    self.inviteNumL = [JLFactoryUtil labelWithText:@"Invite code：-" font:REGULARFONT(16) textColor:kMainTextColor];
    [self.shareView addSubview:self.inviteNumL];
    [self.inviteNumL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.shareView);
        make.top.equalTo(self.shareView.mas_top).offset(14);
    }];
    
    self.qrimgView = [JLFactoryUtil imageView];
    [self.shareView addSubview:self.qrimgView];
    [self.qrimgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.shareView);
        make.top.equalTo(self.inviteNumL.mas_bottom).offset(6);
        make.size.mas_equalTo(CGSizeMake(167, 167));
    }];
    
    UIButton *saveBtn = [JLFactoryUtil buttonWithTitle:@"Save" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [saveBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [saveBtn addTarget:self action:@selector(saveBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [qrview addSubview:saveBtn];
    [saveBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(qrview);
        make.bottom.equalTo(qrview.mas_bottom).offset(-20);
        make.size.mas_equalTo(CGSizeMake(160, 44));
    }];
    CAGradientLayer *gl = [CAGradientLayer layer];
    gl.frame = CGRectMake(0,0,160,44);
    gl.startPoint = CGPointMake(0.21, 0.1);
    gl.endPoint = CGPointMake(0.72, 0.91);
    gl.colors = @[(__bridge id)[UIColor colorWithRed:243/255.0 green:108/255.0 blue:48/255.0 alpha:1.0].CGColor, (__bridge id)[UIColor colorWithRed:237/255.0 green:21/255.0 blue:32/255.0 alpha:1.0].CGColor];
    gl.locations = @[@(0), @(1.0f)];
    [saveBtn.layer insertSublayer:gl atIndex:0];
    saveBtn.layer.masksToBounds = YES;
    saveBtn.layer.cornerRadius = 22;
    
    UIView *userView = [JLFactoryUtil view];
    userView.backgroundColor = [UIColor.whiteColor colorWithAlphaComponent:0.2];
    [userView setCorner:12 withType:JLCornerTypeAllCorner];
    [bgimg addSubview:userView];
    [userView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(bgimg);
        make.top.equalTo(qrview.mas_bottom).offset(10);
        make.bottom.equalTo(bgimg.mas_bottom).offset(-HOME_INDICATOR_HEIGHT);
        make.width.mas_equalTo(kScreenWidth - 40);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Invitation record" font:MEDIUMFONT(17) textColor:UIColor.whiteColor];
    [userView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(userView);
        make.top.equalTo(userView.mas_top).offset(10);
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Sort" font:REGULARFONT(14) textColor:UIColor.whiteColor];
    label2.textAlignment = NSTextAlignmentCenter;
    [userView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(label1.mas_bottom).offset(10);
        make.left.equalTo(userView.mas_left);
        make.width.mas_equalTo(84);
    }];

    UILabel *label3 = [JLFactoryUtil labelWithText:@"User" font:REGULARFONT(14) textColor:UIColor.whiteColor];
    label3.textAlignment = NSTextAlignmentCenter;
    [userView addSubview:label3];
    [label3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(label1.mas_bottom).offset(10);
        make.left.equalTo(label2.mas_right);
        make.width.mas_equalTo(kScreenWidth - 208);
    }];
    
    UILabel *label4 = [JLFactoryUtil labelWithText:@"Integral" font:REGULARFONT(14) textColor:UIColor.whiteColor];
    label4.textAlignment = NSTextAlignmentCenter;
    [userView addSubview:label4];
    [label4 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(label1.mas_bottom).offset(10);
        make.left.equalTo(label3.mas_right);
        make.width.mas_equalTo(84);
    }];
    
    self.tableView = [[UITableView alloc] initWithFrame:CGRectZero];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.tableFooterView = [UIView new];
    self.tableView.showsVerticalScrollIndicator = NO;
    self.tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    [userView addSubview:self.tableView];
    self.tableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;
    [self.tableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(userView);
        make.bottom.equalTo(userView.mas_bottom).offset(-5);
        make.top.equalTo(label2.mas_bottom).offset(5);
    }];
    self.tableView.backgroundColor = UIColor.clearColor;
    
    self.inviteNumL.text = kStringFormat(@"Invite code：%@", KStringIsNull([UserManager shareManager].getUserInfo.user_invitecode));
    
    self.qrimgView.backgroundColor = kRANDOM_COLOR;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellid = @"cellid";
    BC_InviteUserTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellid];
    if (!cell) {
        cell = [[BC_InviteUserTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellid];
    }
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    [cell setModel:_dataArr[indexPath.row]];
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 35;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.dataArr.count;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
}

- (void)inviteRuleBtnClick {
    [self.navigationController pushViewController:[BC_InviteRuleViewController new] animated:YES];
}

- (void)saveBtnClick {
    UIImage *snapImg = [self.shareView snapshotImage];
    UIImage *pngimg = [UIImage imageWithData:UIImagePNGRepresentation(snapImg)];
    [PHPhotoLibrary requestAuthorization:^(PHAuthorizationStatus status) {
        if (status == PHAuthorizationStatusAuthorized) {
            [[PHPhotoLibrary sharedPhotoLibrary] performChanges:^{
                [PHAssetChangeRequest creationRequestForAssetFromImage:pngimg];
            } completionHandler:^(BOOL success, NSError * _Nullable error) {
                dispatch_async(dispatch_get_main_queue(), ^{
                    if (success) {
                        [BaseFunction showAlert:@"保存成功"];
                    } else {
                        [BaseFunction showAlert:@"保存失败"];
                    }
                });
            }];
        }
    }];
}

- (void)getListData {
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getinvitationlist/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            self.dataArr = [BC_MineModuleModel mj_objectArrayWithKeyValuesArray:dataDic[@"data"]];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
        [self.tableView reloadData];
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [BaseFunction showAlert:@"Error"];
    }];
}

@end
