//
//  BC_InviteUserTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_InviteUserTableViewCell.h"
#import "BC_MineModuleModel.h"

@implementation BC_InviteUserTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.backgroundColor = UIColor.clearColor;
        self.contentView.backgroundColor = UIColor.clearColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.sortL = [JLFactoryUtil labelWithText:@"" font:REGULARFONT(13) textColor:UIColor.whiteColor];
    self.sortL.textAlignment = NSTextAlignmentCenter;
    [self.contentView addSubview:self.sortL];
    [self.sortL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.contentView.mas_left).offset(0);
        make.width.mas_equalTo(84);
    }];
    
    self.phoneL = [JLFactoryUtil labelWithText:@"" font:REGULARFONT(13) textColor:UIColor.whiteColor];
    self.phoneL.textAlignment = NSTextAlignmentCenter;
    [self.contentView addSubview:self.phoneL];
    [self.phoneL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.sortL.mas_right).offset(0);
        make.width.mas_equalTo(kScreenWidth - 208);
    }];
    
    self.integralL = [JLFactoryUtil labelWithText:@"" font:REGULARFONT(13) textColor:UIColor.whiteColor];
    self.integralL.textAlignment = NSTextAlignmentCenter;
    [self.contentView addSubview:self.integralL];
    [self.integralL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.phoneL.mas_right).offset(0);
        make.width.mas_equalTo(84);
    }];
    
    
}

- (void)setModel:(BC_MineModuleModel *)model {
    self.sortL.text = @"0";
    self.phoneL.text = @"153****1111";
    self.integralL.text = @"20";
}
@end
