//
//  BC_ExecutorIncomeTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/24.
//

#import "BC_ExecutorIncomeTableViewCell.h"
#import "BC_MineModuleModel.h"
@implementation BC_ExecutorIncomeTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.numberL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.numberL];
    [self.numberL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(self.contentView.mas_centerY).offset(-2);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-100);
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kLightGrayTextColor];
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_centerY).offset(2);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-100);
    }];
    
    self.priceL = [JLFactoryUtil labelWithText:@"$0" font:SEMIBOLDFONT(22) textColor:kMainThemeColor];
    [self.contentView addSubview:self.priceL];
    [self.priceL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(self.contentView.mas_bottom);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
}

- (void)setModel:(BC_MineModuleModel *)model {
    _model = model;
    self.numberL.text = kStringFormat(@"Number:%@", KStringIsNull(model.order_id));
    self.timeL.text = KStringIsNull(model.update_datetime);
    if ([KStringIsNull(model.type_int) isEqualToString:@"4"]) {
        self.priceL.text = kStringFormat(@"-$%@", KStringIsNull(model.price));
    } else {
        self.priceL.text = kStringFormat(@"+$%@", KStringIsNull(model.price));
    }
}
@end
