//
//  BC_MyPostTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_MyPostTableViewCell.h"
#import "BC_MineModuleModel.h"

@implementation BC_MyPostTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.postimg = [JLFactoryUtil imageView];
    [self.postimg setCorner:4 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.postimg];
    [self.postimg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.size.mas_equalTo(CGSizeMake(88, 88));
    }];
    
    self.postDescL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kMainTextColor];
    self.postDescL.numberOfLines = 1;
    [self.contentView addSubview:self.postDescL];
    [self.postDescL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.postimg.mas_right).offset(10);
        make.centerY.equalTo(self.postimg);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.postTitleL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:self.postTitleL];
    [self.postTitleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.postimg.mas_right).offset(10);
        make.bottom.equalTo(self.postDescL.mas_top).offset(-4);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.statusL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kMainTextColor];
    [self.contentView addSubview:self.statusL];
    [self.statusL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.postimg.mas_right).offset(10);
        make.top.equalTo(self.postDescL.mas_bottom).offset(4);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.typeImg = [JLFactoryUtil imageViewWithImg:@"图文tag"];
    [self.postimg addSubview:self.typeImg];
    [self.typeImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.right.equalTo(self.postimg).offset(-5);
        make.size.mas_equalTo(CGSizeMake(12, 12));
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(self.contentView.mas_bottom);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
}

- (void)setModel:(BC_MineModuleModel *)model {
    
    if ([KStringIsNull(model.file_type) isEqualToString:@"1"]) {
        self.typeImg.image = [UIImage imageNamed:@"视频tag"];
        //视频封面
        if (model.files.count > 0) {
            self.postimg.image = kPlaceHolderImg;
            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
                UIImage *img = [BaseFunction thumbnailImageForVideo:[NSURL URLWithString:KStringIsNull(model.files[0])] atTime:0.1];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.postimg.image = img;
                });
            });
        } else {
            self.postimg.image = kPlaceHolderImg;
        }
    } else {
        self.typeImg.image = [UIImage imageNamed:@"图文tag"];
        if (model.files.count > 0) {
            [self.postimg sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(model.files[0])] placeholderImage:kPlaceHolderImg];
        } else {
            self.postimg.image = kPlaceHolderImg;
        }
    }
    self.postTitleL.text = KStringIsNull(model.name);
    self.postDescL.text = KStringIsNull(model.desc);
    if ([KStringIsNull(model.audit_status) isEqualToString:@"10"]) {
        self.statusL.text = @"pending review";
        self.statusL.textColor = kMainTextColor;
    } else if ([KStringIsNull(model.audit_status) isEqualToString:@"20"]) {
        self.statusL.text = @"pass";
        self.statusL.textColor = kCOLOR(76, 157, 68, 1);
    } else if ([KStringIsNull(model.audit_status) isEqualToString:@"30"]) {
        self.statusL.text = @"reject";
        self.statusL.textColor = kMainThemeColor;
    } else {
        self.statusL.text = @"";
    }
    
}
@end
