//
//  BC_AddHouseViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_AddHouseViewController.h"
#import "BC_AddHouseTableViewCell.h"
#import "BC_AddHousePicTableViewCell.h"

#import <TZImagePickerController.h>
#import "BC_UploadImgCollectionViewCell.h"
#import "ZlinkPhotoBrowserView.h"
#import "BRAddressPickerView.h"

#import "BC_HouseInfoModel.h"
#import "BC_MyHouseAddModel.h"
#import "BC_UploadImgModel.h"
@interface BC_AddHouseViewController ()<TZImagePickerControllerDelegate, UICollectionViewDelegate, UICollectionViewDataSource, BC_UploadImgCollectionViewCellDelegate, UITableViewDelegate, UITableViewDataSource, BC_AddHousePicTableViewCellDelegate>
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;
@property (nonatomic, strong) UITableView *tableView;
@property (nonatomic, strong) UITextField *nameL;
@property (nonatomic, strong) UITextField *cityL;
@property (nonatomic, strong) UITextField *valueL;
@property (nonatomic, strong) UITextField *locationL;
@property (nonatomic, strong) TZImagePickerController *contractImagePickerVc;
@property (nonatomic, strong) BRAddressPickerView *areaPicker;
@property (nonatomic, copy) NSString *selectCityID;

@property (nonatomic, strong) NSIndexPath *chooseIndexPath;
@property (nonatomic, strong) NSIndexPath *chooseContractIndexPath;

@property (nonatomic, assign) BOOL isChooseAvatar;
@property (nonatomic, strong) NSMutableArray *tenementArr;
@property (nonatomic, strong) UICollectionView *photoCollectionView;
@property (nonatomic, strong) NSMutableArray *imgArr;
@property (nonatomic, strong) NSMutableArray *areaArr;
@end

@implementation BC_AddHouseViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"New property";
    self.isChooseAvatar = NO;
    self.selectCityID = @"";
    self.imgArr = [NSMutableArray array];
    self.areaArr = [NSMutableArray array];
    self.tenementArr = [NSMutableArray array];
        
    [self setupUI];
    
    if (_isedit) {
        BC_UploadImgModel *model = [BC_UploadImgModel new];
        model.type = @"add";
        model.imgurl = @"";
        [self.imgArr addObject:model];
        
        if (_editModel.images.count > 0) {
            for (int i = 0; i < _editModel.images.count; i++) {
                BC_UploadImgModel *model = [BC_UploadImgModel new];
                model.type = @"";
                model.imgurl = KStringIsNull(_editModel.images[i]);
                [self.imgArr insertObject:model atIndex:i];
            }
        }
        
        self.selectCityID = KStringIsNull(_editModel.city_id);
        self.nameL.text = KStringIsNull(_editModel.name);
        self.cityL.text = kStringFormat(@"%@%@", KStringIsNull(_editModel.province), KStringIsNull(_editModel.city));
        self.valueL.text = KStringIsNull(_editModel.price);
        self.locationL.text = KStringIsNull(_editModel.place);
        
        [self configOldTenaData];

    } else {
        BC_UploadImgModel *model = [BC_UploadImgModel new];
        model.type = @"add";
        model.imgurl = @"";
        [self.imgArr addObject:model];
        [self configTeneData];
    }
    
    [self.photoCollectionView reloadData];
    [self.tableView reloadData];
    
    [self getCityList];
}

- (void)configTeneData {
    NSMutableArray *temp = [NSMutableArray array];
    NSArray *arr = @[@"Avatar", @"Name", @"Phone", @"Email", @"Profession", @"Credit score", @"Contract"];
    for (int i = 0; i < 7; i++) {
        BC_MyHouseAddModel *model1 = [BC_MyHouseAddModel new];
        model1.type = arr[i];
        model1.contentValue = @"";
        [temp addObject:model1];
    }
    [self.tenementArr addObject:temp];
}

- (void)configOldTenaData {
    for (int i = 0; i < _editModel.tenant.count; i++) {
        BC_HouseInfoModel *model = _editModel.tenant[i];
        NSMutableArray *temp = [NSMutableArray array];
        NSArray *arr = @[@"Avatar", @"Name", @"Phone", @"Email", @"Profession", @"Credit score", @"Contract"];
        NSArray *carr = @[KStringIsNull(model.avatar), KStringIsNull(model.name), KStringIsNull(model.mobile), KStringIsNull(model.email), KStringIsNull(model.vocation), KStringIsNull(model.score), model.files];
        
        for (int i = 0; i < 7; i++) {
            if (i == 6) {
                BC_MyHouseAddModel *model1 = [BC_MyHouseAddModel new];
                model1.type = arr[i];
                model1.contentValue = @"1";
                model1.tenantID = KStringIsNull(model.itemid);
                NSMutableArray *farr = [NSMutableArray array];
                NSArray *arr6 = carr[6];
                if (arr6.count > 0) {
                    for (NSString *url in arr6) {
                        BC_UploadImgModel *imgmodel = [BC_UploadImgModel new];
                        imgmodel.type = @"";
                        imgmodel.imgurl = KStringIsNull(url);
                        [farr addObject:imgmodel];
                    }
                }
                model1.imageArr = farr.copy;
                [temp addObject:model1];

            } else {
                BC_MyHouseAddModel *model1 = [BC_MyHouseAddModel new];
                model1.type = arr[i];
                model1.contentValue = carr[i];
                [temp addObject:model1];
            }
        }
        
        [self.tenementArr addObject:temp];
    }
}

- (void)setupUI {
    
    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight)];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.tableFooterView = [UIView new];
    self.tableView.showsVerticalScrollIndicator = NO;
    self.tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    [self.view addSubview:self.tableView];
    self.tableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;
    
    self.contentView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, 510)];
    self.contentView.backgroundColor = [UIColor whiteColor];
    self.tableView.tableHeaderView = self.contentView;
    
    UIView *footer = [JLFactoryUtil view];
    footer.frame = CGRectMake(0, 0, kScreenWidth, 170);
    self.tableView.tableFooterView = footer;
    
    UIView *footerLine1 = [JLFactoryUtil view];
    footerLine1.backgroundColor = kColorWithHex(@"#F8F8F8");
    [footer addSubview:footerLine1];
    [footerLine1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.top.right.equalTo(footer);
        make.height.mas_equalTo(10);
    }];
    
    UILabel *addL = [JLFactoryUtil labelWithText:@"+ Add" font:REGULARFONT(15) textColor:kMainTextColor];
    addL.userInteractionEnabled = YES;
    [footer addSubview:addL];
    [addL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(footer.mas_left).offset(15);
        make.top.equalTo(footerLine1.mas_bottom).offset(15);
    }];
    
    UIView *footerLine2 = [JLFactoryUtil view];
    footerLine2.backgroundColor = kColorWithHex(@"#F8F8F8");
    [footer addSubview:footerLine2];
    [footerLine2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(footer);
        make.top.equalTo(addL.mas_bottom).offset(15);
        make.height.mas_equalTo(1);
    }];
    
    UIView *addClear = [JLFactoryUtil view];
    addClear.backgroundColor = UIColor.clearColor;
    [footer addSubview:addClear];
    [addClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(footer);
        make.top.equalTo(footerLine1.mas_bottom);
        make.bottom.equalTo(footerLine2.mas_top);
    }];
    UITapGestureRecognizer *tapAdd = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(addTene)];
    [addClear addGestureRecognizer:tapAdd];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(uploadAllImg) forControlEvents:UIControlEventTouchUpInside];
    [footer addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(footer);
        make.top.equalTo(footerLine2.mas_bottom).offset(40);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    UILabel *label = [JLFactoryUtil labelWithText:@"Name" font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:label];
    [label mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(20);
    }];
    
    self.nameL = [JLFactoryUtil textFieldWithFont:REGULARFONT(15) place:@"name"];
    self.nameL.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:self.nameL];
    [self.nameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(label);
        make.size.mas_equalTo(CGSizeMake(200, 30));
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label.mas_bottom).offset(20);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"City" font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line.mas_bottom).offset(20);
    }];
    
    self.cityL = [JLFactoryUtil textFieldWithFont:REGULARFONT(15) place:@"city"];
    self.cityL.enabled = NO;
    self.cityL.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:self.cityL];
    [self.cityL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(label1);
        make.size.mas_equalTo(CGSizeMake(200, 30));
    }];
    
    UIView *line1 = [JLFactoryUtil view];
    line1.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line1];
    [line1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label1.mas_bottom).offset(20);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UIView *cityClear = [JLFactoryUtil view];
    cityClear.backgroundColor = UIColor.clearColor;
    [self.contentView addSubview:cityClear];
    [cityClear mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.contentView);
        make.centerY.equalTo(self.cityL);
        make.height.mas_equalTo(30);
    }];
    UITapGestureRecognizer *tapCity = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseLoc)];
    [cityClear addGestureRecognizer:tapCity];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Value" font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line1.mas_bottom).offset(20);
    }];
    
    self.valueL = [JLFactoryUtil textFieldWithFont:REGULARFONT(15) place:@"value"];
    self.valueL.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:self.valueL];
    [self.valueL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(label2);
        make.size.mas_equalTo(CGSizeMake(200, 30));
    }];
    
    UIView *line2 = [JLFactoryUtil view];
    line2.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line2];
    [line2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(label2.mas_bottom).offset(20);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UILabel *label3 = [JLFactoryUtil labelWithText:@"Location" font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:label3];
    [label3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line2.mas_bottom).offset(20);
    }];
    
    self.locationL = [JLFactoryUtil textFieldWithFont:REGULARFONT(15) place:@"location"];
    self.locationL.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:self.locationL];
    [self.locationL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(label3);
        make.size.mas_equalTo(CGSizeMake(200, 30));
    }];
    
    UIView *line3 = [JLFactoryUtil view];
    line3.backgroundColor = kColorWithHex(@"#F8F8F8");
    [self.contentView addSubview:line3];
    [line3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(0);
        make.top.equalTo(label3.mas_bottom).offset(20);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth, 10));
    }];
    
    UILabel *label4 = [JLFactoryUtil labelWithText:@"Photo" font:MEDIUMFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label4];
    [label4 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line3.mas_bottom).offset(20);
    }];
    
    UICollectionViewFlowLayout *layout = [UICollectionViewFlowLayout new];
    layout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
    layout.minimumInteritemSpacing = 1;
    layout.minimumLineSpacing = 10;
    layout.itemSize = CGSizeMake(88, 88);
    layout.sectionInset = UIEdgeInsetsMake(10, 15, 10, 15);
    self.photoCollectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:layout];
    self.photoCollectionView.delegate = self;
    self.photoCollectionView.dataSource = self;
    self.photoCollectionView.backgroundColor = UIColor.clearColor;
    self.photoCollectionView.showsHorizontalScrollIndicator = NO;
    [self.photoCollectionView registerClass:[BC_UploadImgCollectionViewCell class] forCellWithReuseIdentifier:@"photocell"];
    [self.contentView addSubview:self.photoCollectionView];
    [self.photoCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView);
        make.left.equalTo(self.contentView);
        make.top.equalTo(label4.mas_bottom).offset(10);
        make.height.mas_equalTo(110);
    }];
        
    UIView *line4 = [JLFactoryUtil view];
    line4.backgroundColor = kColorWithHex(@"#F8F8F8");
    [self.contentView addSubview:line4];
    [line4 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.photoCollectionView.mas_bottom).offset(15);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 10));
    }];
    
    UILabel *label5 = [JLFactoryUtil labelWithText:@"Tenant Information" font:MEDIUMFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label5];
    [label5 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line4.mas_bottom).offset(15);
    }];
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    NSArray *arr = self.tenementArr[indexPath.section];
    if (indexPath.row == 6) {
        static NSString *cellid = @"piccellid";
        BC_AddHousePicTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellid];
        if (!cell) {
            cell = [[BC_AddHousePicTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellid];
        }
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.delegate = self;
        [cell setIndexP:indexPath];
        BC_MyHouseAddModel *hmodel = arr[indexPath.row];
        [cell setModel:hmodel];
        return cell;
    } else {
        static NSString *cellid = @"cellid";
        BC_AddHouseTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellid];
        if (!cell) {
            cell = [[BC_AddHouseTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellid];
        }
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        [cell setModel:arr[indexPath.row]];
        return cell;
    }
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    if (indexPath.row == 6) {
        return 136;
    } else {
        return 60;
    }
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 7;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return self.tenementArr.count;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    if (indexPath.row == 0) {
        self.isChooseAvatar = YES;
        self.chooseIndexPath = indexPath;
        [self showChoosePic];
    } else if (indexPath.row == 6) {
        //合同
        self.chooseContractIndexPath = indexPath;
        [self chooseContractImage];
    }
    
}

#pragma mark  UICollectionView Delegate
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    BC_UploadImgModel *model = self.imgArr[indexPath.item];
    if ([KStringIsNull(model.type) isEqualToString:@"add"]) {
        self.isChooseAvatar = NO;
        [self showChoosePic];
    } else {
        NSMutableArray *itemarr = [NSMutableArray array];
        for (BC_UploadImgModel *m in self.imgArr) {
            if ([KStringIsNull(m.type) isEqualToString:@""]) {
                ZlinkPhotoGroupItem *item = [ZlinkPhotoGroupItem new];
                item.thumbView = self.photoCollectionView;
                item.largeImageURL = [NSURL URLWithString:KStringIsNull(m.imgurl)];
                item.showimg = m.img;
                [itemarr addObject:item];
            }
        }

        ZlinkPhotoBrowserView *browser = [[ZlinkPhotoBrowserView alloc] initWithGroupItems:itemarr];
        [browser presentFromImageView:self.photoCollectionView toContainer:self.navigationController.view animated:YES index:indexPath.item completion:^{
        }];
    }
}

- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    BC_UploadImgCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"photocell" forIndexPath:indexPath];
    cell.delegate = self;
    [cell setModel:_imgArr[indexPath.item]];
    return cell;
}

- (void)removeImgModel:(BC_UploadImgModel *)model {
    [self.imgArr removeObject:model];
    [self.photoCollectionView reloadData];
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    return self.imgArr.count;
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView {
    return 1;
}

- (void)showChoosePic {
    NSInteger count = 1;
    if (_isChooseAvatar) {
        count = 1;
    } else {
        count = 9 - self.imgArr.count + 1;
        if (self.imgArr.count > 9) {
            [BaseFunction showAlert:@"The maximum number of pictures is 9"];
            return;
        }
    }
    TZImagePickerController *imagePickerVc = [[TZImagePickerController alloc] initWithMaxImagesCount:count delegate:self];
    imagePickerVc.barItemTextColor = [UIColor whiteColor];
    [imagePickerVc.navigationBar setTitleTextAttributes:@{NSForegroundColorAttributeName : [UIColor whiteColor]}];
    imagePickerVc.navigationBar.tintColor = [UIColor whiteColor];
    if (@available(iOS 15.0, *)) {
        UINavigationBarAppearance *barApp = [UINavigationBarAppearance new];
        barApp.backgroundColor = [UIColor whiteColor];
        barApp.shadowColor = [UIColor clearColor];
        imagePickerVc.navigationController.navigationBar.scrollEdgeAppearance = barApp;
        imagePickerVc.navigationController.navigationBar.standardAppearance = barApp;
    } else {
        imagePickerVc.navigationBar.barTintColor = [UIColor whiteColor];
    }
    imagePickerVc.oKButtonTitleColorDisabled = [UIColor lightGrayColor];
    imagePickerVc.navigationBar.translucent = NO;
    imagePickerVc.iconThemeColor = kMainThemeColor;
    imagePickerVc.showSelectedIndex = YES;
    imagePickerVc.allowTakePicture = YES;
    imagePickerVc.allowTakeVideo = NO;   // 在内部显示拍视频按
    imagePickerVc.showPhotoCannotSelectLayer = YES;
    imagePickerVc.cannotSelectLayerColor = [[UIColor whiteColor] colorWithAlphaComponent:0.8];
    imagePickerVc.allowPickingVideo = NO;
    imagePickerVc.allowPickingOriginalPhoto = NO;
    imagePickerVc.allowPickingImage = YES;
    imagePickerVc.allowPickingGif = NO;
    imagePickerVc.statusBarStyle = UIStatusBarStyleDefault;
    imagePickerVc.preferredLanguage = @"en";
    imagePickerVc.modalPresentationStyle = UIModalPresentationFullScreen;
    [self presentViewController:imagePickerVc animated:YES completion:nil];
}

- (void)chooseContractImage {
    [self.view endEditing:YES];
    
    NSArray *arr = self.tenementArr[self.chooseContractIndexPath.section];
    BC_MyHouseAddModel *model = arr[self.chooseContractIndexPath.row];
    
    if (model.imageArr.count >= 9) {
        [BaseFunction showAlert:@"The maximum number of pictures is 9"];
        return;
    }
    
    self.contractImagePickerVc = [[TZImagePickerController alloc] initWithMaxImagesCount:9 - model.imageArr.count delegate:self];
    self.contractImagePickerVc.barItemTextColor = [UIColor whiteColor];
    [self.contractImagePickerVc.navigationBar setTitleTextAttributes:@{NSForegroundColorAttributeName : [UIColor whiteColor]}];
    self.contractImagePickerVc.navigationBar.tintColor = [UIColor whiteColor];
    if (@available(iOS 15.0, *)) {
        UINavigationBarAppearance *barApp = [UINavigationBarAppearance new];
        barApp.backgroundColor = [UIColor whiteColor];
        barApp.shadowColor = [UIColor clearColor];
        self.contractImagePickerVc.navigationController.navigationBar.scrollEdgeAppearance = barApp;
        self.contractImagePickerVc.navigationController.navigationBar.standardAppearance = barApp;
    } else {
        self.contractImagePickerVc.navigationBar.barTintColor = [UIColor whiteColor];
    }
    self.contractImagePickerVc.oKButtonTitleColorDisabled = [UIColor lightGrayColor];
    self.contractImagePickerVc.navigationBar.translucent = NO;
    self.contractImagePickerVc.iconThemeColor = kMainThemeColor;
    self.contractImagePickerVc.showSelectedIndex = YES;
    self.contractImagePickerVc.allowTakePicture = YES;
    self.contractImagePickerVc.allowTakeVideo = NO;   // 在内部显示拍视频按
    self.contractImagePickerVc.showPhotoCannotSelectLayer = YES;
    self.contractImagePickerVc.cannotSelectLayerColor = [[UIColor whiteColor] colorWithAlphaComponent:0.8];
    self.contractImagePickerVc.allowPickingVideo = NO;
    self.contractImagePickerVc.allowPickingOriginalPhoto = NO;
    self.contractImagePickerVc.allowPickingImage = YES;
    self.contractImagePickerVc.allowPickingGif = NO;
    self.contractImagePickerVc.statusBarStyle = UIStatusBarStyleDefault;
    self.contractImagePickerVc.preferredLanguage = @"en";
    self.contractImagePickerVc.modalPresentationStyle = UIModalPresentationFullScreen;
    [self presentViewController:self.contractImagePickerVc animated:YES completion:nil];
}

- (void)tz_imagePickerControllerDidCancel:(TZImagePickerController *)picker {
}

- (void)imagePickerController:(TZImagePickerController *)picker didFinishPickingPhotos:(NSArray<UIImage *> *)photos sourceAssets:(NSArray *)assets isSelectOriginalPhoto:(BOOL)isSelectOriginalPhoto {
    if (photos.count > 0) {
        if (picker == self.contractImagePickerVc) {
            NSArray *arr = self.tenementArr[self.chooseContractIndexPath.section];
            BC_MyHouseAddModel *model = arr[self.chooseContractIndexPath.row];
            
            NSMutableArray *temp = [NSMutableArray arrayWithArray:model.imageArr];
            for (UIImage *img in photos) {
                BC_UploadImgModel *model = [BC_UploadImgModel new];
                model.type = @"";
                model.img = img;
                [temp insertObject:model atIndex:0];
            }
            model.imageArr = temp.copy;
            [self uploadContractImages];
        } else {
            if (_isChooseAvatar) {
                [self uploadTenantAvatar:photos[0]];
            } else {
                for (UIImage *img in photos) {
                    BC_UploadImgModel *model = [BC_UploadImgModel new];
                    model.type = @"";
                    model.img = img;
                    [self.imgArr insertObject:model atIndex:0];
                }
                [self.photoCollectionView reloadData];
            }
        }
    }
}

#pragma mark  添加租户
- (void)addTene {
    [self configTeneData];
    [self.tableView reloadData];
}

- (void)clickAddContractImg:(NSIndexPath *)indexp {
    self.chooseContractIndexPath = indexp;
    [self chooseContractImage];
}

#pragma mark  选择城市
- (void)chooseLoc {
    if (self.areaArr.count == 0) return;
    [self.view endEditing:YES];
    [self.areaPicker show];
}

#pragma mark  上传图片
- (void)uploadAllImg {
    
    if ([KStringIsNull(self.cityL.text) isEqualToString:@""] || [KStringIsNull(self.valueL.text) isEqualToString:@""] || [KStringIsNull(self.locationL.text) isEqualToString:@""] || [KStringIsNull(self.nameL.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please complete info"];
        return;
    }
    
    if (self.imgArr.count == 1) {
        [BaseFunction showAlert:@"Please upload picture"];
        return;
    }
    
    BOOL hasEmpty = false;
    for (NSArray *arr in self.tenementArr) {
        for (BC_MyHouseAddModel *dic in arr) {
            if ([KStringIsNull(dic.contentValue) isEqualToString:@""]) {
                hasEmpty = true;
                break;
            }
        }
    }
    
    if (hasEmpty) {
        [BaseFunction showAlert:@"Please complete tenant information"];
        return;
    }
            
    [self.view endEditing:YES];
    
    [MBProgressHUD showHUDAddTo:kAppWindow alertMsg:@"Uploading..." animated:YES];
    
    [self.imgArr enumerateObjectsUsingBlock:^(BC_UploadImgModel *  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        if ([KStringIsNull(obj.type) isEqualToString:@""]) {
            if ([KStringIsNull(obj.imgurl) isEqualToString:@""]) {
                UIImage *newImage;
                if (obj.img.size.width > 1024) {  //分辨率大的则重绘，否则不重绘
                    //获取原图片宽高比
                    CGFloat sourceImageAspectRatio = obj.img.size.width/obj.img.size.height;
                    CGSize newSize = CGSizeMake(1024, 1024/sourceImageAspectRatio);
                    //重绘图片
                    UIGraphicsBeginImageContextWithOptions(newSize, NO, 0);
    //                UIGraphicsBeginImageContext(newSize);
                    [obj.img drawInRect:CGRectMake(0, 0, newSize.width,newSize.height)];
                    newImage = UIGraphicsGetImageFromCurrentImageContext();
                    UIGraphicsEndImageContext();
                } else {
                    newImage = obj.img;
                }
                obj.img = newImage;
            }
        }
    }];
    
    dispatch_group_t uploadGroup = dispatch_group_create();
    
    NSMutableArray *errorArr = [NSMutableArray array];
    
    NSString *url = [NSString stringWithFormat:@"%@/api/app/uploadimage/",KMainUrl];
    for (int i = 0; i < self.imgArr.count; i++) {
        BC_UploadImgModel *model = self.imgArr[i];
        if ([KStringIsNull(model.type) isEqualToString:@""]) {
            if ([KStringIsNull(model.imgurl) isEqualToString:@""]) {
                //还没有上传
                dispatch_group_enter(uploadGroup);
                [PPNetworkHelper uploadImagesWithURL:url parameters:@{} name:@"file" images:@[model.img] fileNames:nil imageScale:0.8 imageType:@"png" progress:^(NSProgress *progress) {
                    
                } success:^(id responseObject) {
                    KLog(@"上传成功===%@", responseObject);
                    NSDictionary *resdic = (NSDictionary *)responseObject;
                    if ([resdic[@"code"] integerValue] == 2000) {
                        NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
                        NSArray *arr = (NSArray *)dataDic[@"data"];
                        if (arr.count > 0) {
                            model.imgurl = KStringIsNull(arr[0]);
                        }
                    } else {
                        [errorArr addObject:@"1"];
                    }
                    dispatch_group_leave(uploadGroup);
                } failure:^(NSError *error) {
                    KLog(@"上传失败===%@", error);
                    [errorArr addObject:@"1"];
                    dispatch_group_leave(uploadGroup);
                }];
            } else {
                continue;
            }
        } else {
            continue;
        }
    }
    
    dispatch_group_notify(uploadGroup, dispatch_get_main_queue(), ^{
        [MBProgressHUD hideHUDForView:kAppWindow animated:YES];
        if (errorArr.count > 0) {
            [BaseFunction showAlert:@"Some errors have occurred, please upload again"];
        } else {
            //发布
            [self submitBtnClick];
        }
    });

}

#pragma mark  上传合同
- (void)uploadContractImages {
    
    NSArray *arr = self.tenementArr[self.chooseContractIndexPath.section];
    BC_MyHouseAddModel *rowmodel = arr[self.chooseContractIndexPath.row];
    
    [MBProgressHUD showHUDAddTo:kAppWindow alertMsg:@"Uploading..." animated:YES];
    [rowmodel.imageArr enumerateObjectsUsingBlock:^(BC_UploadImgModel *  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        if ([KStringIsNull(obj.type) isEqualToString:@""]) {
            if ([KStringIsNull(obj.imgurl) isEqualToString:@""]) {
                UIImage *newImage;
                if (obj.img.size.width > 1024) {  //分辨率大的则重绘，否则不重绘
                    //获取原图片宽高比
                    CGFloat sourceImageAspectRatio = obj.img.size.width/obj.img.size.height;
                    CGSize newSize = CGSizeMake(1024, 1024/sourceImageAspectRatio);
                    //重绘图片
                    UIGraphicsBeginImageContextWithOptions(newSize, NO, 0);
    //                UIGraphicsBeginImageContext(newSize);
                    [obj.img drawInRect:CGRectMake(0, 0, newSize.width,newSize.height)];
                    newImage = UIGraphicsGetImageFromCurrentImageContext();
                    UIGraphicsEndImageContext();
                } else {
                    newImage = obj.img;
                }
                obj.img = newImage;
            }
        }
    }];
    
    dispatch_group_t uploadGroup = dispatch_group_create();
    
    NSMutableArray *errorArr = [NSMutableArray array];
    
    NSString *url = [NSString stringWithFormat:@"%@/api/app/uploadimage/",KMainUrl];
    for (int i = 0; i < rowmodel.imageArr.count; i++) {
        BC_UploadImgModel *model = rowmodel.imageArr[i];
        if ([KStringIsNull(model.type) isEqualToString:@""]) {
            if ([KStringIsNull(model.imgurl) isEqualToString:@""]) {
                //还没有上传
                dispatch_group_enter(uploadGroup);
                [PPNetworkHelper uploadImagesWithURL:url parameters:@{} name:@"file" images:@[model.img] fileNames:nil imageScale:0.8 imageType:@"png" progress:^(NSProgress *progress) {
                    
                } success:^(id responseObject) {
                    KLog(@"上传成功===%@", responseObject);
                    NSDictionary *resdic = (NSDictionary *)responseObject;
                    if ([resdic[@"code"] integerValue] == 2000) {
                        NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
                        NSArray *arr = (NSArray *)dataDic[@"data"];
                        if (arr.count > 0) {
                            model.imgurl = KStringIsNull(arr[0]);
                        }
                    } else {
                        [errorArr addObject:@"1"];
                    }
                    dispatch_group_leave(uploadGroup);
                } failure:^(NSError *error) {
                    KLog(@"上传失败===%@", error);
                    [errorArr addObject:@"1"];
                    dispatch_group_leave(uploadGroup);
                }];
            } else {
                continue;
            }
        } else {
            continue;
        }
    }
    
    dispatch_group_notify(uploadGroup, dispatch_get_main_queue(), ^{
        [MBProgressHUD hideHUDForView:kAppWindow animated:YES];
        if (errorArr.count > 0) {
            [BaseFunction showAlert:@"Some errors have occurred, please upload again"];
        } else {
            rowmodel.contentValue = @"1";
            [self.tableView reloadRowAtIndexPath:self.chooseContractIndexPath withRowAnimation:UITableViewRowAnimationNone];
        }
    });
}

- (void)uploadTenantAvatar:(UIImage *)img {
    [self.view endEditing:YES];
    
    [MBProgressHUD showHUDAddTo:kAppWindow alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/uploadimage/",KMainUrl];
    [PPNetworkHelper uploadImagesWithURL:url parameters:@{} name:@"file" images:@[img] fileNames:nil imageScale:0.8 imageType:@"png" progress:^(NSProgress *progress) {
        
    } success:^(id responseObject) {
        KLog(@"上传成功===%@", responseObject);
        [MBProgressHUD hideHUDForView:kAppWindow animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSArray *arr = (NSArray *)dataDic[@"data"];
            if (arr.count > 0) {
                BC_MyHouseAddModel *model = self.tenementArr[self.chooseIndexPath.section][self.chooseIndexPath.row];
                model.contentValue = KStringIsNull(arr[0]);
                [self.tableView reloadRowAtIndexPath:self.chooseIndexPath withRowAnimation:UITableViewRowAnimationNone];
            }
            [BaseFunction showAlert:@"Upload success"];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"上传失败===%@", error);
        [MBProgressHUD hideHUDForView:kAppWindow animated:YES];
    }];
}

- (void)getCityList {
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/getprovinceareaslist/", KMainUrl];
    [PPNetworkHelper GET:url parameters:@{} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            NSDictionary *dataDic = (NSDictionary *)resdic[@"data"];
            NSArray *arr = (NSArray *)dataDic[@"data"];
            NSMutableArray *dataSource = [NSMutableArray array];

            [arr enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
                NSDictionary *pdic = arr[idx];
                NSMutableArray *cityModelArr = [NSMutableArray array];
                NSArray *cityArr = (NSArray *)pdic[@"childlist"];
                [cityArr enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx1, BOOL * _Nonnull stop) {
                    NSDictionary *adic = cityArr[idx1];
                    BRCityModel *cmodel = [BRCityModel new];
                    cmodel.name = adic[@"name"];
                    cmodel.code = adic[@"id"];
                    cmodel.index = idx1;
                    [cityModelArr addObject:cmodel];
                }];
                BRProvinceModel *model = [BRProvinceModel new];
                model.name = pdic[@"name"];
                model.citylist = cityModelArr;
                model.code = pdic[@"id"];
                model.index = idx;
                [dataSource addObject:model];
            }];

            [self.areaArr removeAllObjects];
            [self.areaArr addObjectsFromArray:dataSource];
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)submitBtnClick {
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    
    NSString *type = @"";
    if (_isedit) {
        type = @"edit";
    } else {
        type = @"add";
    }
    NSMutableArray *topimgArr = [NSMutableArray array];
    for (BC_UploadImgModel *model in self.imgArr) {
        if ([KStringIsNull(model.type) isEqualToString:@""]) {
            [topimgArr addObject:KStringIsNull(model.imgurl)];
        }
    }
        
    
    NSMutableArray *teneArr = [NSMutableArray array];
    for (int i = 0; i < self.tenementArr.count; i++) {
        NSArray *arr = self.tenementArr[i];
        BC_MyHouseAddModel *hmodel1 = arr[0];
        BC_MyHouseAddModel *hmodel2 = arr[1];
        BC_MyHouseAddModel *hmodel3 = arr[2];
        BC_MyHouseAddModel *hmodel4 = arr[3];
        BC_MyHouseAddModel *hmodel5 = arr[4];
        BC_MyHouseAddModel *hmodel6 = arr[5];
        BC_MyHouseAddModel *hmodel7 = arr[6];
        NSMutableArray *tenImgArr = [NSMutableArray array];
        for (BC_UploadImgModel *model in hmodel7.imageArr) {
            if ([KStringIsNull(model.type) isEqualToString:@""]) {
                [tenImgArr addObject:KStringIsNull(model.imgurl)];
            }
        }
        
        NSString *files = KStringIsNull([tenImgArr mj_JSONString]);
        files = [KStringIsNull(files) stringByReplacingOccurrencesOfString:@"\\" withString:@""];
        if (_isedit) {
            NSDictionary *dic = @{@"id":KStringIsNull(hmodel1.tenantID),@"name":KStringIsNull(hmodel2.contentValue),@"avatar":KStringIsNull(hmodel1.contentValue),@"mobile":KStringIsNull(hmodel3.contentValue),@"email":KStringIsNull(hmodel4.contentValue),@"vocation":KStringIsNull(hmodel5.contentValue), @"score":KStringIsNull(hmodel6.contentValue),@"files":KStringIsNull(files)};
            [teneArr addObject:dic];
        } else {
            NSDictionary *dic = @{@"name":KStringIsNull(hmodel2.contentValue),@"avatar":KStringIsNull(hmodel1.contentValue),@"mobile":KStringIsNull(hmodel3.contentValue),@"email":KStringIsNull(hmodel4.contentValue),@"vocation":KStringIsNull(hmodel5.contentValue), @"score":KStringIsNull(hmodel6.contentValue),@"files":KStringIsNull(files)};
            [teneArr addObject:dic];
        }
    }
    NSString *tenaStr = [KStringIsNull([teneArr mj_JSONString]) stringByReplacingOccurrencesOfString:@"\\" withString:@""];
    NSString *images = [KStringIsNull([topimgArr mj_JSONString]) stringByReplacingOccurrencesOfString:@"\\" withString:@""];
    
    NSString *url = [NSString stringWithFormat:@"%@/api/app/gethouseaddedit/", KMainUrl];
    NSDictionary *para = @{@"type":type, @"name":KStringIsNull(self.nameL.text), @"price":KStringIsNull(self.valueL.text), @"images":KStringIsNull(images), @"place":KStringIsNull(self.locationL.text), @"city":KStringIsNull(self.selectCityID), @"tenant":KStringIsNull(tenaStr), @"id":KStringIsNull(self.editModel.itemid)};
    
    KLog(@"para====%@", para);
        
    [PPNetworkHelper POST:url parameters:para success:^(id responseObject) {
        KLog(@"发布成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [BaseFunction showAlert:@"Submit success"];
            [kNotificationCenter postNotificationName:@"refreshListAfterSubmit" object:nil];
            [self.navigationController popViewControllerAnimated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (BRAddressPickerView *)areaPicker {
    if (!_areaPicker) {
        _areaPicker = [[BRAddressPickerView alloc] initWithPickerMode:BRAddressPickerModeCity];
        _areaPicker.dataSourceArr = self.areaArr;
        @weakify(self);
        _areaPicker.resultBlock = ^(BRProvinceModel * _Nullable province, BRCityModel * _Nullable city, BRAreaModel * _Nullable area) {
            @strongify(self);
            self.cityL.text = kStringFormat(@"%@ %@", KStringIsNull(province.name), KStringIsNull(city.name));
            self.selectCityID = KStringIsNull(city.code);
        };
    }
    return _areaPicker;
}
@end
