//
//  BC_ChangeGroupNameViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/21.
//

#import "BC_ChangeGroupNameViewController.h"
@import ImSDK_Plus;
@interface BC_ChangeGroupNameViewController ()
@property (nonatomic, strong) UIImageView *logoImg;
@property (nonatomic, strong) UITextField *nameTF;
@end

@implementation BC_ChangeGroupNameViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Group name";
    [self setupUI];
}

- (void)setupUI {
    
    self.logoImg = [JLFactoryUtil imageView];
    [self.logoImg setCorner:26 withType:JLCornerTypeAllCorner];
    [self.view addSubview:self.logoImg];
    [self.logoImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(24);
        make.top.equalTo(self.view.mas_top).offset(48);
        make.size.mas_equalTo(CGSizeMake(52, 52));
    }];
    [self.logoImg sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(self.groupAvatar)]];
    
    self.nameTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(16) place:@"Modify group chat name"];
    self.nameTF.textColor = kMainTextColor;
    [self.view addSubview:self.nameTF];
    [self.nameTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.logoImg);
        make.left.equalTo(self.logoImg.mas_right).offset(15);
        make.right.equalTo(self.view.mas_right).offset(-20);
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#E6E6E6");
    [self.view addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(24);
        make.top.equalTo(self.logoImg.mas_bottom).offset(12);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 48, 1));
    }];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.top.equalTo(line.mas_bottom).offset(100);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
}

- (void)submitBtnClick {
    
    if ([KStringIsNull(self.nameTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please input name"];
        return;
    }
    [self.view endEditing:YES];
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    V2TIMGroupInfo *info = [V2TIMGroupInfo new];
    info.groupID = KStringIsNull(self.groupid);
    info.groupName = KStringIsNull(self.nameTF.text);
    [[V2TIMManager sharedInstance] setGroupInfo:info succ:^{
        KLog(@"修改群名称成功");
        dispatch_async(dispatch_get_main_queue(), ^{
            [MBProgressHUD hideHUDForView:self.view animated:YES];
            [BaseFunction showAlert:@"Set success"];
            [self.navigationController popViewControllerAnimated:YES];
        });
    } fail:^(int code, NSString *desc) {
        KLog(@"修改群名称 error===%@", desc);
        dispatch_async(dispatch_get_main_queue(), ^{
            [MBProgressHUD hideHUDForView:self.view animated:YES];
            [BaseFunction showAlert:KStringIsNull(desc)];
        });
    }];
}

@end
