//
//  BC_AddGroupHouseListTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/21.
//

#import "BC_AddGroupHouseListTableViewCell.h"
#import "BC_HouseInfoModel.h"
@implementation BC_AddGroupHouseListTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    
    self.selBtn = [JLFactoryUtil imageViewWithImg:@"未选中icon"];
    [self.contentView addSubview:self.selBtn];
    [self.selBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.contentView.mas_left).offset(10);
        make.size.mas_equalTo(CGSizeMake(30, 30));
    }];
    
    self.logoImg = [JLFactoryUtil imageView];
    [self.logoImg setCorner:5 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.logoImg];
    [self.logoImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.selBtn.mas_right).offset(10);
        make.centerY.equalTo(self.contentView);
        make.size.mas_equalTo(CGSizeMake(88, 88));
    }];
    
    UIImageView *disImg = [JLFactoryUtil imageViewWithImg:@"价格"];
    [self.contentView addSubview:disImg];
    [disImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.logoImg);
        make.left.equalTo(self.logoImg.mas_right).offset(10);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    self.disL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.disL];
    [self.disL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(disImg.mas_right).offset(5);
        make.right.equalTo(self.contentView.mas_right).offset(-10);
        make.centerY.equalTo(self.logoImg);
    }];
    
    self.areaL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.areaL];
    [self.areaL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.logoImg.mas_right).offset(10);
        make.right.equalTo(self.contentView.mas_right).offset(-10);
        make.bottom.equalTo(disImg.mas_top).offset(-10);
    }];
    
    UIImageView *addrImg = [JLFactoryUtil imageViewWithImg:@"位置"];
    [self.contentView addSubview:addrImg];
    [addrImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(disImg.mas_bottom).offset(10);
        make.left.equalTo(self.logoImg.mas_right).offset(10);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    self.addressL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.addressL];
    [self.addressL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(addrImg.mas_right).offset(5);
        make.right.equalTo(self.contentView.mas_right).offset(-10);
        make.centerY.equalTo(addrImg);
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(self.contentView.mas_bottom);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
}

- (void)setModel:(BC_HouseInfoModel *)model {
    _model = model;
    if (model.images.count > 0) {
        [self.logoImg sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(model.images[0])]];

    }
    
    self.areaL.text = kStringFormat(@"%@ %@",KStringIsNull(model.name), KStringIsNull(model.city));
    self.disL.text = kStringFormat(@"$%@", KStringIsNull(model.price));
    self.addressL.text = KStringIsNull(model.place);
    if (model.isSelect) {
        self.selBtn.image = [UIImage imageNamed:@"选中icon"];
    } else {
        self.selBtn.image = [UIImage imageNamed:@"未选中icon"];
    }
}
@end
