//
//  BC_AddHousePicTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_AddHousePicTableViewCell.h"
#import "BC_MyHouseAddModel.h"
#import "BC_UploadImgModel.h"
@implementation BC_AddHousePicTableViewCell
- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        [self setupUI];
    }
    return self;
}

- (void)setupUI  {
    self.typeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.typeL];
    [self.typeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.contentView.mas_top).offset(20);
        make.left.equalTo(self.contentView.mas_left).offset(15);
    }];
    
//    self.contractImg = [JLFactoryUtil imageViewWithImg:@"添加"];
//    [self.contentView addSubview:self.contractImg];
//    [self.contractImg mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.left.equalTo(self.contentView.mas_left).offset(15);
//        make.top.equalTo(self.typeL.mas_bottom).offset(12);
//        make.size.mas_equalTo(CGSizeMake(66, 66));
//    }];
    
    self.imgScrollView = [[UIScrollView alloc] initWithFrame:CGRectZero];
    self.imgScrollView.showsHorizontalScrollIndicator = NO;
    self.imgScrollView.userInteractionEnabled = YES;
    [self.contentView addSubview:self.imgScrollView];
    [self.imgScrollView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.typeL.mas_bottom).offset(12);
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 70));
    }];
        
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(self.contentView.mas_bottom);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
}

- (void)setModel:(BC_MyHouseAddModel *)model {
    _model = model;
    self.typeL.text = KStringIsNull(model.type);
    self.imgScrollView.contentSize = CGSizeMake(76*model.imageArr.count+76, 70);
    [self.imgScrollView removeAllSubviews];
    
    UIImageView *imgv = [JLFactoryUtil imageView];
    imgv.userInteractionEnabled = YES;
    [self.imgScrollView addSubview:imgv];
    imgv.frame = CGRectMake(0, 0, 66, 66);
    imgv.image = [UIImage imageNamed:@"添加"];
    UITapGestureRecognizer *tapImg = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(clickAdd)];
    [imgv addGestureRecognizer:tapImg];
    
    for (int i = 0; i < model.imageArr.count; i++) {
        BC_UploadImgModel *imgmodel = model.imageArr[i];
        UIImageView *imgv = [JLFactoryUtil imageView];
        [self.imgScrollView addSubview:imgv];
        imgv.frame = CGRectMake(76 + i * 76 , 0, 66, 66);
        [imgv sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(imgmodel.imgurl)]];
    }
        
}

- (void)setIndexP:(NSIndexPath *)indexP {
    _indexP = indexP;
}

- (void)clickAdd {
    if (self.delegate && [self.delegate respondsToSelector:@selector(clickAddContractImg:)]) {
        [self.delegate clickAddContractImg:_indexP];
    }
}

@end
