//
//  BC_AddHouseTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_AddHouseTableViewCell.h"
#import "BC_MyHouseAddModel.h"

@interface BC_AddHouseTableViewCell()<UITextFieldDelegate>

@end

@implementation BC_AddHouseTableViewCell
- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        [self setupUI];
    }
    return self;
}

- (void)setupUI  {
    self.typeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.typeL];
    [self.typeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.contentView.mas_left).offset(15);
    }];
    
    self.avatar = [JLFactoryUtil imageView];
    [self.avatar setCorner:24 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.avatar];
    [self.avatar mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.size.mas_equalTo(CGSizeMake(48, 48));
    }];
    self.avatar.hidden = YES;
    
    self.inputTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(15) place:@""];
    self.inputTF.delegate = self;
    self.inputTF.textColor = kLightGrayTextColor;
    self.inputTF.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:self.inputTF];
    [self.inputTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.size.mas_equalTo(CGSizeMake(200, 35));
    }];
    [self.inputTF addTarget:self action:@selector(inputContent:) forControlEvents:UIControlEventEditingChanged];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(self.contentView.mas_bottom);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
}

- (void)inputContent:(UITextField *)sender {
    _model.contentValue = KStringIsNull(sender.text);
}

- (void)setModel:(BC_MyHouseAddModel *)model {
    _model = model;
    self.typeL.text = KStringIsNull(model.type);
    if ([KStringIsNull(model.type) isEqualToString:@"Avatar"]) {
        self.inputTF.hidden = YES;
        self.avatar.hidden = NO;
        [self.avatar sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(model.contentValue)]];
    } else {
        self.inputTF.hidden = NO;
        self.avatar.hidden = YES;
        self.inputTF.text = KStringIsNull(model.contentValue);
    }
}

@end
