//
//  BC_ExecutorRecommendViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/24.
//

#import "BC_ExecutorRecommendViewController.h"
#import "BC_ExecutorRecommendRecordViewController.h"

@interface BC_ExecutorRecommendViewController ()
@property (nonatomic, strong) UIScrollView *scrollView;
@property (nonatomic, strong) UIView *contentView;

@property (nonatomic, strong) UITextField *nameTF;
@property (nonatomic, strong) UITextField *contactTF;
@property (nonatomic, strong) YYTextView *descTV;
@end

@implementation BC_ExecutorRecommendViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Refer customers";
    
    UIButton *recordBtn = [JLFactoryUtil buttonWithTitle:@"Record" font:MEDIUMFONT(16) textColor:kColorWithHex(@"#05A833")];
    [recordBtn addTarget:self action:@selector(recordBtnClick) forControlEvents:UIControlEventTouchUpInside];
    
    UIBarButtonItem *item = [[UIBarButtonItem alloc] initWithCustomView:recordBtn];
    self.navigationItem.rightBarButtonItem = item;
    
    [self setupUI];
}

- (void)setupUI {
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight - kTopHeight)];
    self.scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:self.scrollView];
    
    self.contentView = [UIView new];
    self.contentView.backgroundColor = [UIColor whiteColor];
    [self.scrollView addSubview:self.contentView];
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.scrollView);
        make.width.equalTo(self.scrollView);
    }];
    
    UILabel *label1 = [JLFactoryUtil labelWithText:@"Customer Name" font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label1];
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(20);
    }];
    
    self.nameTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(14) place:@"Name"];
    self.nameTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.nameTF];
    [self.nameTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(label1);
        make.top.equalTo(label1.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 35));
    }];
    
    UIView *line1 = [JLFactoryUtil view];
    line1.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line1];
    [line1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(label1);
        make.top.equalTo(self.nameTF.mas_bottom).offset(2);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UILabel *label2 = [JLFactoryUtil labelWithText:@"Customer contact" font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label2];
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line1.mas_bottom).offset(20);
    }];
    
    self.contactTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(14) place:@"Contact information"];
    self.contactTF.textColor = kMainTextColor;
    [self.contentView addSubview:self.contactTF];
    [self.contactTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(label2);
        make.top.equalTo(label2.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 35));
    }];
    
    UIView *line2 = [JLFactoryUtil view];
    line2.backgroundColor = kColorWithHex(@"#F2F2F2");
    [self.contentView addSubview:line2];
    [line2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(label2);
        make.top.equalTo(self.contactTF.mas_bottom).offset(2);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UILabel *label3 = [JLFactoryUtil labelWithText:@"Description of Requirement" font:REGULARFONT(16) textColor:kMainTextColor];
    [self.contentView addSubview:label3];
    [label3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(line2.mas_bottom).offset(20);
    }];
    
    UIView *dview = [JLFactoryUtil view];
    [dview setCorner:4 withType:JLCornerTypeAllCorner];
    dview.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:dview];
    [dview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(label1);
        make.top.equalTo(label3.mas_bottom).offset(10);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 120));
    }];
    
    self.descTV = [YYTextView new];
    self.descTV.placeholderFont = REGULARFONT(14);
    self.descTV.placeholderText = @"Demand content";
    self.descTV.placeholderTextColor = kLightGrayTextColor;
    self.descTV.textColor = kMainTextColor;
    self.descTV.font = REGULARFONT(14);
    [dview addSubview:self.descTV];
    [self.descTV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(dview).insets(UIEdgeInsetsMake(10, 10, 10, 10));
    }];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:22 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.contentView);
        make.top.equalTo(dview.mas_bottom).offset(100);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 44));
    }];
    
    [self.contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(submitBtn.mas_bottom).offset(20);
    }];
}

- (void)recordBtnClick {
    [self.navigationController pushViewController:[BC_ExecutorRecommendRecordViewController new] animated:YES];
}

- (void)submitBtnClick {
    
    if ([KStringIsNull(self.nameTF.text) isEqualToString:@""] || [KStringIsNull(self.contactTF.text) isEqualToString:@""] || [KStringIsNull(self.descTV.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please complete info"];
        return;
    }
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/recommendcustomer/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"mobile":KStringIsNull(self.contactTF.text), @"name":KStringIsNull(self.nameTF.text), @"desc":KStringIsNull(self.descTV.text)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            self.nameTF.text = @"";
            self.contactTF.text = @"";
            self.descTV.text = @"";
            [BaseFunction showAlert:@"Success"];
            
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}
@end
