//
//  BC_ExecutorRecommendRecordTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/24.
//

#import "BC_ExecutorRecommendRecordTableViewCell.h"
#import "BC_MineModuleModel.h"
@implementation BC_ExecutorRecommendRecordTableViewCell


- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.nameL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.nameL];
    [self.nameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(20);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-100);
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(12) textColor:kLightGrayTextColor];
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.nameL);
        make.right.equalTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.phoneL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kColorWithHex(@"#777777")];
    [self.contentView addSubview:self.phoneL];
    [self.phoneL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.nameL);
        make.top.equalTo(self.nameL.mas_bottom).offset(8);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.descL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kColorWithHex(@"#777777")];
    self.descL.numberOfLines = 0;
    [self.contentView addSubview:self.descL];
    [self.descL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.nameL);
        make.top.equalTo(self.phoneL.mas_bottom).offset(12);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
        make.bottom.equalTo(self.contentView.mas_bottom).offset(-20);
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#F5F5F5");
    [self.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.bottom.equalTo(self.contentView.mas_bottom);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
}

- (void)setModel:(BC_MineModuleModel *)model {
    _model = model;
    self.nameL.text = KStringIsNull(model.name);
    self.timeL.text = KStringIsNull(model.create_datetime);
    self.phoneL.text = KStringIsNull(model.mobile);
    self.descL.text = KStringIsNull(model.desc);
}
@end
