//
//  BC_EditNicknameViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_EditNicknameViewController.h"
@import ImSDK_Plus;
@interface BC_EditNicknameViewController ()
@property (nonatomic, strong) UITextField *nameTF;
@end

@implementation BC_EditNicknameViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    self.navigationItem.title = @"Change username";
    [self setupUI];
    self.nameTF.text = KStringIsNull(self.nickname);
}

- (void)setupUI {
    self.nameTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(15) place:@"name"];
    self.nameTF.textColor = kMainTextColor;
    [self.view addSubview:self.nameTF];
    [self.nameTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(15);
        make.right.equalTo(self.view.mas_right).offset(-15);
        make.top.equalTo(self.view.mas_top).offset(20);
        make.height.mas_equalTo(35);
    }];
    
    UIView *line = [JLFactoryUtil view];
    line.backgroundColor = kColorWithHex(@"#E6E6E6");
    [self.view addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(15);
        make.top.equalTo(self.nameTF.mas_bottom).offset(20);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, 1));
    }];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.top.equalTo(line.mas_bottom).offset(280);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
}

- (void)submitBtnClick {
    if ([KStringIsNull(self.nameTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Please input name"];
        return;
    }
    
    [self.view endEditing:YES];
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/setnickname/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"nickname":KStringIsNull(self.nameTF.text)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            
            V2TIMUserFullInfo *info = [[V2TIMUserFullInfo alloc] init];
            info.nickName = KStringIsNull(self.nameTF.text);
            [[V2TIMManager sharedInstance] setSelfInfo:info succ:^{
                KLog(@"设置im昵称成功");
            } fail:^(int code, NSString *desc) {
            }];
            
            [BaseFunction showAlert:@"Edit success"];
            BaseUserModel *umodel = [UserManager shareManager].getUserInfo;
            umodel.member_nickname = KStringIsNull(self.nameTF.text);
            [[UserManager shareManager] saveUserInfoWithModel:umodel];
            [self.navigationController popViewControllerAnimated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

@end
