//
//  BC_EditPhoneViewController.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/20.
//

#import "BC_EditPhoneViewController.h"
#import "EVTPhoneAreaCodeViewController.h"

@interface BC_EditPhoneViewController ()
@property (nonatomic, strong) UITextField *accTF;
@property (nonatomic, strong) UITextField *codeTF;
@property (nonatomic, strong) UIButton *getCodeBtn;
@property (nonatomic, strong) UILabel *areaCodeL;

@property (nonatomic, copy) NSString *msgCode;
@end

@implementation BC_EditPhoneViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.navigationItem.title = @"Revise phone";
    self.msgCode = @"";
    [self setupUI];
}

- (void)setupUI {
    UIView *accview = [JLFactoryUtil view];
    [accview setCorner:8 withType:JLCornerTypeAllCorner];
    accview.layer.borderWidth = 1;
    accview.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
    [self.view addSubview:accview];
    [accview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.top.equalTo(self.view.mas_top).offset(24);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    UIImageView *accImg = [JLFactoryUtil imageViewWithImg:@"账号icon"];
    [accview addSubview:accImg];
    [accImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(accview.mas_left).offset(15);
        make.centerY.equalTo(accview);
        make.size.mas_equalTo(CGSizeMake(20, 20));
    }];
    
    self.areaCodeL = [JLFactoryUtil labelWithText:@"+86" font:REGULARFONT(13) textColor:kLightGrayTextColor];
    self.areaCodeL.textAlignment = NSTextAlignmentCenter;
    self.areaCodeL.userInteractionEnabled = YES;
    [accview addSubview:self.areaCodeL];
    [self.areaCodeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(accImg.mas_right).offset(0);
        make.width.mas_equalTo(55);
        make.centerY.equalTo(accImg);
    }];
    UITapGestureRecognizer *tapArea = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chooseAreaCode)];
    [self.areaCodeL addGestureRecognizer:tapArea];
    
    UIView *vline = [JLFactoryUtil view];
    vline.backgroundColor = kColorWithHex(@"#E6E6E6");
    [accview addSubview:vline];
    [vline mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.areaCodeL.mas_right);
        make.centerY.equalTo(self.areaCodeL);
        make.size.mas_equalTo(CGSizeMake(1, 12));
    }];
    
    self.accTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Input mobile Phone number"];
    self.accTF.keyboardType = UIKeyboardTypePhonePad;
    self.accTF.textColor = kMainTextColor;
    [accview addSubview:self.accTF];
    [self.accTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(accview);
        make.left.equalTo(vline.mas_right).offset(10);
        make.right.equalTo(accview.mas_right).offset(-10);
        make.height.mas_equalTo(35);
    }];
    
    UIView *codeView = [JLFactoryUtil view];
    [codeView setCorner:8 withType:JLCornerTypeAllCorner];
    codeView.layer.borderWidth = 1;
    codeView.layer.borderColor = kColorWithHex(@"#E6E6E6").CGColor;
    [self.view addSubview:codeView];
    [codeView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.view.mas_left).offset(30);
        make.top.equalTo(accview.mas_bottom).offset(16);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
    self.codeTF = [JLFactoryUtil textFieldWithFont:REGULARFONT(13) place:@"Please enter verification code"];
    self.codeTF.textColor = kMainTextColor;
    [codeView addSubview:self.codeTF];
    [self.codeTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(codeView);
        make.left.equalTo(codeView.mas_left).offset(10);
        make.right.equalTo(codeView.mas_right).offset(-112);
        make.height.mas_equalTo(35);
    }];
    
    self.getCodeBtn = [JLFactoryUtil buttonWithTitle:@"Verification" font:REGULARFONT(14) textColor:UIColor.whiteColor];
    self.getCodeBtn.backgroundColor = kMainThemeColor;
    [self.getCodeBtn setCorner:18 withType:JLCornerTypeAllCorner];
    [self.getCodeBtn setLayerShadow:[UIColor colorWithRed:230/255.0 green:0/255.0 blue:0/255.0 alpha:0.6] offset:CGSizeMake(0, 0) radius:4];
    [self.getCodeBtn addTarget:self action:@selector(getCodeBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [codeView addSubview:self.getCodeBtn];
    [self.getCodeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.codeTF);
        make.left.equalTo(self.codeTF.mas_right).offset(10);
        make.right.equalTo(codeView.mas_right).offset(-10);
        make.height.mas_equalTo(36);
    }];
    
    UIButton *submitBtn = [JLFactoryUtil buttonWithTitle:@"Submit" font:MEDIUMFONT(16) textColor:UIColor.whiteColor];
    [submitBtn setCorner:24 withType:JLCornerTypeAllCorner];
    submitBtn.backgroundColor = kMainThemeColor;
    [submitBtn setLayerShadow:[UIColor colorWithRed:232/255.0 green:37/255.0 blue:37/255.0 alpha:0.36] offset:CGSizeMake(0, 4) radius:8];
    [submitBtn addTarget:self action:@selector(submitBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:submitBtn];
    [submitBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(accview.mas_left);
        make.top.equalTo(codeView.mas_bottom).offset(80);
        make.size.mas_equalTo(CGSizeMake(kScreenWidth - 60, 48));
    }];
    
}

#pragma mark  区号
- (void)chooseAreaCode {
    EVTPhoneAreaCodeViewController *code = [[EVTPhoneAreaCodeViewController alloc] init];
    code.localeEn = YES;
    @weakify(self);
    code.completion = ^(NSString *name, NSString *code) {
        @strongify(self);
        self.areaCodeL.text = kStringFormat(@"+%@", KStringIsNull(code));
    };
    [self.navigationController pushViewController:code animated:YES];
}

- (void)getCodeBtnClick {
    
    if ([KStringIsNull(self.accTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"Invalid phone number"];
        return;
    }
    [self.view endEditing:YES];
    
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/sendsms/", KMainUrl];
    NSString *ccode = [KStringIsNull(self.areaCodeL.text) substringFromIndex:1];

    [PPNetworkHelper POST:url parameters:@{@"mobile":KStringIsNull(self.accTF.text), @"smstype":@"", @"countrycode":KStringIsNull(ccode)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [self countTime];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}

- (void)countTime {
    __block int timeout=60; //倒计时时间
    dispatch_queue_t queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    dispatch_source_t _timer = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0,queue);
    dispatch_source_set_timer(_timer,dispatch_walltime(NULL, 0),1.0*NSEC_PER_SEC, 0); //每秒执行
    dispatch_source_set_event_handler(_timer, ^{
        if(timeout<=0){ //倒计时结束，关闭
            dispatch_source_cancel(_timer);
            //dispatch_release(_timer);
            dispatch_async(dispatch_get_main_queue(), ^{
                self->_getCodeBtn.enabled = YES;
                [self->_getCodeBtn setTitle:@"Verification" forState:0];
            });
        }else{
            dispatch_async(dispatch_get_main_queue(), ^{
                self->_getCodeBtn.enabled = NO;
                [self->_getCodeBtn setTitle:[NSString stringWithFormat:@"%ds",timeout] forState:0];
            });
            timeout--;
        }
    });
    dispatch_resume(_timer);
}

- (void)submitBtnClick {
    if ([KStringIsNull(self.accTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"please input phone number"];
        return;
    }
    
    if ([KStringIsNull(self.codeTF.text) isEqualToString:@""]) {
        [BaseFunction showAlert:@"please input verification code"];
        return;
    }
    
    [self.view endEditing:YES];
    [MBProgressHUD showHUDAddTo:self.view alertMsg:@"" animated:YES];
    NSString *url = [NSString stringWithFormat:@"%@/api/app/rebindmobile/", KMainUrl];
    [PPNetworkHelper POST:url parameters:@{@"mobile":KStringIsNull(self.accTF.text), @"code":KStringIsNull(self.codeTF.text)} success:^(id responseObject) {
        KLog(@"成功======%@",responseObject);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        NSDictionary *resdic = (NSDictionary *)responseObject;
        if ([resdic[@"code"] integerValue] == 2000) {
            [BaseFunction showAlert:@"Edit success"];
            BaseUserModel *umodel = [UserManager shareManager].getUserInfo;
            umodel.member_phone = KStringIsNull(self.accTF.text);
            [[UserManager shareManager] saveUserInfoWithModel:umodel];
            [self.navigationController popViewControllerAnimated:YES];
        } else {
            [BaseFunction showAlert:kStringFormat(@"%@", resdic[@"msg"])];
        }
    } failure:^(NSError *error) {
        KLog(@"失败======%@",error);
        [MBProgressHUD hideHUDForView:self.view animated:YES];
        [BaseFunction showAlert:@"Error"];
    }];
}
@end
