//
//  BC_SupervisorHomeHasBtnPicTableViewCell.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/25.
//

#import "BC_SupervisorHomeHasBtnPicTableViewCell.h"
#import "BC_PostListModel.h"

@implementation BC_SupervisorHomeHasBtnPicTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.contentView.backgroundColor = UIColor.whiteColor;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.avatar = [JLFactoryUtil imageView];
    [self.avatar setCorner:20 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.avatar];
    [self.avatar mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentView.mas_top).offset(15);
        make.size.mas_equalTo(CGSizeMake(40, 40));
    }];
    
    self.nicknameL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(15) textColor:kMainTextColor];
    [self.contentView addSubview:self.nicknameL];
    [self.nicknameL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.avatar.mas_right).offset(10);
        make.bottom.equalTo(self.avatar.mas_centerY).offset(-1);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-10);
    }];
    
    self.timeL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(12) textColor:kLightGrayTextColor];
    [self.contentView addSubview:self.timeL];
    [self.timeL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.avatar.mas_right).offset(10);
        make.top.equalTo(self.avatar.mas_centerY).offset(1);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-10);
    }];
    
    self.titleL = [JLFactoryUtil labelWithText:@" " font:MEDIUMFONT(14) textColor:kMainTextColor];
    self.titleL.numberOfLines = 0;
    [self.contentView addSubview:self.titleL];
    [self.titleL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.avatar.mas_bottom).offset(12);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.contentL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(14) textColor:kColorWithHex(@"#777777")];
    self.contentL.numberOfLines = 2;
    [self.contentView addSubview:self.contentL];
    [self.contentL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.titleL.mas_bottom).offset(8);
        make.right.lessThanOrEqualTo(self.contentView.mas_right).offset(-15);
    }];
    
    self.imgview1 = [JLFactoryUtil imageView];
    [self.imgview1 setCorner:5 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.imgview1];
    [self.imgview1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.contentL.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 40)/3, (kScreenWidth - 40)/3));
    }];
    
    self.imgview2 = [JLFactoryUtil imageView];
    [self.imgview2 setCorner:5 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.imgview2];
    [self.imgview2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.imgview1.mas_right).offset(5);
        make.top.equalTo(self.contentL.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 40)/3, (kScreenWidth - 40)/3));
    }];
    
    self.imgview3 = [JLFactoryUtil imageView];
    [self.imgview3 setCorner:5 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.imgview3];
    [self.imgview3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.imgview2.mas_right).offset(5);
        make.top.equalTo(self.contentL.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake((kScreenWidth - 40)/3, (kScreenWidth - 40)/3));
    }];
    
    self.areaView = [JLFactoryUtil view];
    self.areaView.backgroundColor = kColorWithHex(@"#ECF8EF");
    [self.areaView setCorner:12 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.areaView];
    [self.areaView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.contentView.mas_left).offset(15);
        make.top.equalTo(self.imgview1.mas_bottom).offset(8);
        make.size.mas_equalTo(CGSizeMake(30, 24));
        make.bottom.equalTo(self.contentView.mas_bottom).offset(-20);
    }];
    
    UIImageView *areaImg = [JLFactoryUtil imageViewWithImg:@"位置"];
    [self.areaView addSubview:areaImg];
    [areaImg mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(self.areaView.mas_left).offset(10);
        make.size.mas_equalTo(CGSizeMake(16, 16));
    }];
    
    self.areaL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(13) textColor:kColorWithHex(@"#05A833")];
    [self.areaView addSubview:self.areaL];
    [self.areaL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.areaView);
        make.left.equalTo(areaImg.mas_right).offset(3);
        make.width.mas_lessThanOrEqualTo(250);
    }];
    
    UIButton *repBtn = [JLFactoryUtil buttonWithImage:@"屏蔽"];
    [repBtn setTitle:@"shield" forState:0];
    repBtn.titleLabel.font = REGULARFONT(14);
    [repBtn setTitleColor:kMainTextColor forState:0];
    repBtn.titleEdgeInsets = UIEdgeInsetsMake(0, 5, 0, 0);
    [repBtn addTarget:self action:@selector(repBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:repBtn];
    [repBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-10);
        make.centerY.equalTo(self.areaView);
        make.size.mas_equalTo(CGSizeMake(90, 20));
    }];
        
    self.passBtn = [JLFactoryUtil buttonWithTitle:@"Pass" font:REGULARFONT(15) textColor:kMainThemeColor];
//    [self.passBtn addTarget:self action:@selector(passBtnClick) forControlEvents:UIControlEventTouchUpInside];
    self.passBtn.enabled = NO;
    self.passBtn.layer.borderWidth = 1;
    self.passBtn.layer.borderColor = kMainThemeColor.CGColor;
    [self.passBtn setCorner:16 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.passBtn];
    [self.passBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.top.equalTo(self.areaView.mas_bottom).offset(12);
        make.size.mas_equalTo(CGSizeMake(80, 32));
    }];
    
    self.refuseBtn = [JLFactoryUtil buttonWithTitle:@"Refuse" font:REGULARFONT(15) textColor:kMainTextColor];
//    [self.refuseBtn addTarget:self action:@selector(refuseBtnClick) forControlEvents:UIControlEventTouchUpInside];
    self.refuseBtn.enabled = NO;
    self.refuseBtn.layer.borderWidth = 1;
    self.refuseBtn.layer.borderColor = kColorWithHex(@"#AAAAAA").CGColor;
    [self.refuseBtn setCorner:16 withType:JLCornerTypeAllCorner];
    [self.contentView addSubview:self.refuseBtn];
    [self.refuseBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.passBtn.mas_left).offset(-15);
        make.top.equalTo(self.areaView.mas_bottom).offset(12);
        make.size.mas_equalTo(CGSizeMake(80, 32));
    }];
    self.passBtn.hidden = YES;
    self.refuseBtn.hidden = YES;
    
    self.statusL = [JLFactoryUtil labelWithText:@" " font:REGULARFONT(15) textColor:kColorWithHex(@"#777777")];
    [self.contentView addSubview:self.statusL];
    [self.statusL mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.contentView.mas_right).offset(-15);
        make.centerY.equalTo(self.nicknameL);
    }];
    
}

- (void)repBtnClick {
    if (self.delegate && [self.delegate respondsToSelector:@selector(shieldPicItem:)]) {
        [self.delegate shieldPicItem:_model];
    }
}

- (void)setPageIndex:(NSInteger)pageIndex {
    _pageIndex = pageIndex;
    if (pageIndex == 0) {
        self.statusL.hidden = YES;
        self.refuseBtn.hidden = NO;
        self.passBtn.hidden = NO;
    } else {
        self.statusL.hidden = NO;
        self.refuseBtn.hidden = YES;
        self.passBtn.hidden = YES;
        self.statusL.text = @"through";//Refused
    }
}

- (void)setModel:(BC_PostListModel *)model {
    _model = model;
    [self.avatar sd_setImageWithURL:[NSURL URLWithString:KStringIsNull(model.user_avatar)] placeholderImage:kAvatarPlaceHolderImg];
    self.nicknameL.text = KStringIsNull(model.user_name).length == 0 ? @"User":KStringIsNull(model.user_name);    self.timeL.text = KStringIsNull(model.create_datetime);
    self.titleL.text = KStringIsNull(model.name);
    self.contentL.text = KStringIsNull(model.desc);
    self.areaL.text = KStringIsNull(model.city);
    CGSize size = [self.areaL sizeThatFits:CGSizeMake(kScreenWidth, CGFLOAT_MAX)];
    if (size.width >= 250) {
        size.width = 250;
    }
    
    if ([KStringIsNull(model.audit_status) isEqualToString:@"10"]) {
        self.statusL.hidden = YES;
        self.refuseBtn.hidden = NO;
        self.passBtn.hidden = NO;
        [self.areaView mas_updateConstraints:^(MASConstraintMaker *make) {
            make.size.mas_equalTo(CGSizeMake(40+size.width, 24));
            make.bottom.equalTo(self.contentView.mas_bottom).offset(-60);
        }];
    } else {
        self.statusL.hidden = NO;
        self.refuseBtn.hidden = YES;
        self.passBtn.hidden = YES;
        [self.areaView mas_updateConstraints:^(MASConstraintMaker *make) {
            make.size.mas_equalTo(CGSizeMake(40+size.width, 24));
            make.bottom.equalTo(self.contentView.mas_bottom).offset(-20);
        }];
        if ([KStringIsNull(model.audit_status) isEqualToString:@"20"]) {
            self.statusL.text = @"through";
        } else {
            self.statusL.text = @"Refused";
        }
    }
        
    NSArray *imgarr = model.files;
    if (imgarr.count >= 3) {
        self.imgview1.hidden = NO;
        self.imgview2.hidden = NO;
        self.imgview3.hidden = NO;
        [self.imgview1 mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.contentView.mas_left).offset(15);
            make.top.equalTo(self.contentL.mas_bottom).offset(8);
            make.size.mas_equalTo(CGSizeMake((kScreenWidth - 40)/3, (kScreenWidth - 40)/3));
        }];
        [self.imgview2 mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.imgview1.mas_right).offset(5);
            make.top.equalTo(self.contentL.mas_bottom).offset(8);
            make.size.mas_equalTo(CGSizeMake((kScreenWidth - 40)/3, (kScreenWidth - 40)/3));
        }];
        [self.imgview3 mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.imgview2.mas_right).offset(5);
            make.top.equalTo(self.contentL.mas_bottom).offset(8);
            make.size.mas_equalTo(CGSizeMake((kScreenWidth - 40)/3, (kScreenWidth - 40)/3));
        }];
        
        [self.imgview1 sd_setImageWithURL:[NSURL URLWithString:imgarr[0]] placeholderImage:kPlaceHolderImg];
        [self.imgview2 sd_setImageWithURL:[NSURL URLWithString:imgarr[1]] placeholderImage:kPlaceHolderImg];
        [self.imgview3 sd_setImageWithURL:[NSURL URLWithString:imgarr[2]] placeholderImage:kPlaceHolderImg];
    } else if (imgarr.count == 2) {
            
        self.imgview1.hidden = NO;
        self.imgview2.hidden = NO;
        self.imgview3.hidden = YES;
        [self.imgview1 mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.contentView.mas_left).offset(15);
            make.top.equalTo(self.contentL.mas_bottom).offset(8);
            make.size.mas_equalTo(CGSizeMake((kScreenWidth - 35)/2, (kScreenWidth - 35)/2));
        }];
        [self.imgview2 mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.imgview1.mas_right).offset(5);
            make.top.equalTo(self.contentL.mas_bottom).offset(8);
            make.size.mas_equalTo(CGSizeMake((kScreenWidth - 35)/2, (kScreenWidth - 35)/2));
        }];
        [self.imgview1 sd_setImageWithURL:[NSURL URLWithString:imgarr[0]] placeholderImage:kPlaceHolderImg];
        [self.imgview2 sd_setImageWithURL:[NSURL URLWithString:imgarr[1]] placeholderImage:kPlaceHolderImg];
    } else {
        self.imgview1.hidden = NO;
        self.imgview2.hidden = YES;
        self.imgview3.hidden = YES;
        [self.imgview1 mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.contentView.mas_left).offset(15);
            make.top.equalTo(self.contentL.mas_bottom).offset(8);
            make.size.mas_equalTo(CGSizeMake(kScreenWidth - 30, (kScreenWidth - 30)*180/345));
        }];
        [self.imgview1 sd_setImageWithURL:[NSURL URLWithString:imgarr[0]] placeholderImage:kPlaceHolderImg];
    }
}

- (void)refuseBtnClick {
    
}

- (void)passBtnClick {
    
}
@end
