//
//  JLFactoryUtil.m
//  BuildingComApp
//
//  Created by Jiangl on 2021/12/13.
//

#import "JLFactoryUtil.h"

@implementation JLFactoryUtil
+ (UIView *)view {
    UIView *view = [UIView new];
    view.backgroundColor = [UIColor whiteColor];
    return view;
}


+ (UIButton *)buttonWithTitle:(NSString *)title font:(UIFont *)font textColor:(UIColor *)color {
    UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
    [button setTitleColor:color forState:UIControlStateNormal];
    [button setTitle:title forState:UIControlStateNormal];
    button.titleLabel.font = font;
    return button;
}

+ (UIButton *)buttonWithTitle:(NSString *)title font:(UIFont *)font textColor:(nonnull UIColor *)color image:(nonnull NSString *)imgname {
    UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
    [button setTitleColor:color forState:UIControlStateNormal];
    [button setTitle:title forState:UIControlStateNormal];
    button.titleLabel.font = font;
    [button setImage:[UIImage imageNamed:imgname] forState:0];
    return button;
}

+ (UIButton *)buttonWithImage:(NSString *)imgname {
    UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
    [button setImage:[UIImage imageNamed:imgname] forState:0];
    return button;
}

+ (UILabel *)labelWithText:(NSString *)text font:(nonnull UIFont *)font textColor:(nonnull UIColor *)color {
    UILabel *label = [[UILabel alloc] init];
    label.font = font;
    label.textColor = color;
    label.text = text;
    return label;
}

+ (UIImageView *)imageViewWithImg:(NSString *)imgname  {
    UIImageView *imgView = [[UIImageView alloc] init];
    imgView.image = [UIImage imageNamed:imgname];
//    imgView.contentMode= UIViewContentModeScaleAspectFill;
//    imgView.clipsToBounds = YES;
    return imgView;
}

+ (UIImageView *)imageView  {
    UIImageView *imgView = [[UIImageView alloc] init];
    imgView.contentMode= UIViewContentModeScaleAspectFill;
    imgView.clipsToBounds = YES;
    return imgView;
}

+ (UITextView *)textView {
    UITextView *textview = [[UITextView alloc] initWithFrame:CGRectZero];
    textview.textColor = [UIColor blackColor];
    textview.font = REGULARFONT(14);
    return textview;
}

+ (UITextField *)textFieldWithFont:(UIFont *)font place:(nonnull NSString *)place{
    UITextField *textField = [UITextField new];
    textField.font = font;
    textField.placeholder = place;
    return textField;
}


+ (UIScrollView *)scrollView {
    UIScrollView *scrollview = [[UIScrollView alloc] init];
    return scrollview;
}
@end
