//
//  MainTabbarViewController.m
//  FengShouYouXian
//
//  Created by Jiangl on 2019/11/18.
//  Copyright © 2019 姜磊. All rights reserved.
//

#import "MainTabbarViewController.h"
#import "BC_HomePageViewController.h"
#import "BC_MessageViewController.h"
#import "BC_MineViewController.h"
#import "BC_ExecuteViewController.h"
#import "BC_LoginViewController.h"
//执行者
#import "BC_ExecutorHomePageViewController.h"
#import "BC_ExecutorProjectListViewController.h"

//督导
#import "BC_SupervisorHomePageViewController.h"
#import "BC_SupervisorExecuteViewController.h"


@interface MainTabbarViewController ()<UITabBarControllerDelegate>
@property (nonatomic,strong) NSMutableArray *VCS;

@end

@implementation MainTabbarViewController

//是否自动旋转
-(BOOL)shouldAutorotate{
    return self.selectedViewController.shouldAutorotate;
}

//支持哪些屏幕方向
- (UIInterfaceOrientationMask)supportedInterfaceOrientations {
    return [self.selectedViewController supportedInterfaceOrientations];
}

//默认方向
- (UIInterfaceOrientation)preferredInterfaceOrientationForPresentation{
    return [self.selectedViewController preferredInterfaceOrientationForPresentation];
}

- (void)dealloc {
    KLog(@"maintabbar dealloc");
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    if (@available(iOS 13.0, *)) {
        // iOS 13以上
        self.tabBar.tintColor = kColorWithHex(@"#354F46");
        self.tabBar.unselectedItemTintColor = UIColor.grayColor;
    } else {
        // iOS 13以下
        UITabBarItem *item = [UITabBarItem appearance];
        item.titlePositionAdjustment = UIOffsetMake(0, -2);
        [item setTitleTextAttributes:@{NSFontAttributeName:[UIFont systemFontOfSize:10], NSForegroundColorAttributeName:UIColor.grayColor} forState:UIControlStateNormal];
        [item setTitleTextAttributes:@{NSFontAttributeName:[UIFont systemFontOfSize:10], NSForegroundColorAttributeName:kColorWithHex(@"#354F46")} forState:UIControlStateSelected];
    }
    self.delegate = self;
    [self setupTabbar];
        
}

- (void)setupTabbar {
    [self.tabBar setBackgroundImage:[[UIImage alloc]init]];
    [self.tabBar setBackgroundColor:UIColor.whiteColor];
}

#pragma mark  访客
- (void)setupGuestTab {
    _VCS = @[].mutableCopy;
    
    BC_HomePageViewController *v1 = [[BC_HomePageViewController alloc] init];
    [self setupChildViewController:v1 title:@"Home" imageName:@"home_unsel" seleceImageName:@"home_sel"];

    BC_MessageViewController *v3 = [[BC_MessageViewController alloc] init];
    [self setupChildViewController:v3 title:@"News" imageName:@"msg_unsel" seleceImageName:@"msg_sel"];

    BC_MineViewController *v4 = [[BC_MineViewController alloc] init];
    [self setupChildViewController:v4 title:@"Mine" imageName:@"mine_unsel" seleceImageName:@"mine_sel"];

    self.viewControllers = _VCS;
}

#pragma mark  专业用户
- (void)setupProfessionTab {
    _VCS = @[].mutableCopy;
    
    BC_HomePageViewController *v1 = [[BC_HomePageViewController alloc] init];
    [self setupChildViewController:v1 title:@"Home" imageName:@"home_unsel" seleceImageName:@"home_sel"];

    BC_ExecuteViewController *v2 = [[BC_ExecuteViewController alloc] init];
    [self setupChildViewController:v2 title:@"Execute" imageName:@"execute_unsel" seleceImageName:@"execute_sel"];

    BC_MessageViewController *v3 = [[BC_MessageViewController alloc] init];
    [self setupChildViewController:v3 title:@"News" imageName:@"msg_unsel" seleceImageName:@"msg_sel"];

    BC_MineViewController *v4 = [[BC_MineViewController alloc] init];
    [self setupChildViewController:v4 title:@"Mine" imageName:@"mine_unsel" seleceImageName:@"mine_sel"];

    self.viewControllers = _VCS;
}

- (void)setupExecutorTab {
    
    _VCS = @[].mutableCopy;
    BC_ExecutorHomePageViewController *v1 = [[BC_ExecutorHomePageViewController alloc] init];
    [self setupChildViewController:v1 title:@"Home" imageName:@"home_unsel" seleceImageName:@"home_sel"];

    BC_ExecutorProjectListViewController *v2 = [[BC_ExecutorProjectListViewController alloc] init];
    [self setupChildViewController:v2 title:@"Execute" imageName:@"execute_unsel" seleceImageName:@"execute_sel"];

    BC_MessageViewController *v3 = [[BC_MessageViewController alloc] init];
    [self setupChildViewController:v3 title:@"News" imageName:@"msg_unsel" seleceImageName:@"msg_sel"];

    BC_MineViewController *v4 = [[BC_MineViewController alloc] init];
    [self setupChildViewController:v4 title:@"Mine" imageName:@"mine_unsel" seleceImageName:@"mine_sel"];

    self.viewControllers = _VCS;
}

- (void)setupSupervisorTab {
    
    _VCS = @[].mutableCopy;
    BC_SupervisorHomePageViewController *v1 = [[BC_SupervisorHomePageViewController alloc] init];
    [self setupChildViewController:v1 title:@"Home" imageName:@"home_unsel" seleceImageName:@"home_sel"];

    BC_MessageViewController *v3 = [[BC_MessageViewController alloc] init];
    [self setupChildViewController:v3 title:@"News" imageName:@"msg_unsel" seleceImageName:@"msg_sel"];
    
    BC_SupervisorExecuteViewController *v2 = [[BC_SupervisorExecuteViewController alloc] init];
    [self setupChildViewController:v2 title:@"Execute" imageName:@"execute_unsel" seleceImageName:@"execute_sel"];

    self.viewControllers = _VCS;
}

- (void)setupChildViewController:(UIViewController*)controller title:(NSString *)title imageName:(NSString *)imageName seleceImageName:(NSString *)selectImageName{
    controller.title = title;
    controller.tabBarItem.title = title;//跟上面一样效果
    
    controller.tabBarItem.image = [[UIImage imageNamed:imageName] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal];
    controller.tabBarItem.selectedImage = [[UIImage imageNamed:selectImageName] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal];
    //未选中字体颜色
    [controller.tabBarItem setTitleTextAttributes:@{NSForegroundColorAttributeName:kColorWithHex(@"#AAAAAA"),NSFontAttributeName:REGULARFONT(10.0f)} forState:UIControlStateNormal];
    //选中字体颜色
    [controller.tabBarItem setTitleTextAttributes:@{NSForegroundColorAttributeName:kMainThemeColor,NSFontAttributeName:REGULARFONT(10.0f)} forState:UIControlStateSelected];
    
    //包装导航控制器
    BaseNavigationViewController *nav = [[BaseNavigationViewController alloc] initWithRootViewController:controller];
    [_VCS addObject:nav];
    
}

- (void)tabBarController:(UITabBarController *)tabBarController didSelectViewController:(UIViewController *)viewController{
    UIImpactFeedbackGenerator *feedBackGenertor = [[UIImpactFeedbackGenerator alloc] initWithStyle:UIImpactFeedbackStyleLight];
    [feedBackGenertor impactOccurred];
        
}

- (BOOL)tabBarController:(UITabBarController *)tabBarController shouldSelectViewController:(UIViewController *)viewController {
//    if ([viewController.tabBarItem.title isEqualToString:@"发布需求"] || [viewController.tabBarItem.title isEqualToString:@"消息"]) {
//
//        if (![UserManager shareManager].isLogin) {
//            BC_LoginViewController *login = [BC_LoginViewController new];
//            BaseNavigationViewController *nav = [[BaseNavigationViewController alloc] initWithRootViewController:login];
//            nav.modalPresentationStyle = UIModalPresentationFullScreen;
//            [self presentViewController:nav animated:YES completion:nil];
//            return NO;
//        }
//
//    }
    
    return YES;
}

- (UIViewController *)childViewControllerForHomeIndicatorAutoHidden {
    return self.selectedViewController;
}

- (BOOL)prefersHomeIndicatorAutoHidden {
    return NO;
}

@end
