//
//  UIView+JLCustomCorner.m
//  BaiTouWengKaiFang
//
//  Created by Jiangl on 2021/11/9.
//

#import "UIView+JLCustomCorner.h"

@implementation UIView (JLCustomCorner)
- (void)setCorner:(CGFloat)corner withType:(JLCornerType)type {
    switch (type) {
        case JLCornerTypeAllCorner:
            self.layer.cornerRadius = corner;
            self.layer.maskedCorners = kCALayerMinXMinYCorner|kCALayerMaxXMinYCorner|kCALayerMinXMaxYCorner|kCALayerMaxXMaxYCorner;
            break;
        case JLCornerTypeTopLeftAndTopRight:
            self.layer.cornerRadius = corner;
            self.layer.maskedCorners = kCALayerMinXMinYCorner|kCALayerMaxXMinYCorner;
            break;
        case JLCornerTypeBottomLeftAndBottomRight:
            self.layer.cornerRadius = corner;
            self.layer.maskedCorners = kCALayerMinXMaxYCorner|kCALayerMaxXMaxYCorner;
            break;
        case JLCornerTypeTopLeftAndBottomRight:
            self.layer.cornerRadius = corner;
            self.layer.maskedCorners = kCALayerMinXMinYCorner|kCALayerMaxXMaxYCorner;
            break;
        case JLCornerTypeTopRightAndBottomRight:
            self.layer.cornerRadius = corner;
            self.layer.maskedCorners = kCALayerMaxXMinYCorner|kCALayerMaxXMaxYCorner;
            break;
        case JLCornerTypeTopLeftAndBottomLeft:
            self.layer.cornerRadius = corner;
            self.layer.maskedCorners = kCALayerMinXMinYCorner|kCALayerMinXMaxYCorner;
            break;
            
        default:
            break;
    }
    
}
@end
