//
//  BaseFunction.h
//  YiKaoTianXia
//
//  Created by Jiangl on 2019/7/20.
//  Copyright © 2019 姜磊. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
NS_ASSUME_NONNULL_BEGIN

@interface BaseFunction : NSObject
//字典转换为json字符串
+ (NSDictionary *)dictionaryWithJsonString:(NSString *)jsonString;

//设置圆角
+(void)changeCorner:(UIView*)changeView  withRadius:(CGFloat)changeradius;

//验证手机号
+(BOOL)validatePhone:(NSString*)phone;

//矩形提示框
+(void)showAlert:(NSString *)msg;

+(void)showAlertMsg:(NSString *)msg andDelay:(NSTimeInterval)delay;

//验证密码(6-13位的英文和数字结合)
+ (BOOL)checkPassword:(NSString*)password;

+ (UIColor *)colorWithHexString:(NSString *)stringToConvert;

+ (BOOL)isValidateEmail:(NSString *)email;

+(NSString *)handleStringWithWhitespaceAndNewline:(NSString *)content;

/**字符串如果为空 ,则返回 @"" */
+ (NSString *)stringIsNull:(NSString *)string;

/**判断字符串是否为空*/
+ (BOOL)isNull:(NSString *)string;

+ (NSString *)filterHTML:(NSString *)str;

+ (NSString *)filterHTMLTag:(NSString *)str;

+ (NSString *)appendHtmlBody:(NSString *)content;

+ (UIImage *)thumbnailImageForVideo:(NSURL *)videoURL atTime:(NSTimeInterval)time;
@end

NS_ASSUME_NONNULL_END
