//
//  ZlinkPhotoBrowserView.h
//  ZlinkModulesForiOS
//
//  Created by JLei on 2018/2/11.
//  Copyright © 2018年 助力互联. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <UIImageView+YYWebImage.h>
/// Single picture's info.
@interface ZlinkPhotoGroupItem : NSObject
@property (nonatomic, strong) UIView *thumbView; ///< thumb image, used for animation position calculation
@property (nonatomic, assign) CGSize largeImageSize;
@property (nonatomic, strong) NSURL *largeImageURL;

@property (nonatomic, strong) UIImage *showimg;
@end


/// Used to show a group of images.
/// One-shot.
@interface ZlinkPhotoBrowserView : UIView
@property (nonatomic, readonly) NSArray *groupItems; ///< Array<ZlinkPhotoGroupItemPhotoGroupItem>
@property (nonatomic, assign) NSInteger currentPage;
@property (nonatomic, assign) BOOL blurEffectBackground; ///< Default is YES


- (instancetype)init UNAVAILABLE_ATTRIBUTE;
- (instancetype)initWithFrame:(CGRect)frame UNAVAILABLE_ATTRIBUTE;
+ (instancetype)new UNAVAILABLE_ATTRIBUTE;
- (instancetype)initWithGroupItems:(NSArray *)groupItems;

- (void)presentFromImageView:(UIView *)fromView
                 toContainer:(UIView *)container
                    animated:(BOOL)animated index:(NSInteger)index completion:(void (^)(void))completion;

- (void)dismissAnimated:(BOOL)animated completion:(void (^)(void))completion;
- (void)dismiss;
@end
