//
//  UserManager.h
//  YiKaoTianXia
//
//  Created by Jiangl on 2019/7/19.
//  Copyright © 2019 姜磊. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BaseUserModel.h"

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSInteger, UserLoginType) {
    kUserLoginTypeUnKnow = 0,//未知
    kUserLoginTypeWeChat,//微信登录
//    kUserLoginTypeQQ,///QQ登录
    kUserLoginTypeSina,//微博登录
    kUserLoginTypePwd,///账号登录
};

typedef void(^LoginBlock)(BOOL success, NSString *desc);

@interface UserManager : NSObject
@property (nonatomic, assign) BOOL isLogin;
@property (nonatomic, copy) NSString *locationCity;
@property (nonatomic, copy) NSString *lon;
@property (nonatomic, copy) NSString *lat;

+(instancetype)shareManager;

//保存用户信息
- (void)saveUserInfoWithModel:(BaseUserModel *)model;

//清空用户信息
- (void)cleanUserInfo;

//获取当前用户信息
- (BaseUserModel *)getUserInfo;

//登录
- (void)login:(UserLoginType)loginType params:(NSDictionary *)params completion:(LoginBlock)completion;

//自动登录
- (void)autoLogin:(LoginBlock)completion;

//退出登录
- (void)loginOut:(LoginBlock)completion;
@end

NS_ASSUME_NONNULL_END
