//
//  UserManager.m
//  YiKaoTianXia
//
//  Created by Jiangl on 2019/7/19.
//  Copyright © 2019 姜磊. All rights reserved.
//

#import "UserManager.h"
#define KEY @"YSHUSER"

static BaseUserModel *shareModel = nil;
@implementation UserManager
//单例
+ (instancetype)shareManager {
    static UserManager *manager = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        manager = [[UserManager alloc] init];
    });
    return manager;
}

//保存用户信息
- (void)saveUserInfoWithModel:(BaseUserModel *)model {
    NSData *data = [NSKeyedArchiver archivedDataWithRootObject:model];
    [kUserDefaults setObject:data forKey:KEY];
    [kUserDefaults synchronize];
}

//清空用户信息
- (void)cleanUserInfo {
    [kUserDefaults removeObjectForKey:KEY];
    [kUserDefaults synchronize];
    shareModel = nil;
}

//获取用户信息
- (BaseUserModel *)getUserInfo {
    NSData *data = [kUserDefaults objectForKey:KEY];
    if (data != nil) {
        shareModel = [NSKeyedUnarchiver unarchiveObjectWithData:data];
    }
    return shareModel;
}

//参数登录
- (void)login:(UserLoginType)loginType params:(NSDictionary *)params completion:(LoginBlock)completion {
    
    if (loginType != kUserLoginTypePwd) {
        //第三方快捷登录
    } else {
        //使用密码登录
    }
    
}

//自动登录
- (void)autoLogin:(LoginBlock)completion {
    
}

//退出
- (void)loginOut:(LoginBlock)completion {
    
}
@end
